#include <iostream>
#include <vector>
using namespace std;
int main() {
    int n, m;
    cin>>n>>m;

    vector<vector<char>> ornament(n, vector<char>(m, '.'));

    int i = 0, j = 0, di = 1, dj = 1;
    while (true) {
        ornament[i][j] = '*';
        if (i + di < 0 || i + di >= n) {
            di = -di;
        }
        if (j + dj < 0 || j + dj >= m) {
            dj = -dj;
        }
        i += di;
        j += dj;
        if (i == n) {
            break;
        }
    }

    for (const auto &row : ornament) {
        for (char c : row) {
            cout << c;
        }
        cout << '\n';
    }

    return 0;
}

