#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    std::vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    int max_weight_box = *std::max_element(weights.begin(), weights.end());

    int other_box = (boxes[0] == boxes[1]) ? boxes[2] : boxes[1];

    int item_to_move = -1;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == max_weight_box) {
            item_to_move = i + 1;
            break;
        }
    }

    if (weights[item_to_move - 1] == max_weight_box) {
        std::cout << -1 << std::endl;
    } else {
        std::cout << item_to_move << std::endl;
    }

    return 0;
}
