#include <iostream>
#include <vector>
#include <algorithm>

long long maxUnmarkedSequence(int n, int m, std::vector<int>& a) {
    long long result = 0;

    // Sort the vector in descending order
    std::sort(a.begin(), a.end(), std::greater<int>());

    // Calculate the maximum sequence length
    for (int i = 0; i < n; ++i) {
        result += a[i] - 1;
        if (a[i] % 2 == 0) {
            result += (a[i] / 2) * (m - 1);
            break;
        } else {
            --m;
        }
    }

    return result;
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }

    long long result = maxUnmarkedSequence(n, m, a);
    std::cout << result << std::endl;

    return 0;
}
