def max_subarray_length(n, m, colors):
    max_length = 0
    remaining_colors = m + 1

    # Шукаємо максимальний підмасив з незакресленими кольорами
    for length in colors:
        if remaining_colors == 0:
            break

        if length % 2 == 1:
            max_length = max(max_length, length)
            remaining_colors -= 1
        else:
            max_length = max(max_length, length // 2)
            remaining_colors -= 2

    return max_length

# Зчитування вхідних даних
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Виведення результату
result = max_subarray_length(n, m, colors)
print(result)
