def max_unmarked_sequence(n, m, a):
    a.sort(reverse=True)
    
    def count_unmarked(length):
        count = 0
        for i in range(n):
            count += max(0, min(a[i] - 1, length) - i)
        return count
    
    left, right = 0, max(a) + n
    
    while left < right:
        mid = (left + right) // 2
        if count_unmarked(mid) >= m:
            right = mid
        else:
            left = mid + 1
    
    return left + m

# Input reading
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output result
print(max_unmarked_sequence(n, m, a))
