def select_participants(olympiad, participants):
    if olympiad == 'IOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'CEOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'EGOI':
        return sorted([p for p in participants if p[1] == 'female'], key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'EJOI':
        return sorted([p for p in participants if p[3] <= 15], key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == 'BalkOI':
        return sorted([p for p in participants if p[2] != 11], key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'JBOI':
        return sorted([p for p in participants if p[2] not in [10, 11]], key=lambda x: (-x[4], x[0]))[:4]
    return []
n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participants.append((int(participant_info[0]), participant_info[1], int(participant_info[2]), int(participant_info[3]), int(participant_info[4])))
m = int(input())
olympiads = [input() for _ in range(m)]
for olympiad in olympiads:
    selected = select_participants(olympiad, participants)
    print(olympiad)
    for participant in sorted(selected, key=lambda x: x[0]):
        print(participant[0])