def form_team(participants, olympiad, criteria):
    if olympiad not in participants:
        return []

    team_size = criteria if criteria <= len(participants[olympiad]) else len(participants[olympiad])
    return sorted(participants[olympiad][:team_size], key=lambda x: x['id'])

# Зчитування вхідних даних
n = int(input())
participants = {}

for _ in range(n):
    id, gender, grade, age, score = map(int, input().split())
    participants.setdefault('IOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})
    participants.setdefault('CEOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})
    participants.setdefault('EGOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})
    participants.setdefault('EJOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})
    participants.setdefault('BaltOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})
    participants.setdefault('BalkOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})
    participants.setdefault('JBOI', []).append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})

m = int(input())
selected_olympiads = [input().strip() for _ in range(m)]

# Формування команд для кожної олімпіади
teams = {}
for olympiad in selected_olympiads:
    if olympiad == 'IOI':
        teams[olympiad] = form_team(participants, 'IOI', 4)
    elif olympiad == 'CEOI':
        teams[olympiad] = form_team(participants, 'CEOI', 4)
    elif olympiad == 'EGOI':
        teams[olympiad] = form_team(participants, 'EGOI', 4)
    elif olympiad == 'EJOI':
        teams[olympiad] = form_team(participants, 'EJOI', 4)
    elif olympiad == 'BaltOI':
        teams[olympiad] = form_team(participants, 'BaltOI', 6)
    elif olympiad == 'BalkOI':
        teams[olympiad] = form_team(participants, 'BalkOI', 4)
    elif olympiad == 'JBOI':
        teams[olympiad] = form_team(participants, 'JBOI', 4)

# Виведення результатів
for olympiad in selected_olympiads:
    print(olympiad)
    for member in teams.get(olympiad, []):
        print(member['id'])
    print()
