import java.util.Scanner;

public class ColorCircles {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);


        int n = scanner.nextInt();
        long m = scanner.nextLong();


        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = scanner.nextLong();
        }


        long left = 1;
        long right = (long) 1e18;

        while (left < right) {
            long mid = left + (right - left) / 2;

            if (canSelectColors(a, mid, m)) {
                left = mid + 1;
            } else {
                right = mid;
            }
        }
        
        System.out.println(left - 1);
    }

    private static boolean canSelectColors(long[] a, long length, long m) {
        long cnt = 0;

        for (long ai : a) {
            cnt += ai / length;
        }

        return cnt >= m;
    }
}
