def get_max_weight(weights, t, n):
    total = 0
    max_weight = 0
    for i in range(n):
        total += weights[i]
        if t[i] == 1:
            max_weight = max(max_weight, total)
    return max_weight

def main():
    weights = list(map(int, input().split()))
    t = list(map(int, input().split()))
    n = len(weights)
    min_max_weight = float('inf')
    min_item = -1
    for i in range(n):
        weights[i], weights[t[i]-1] = weights[t[i]-1], weights[i]
        t[i], t[t[i]-1] = t[t[i]-1], t[i]
        max_weight = get_max_weight(weights, t, n)
        if max_weight < min_max_weight:
            min_max_weight = max_weight
            min_item = i + 1
        weights[i], weights[t[i]-1] = weights[t[i]-1], weights[i]
        t[i], t[t[i]-1] = t[t[i]-1], t[i]
    print(min_item)

if __name__ == "__main__":
    main()