def min_max_weight(w, t):
    current_max = sum(w[i] for i in range(4) if t[i] in (1, 2))
    best_move = -1

    for i in range(4):
        if t[i] == 0:
            continue
        next_max = current_max - w[i] + (w[i] if t[i] in (1, 2) else 0)
        if next_max < current_max:
            current_max = next_max
            best_move = i + 1

    return best_move

# Input
w = [5, 2, 4, 3]
t = [1, 2, 2, 1]

# Output
print(min_max_weight(w, t))