def find_item_to_move(weights, boxes):
    current_weights = [0, 0]

    # Calculate the initial weights of the boxes
    for i in range(4):
        current_weights[boxes[i] - 1] += weights[i]

    # Try moving each item and find the minimum maximum weight
    min_max_weight = float('inf')
    item_to_move = -1

    for i in range(4):
        current_weights[boxes[i] - 1] -= weights[i]
        current_weights[1 - (boxes[i] - 1)] += weights[i]

        max_weight = max(current_weights)
        if max_weight < min_max_weight:
            min_max_weight = max_weight
            item_to_move = i + 1

        current_weights[1 - (boxes[i] - 1)] -= weights[i]
        current_weights[boxes[i] - 1] += weights[i]

    return item_to_move

# Example Input
weights = [4, 2, 3, 7]
boxes = [2, 1, 1, 2]

# Find the item to move
result = find_item_to_move(weights, boxes)

# Output the result
print(result)
