#include <iostream>
#include <vector>

using namespace std;

int main() {
  vector<int> weights = {5, 2, 4, 3};
  vector<int> boxes = {1, 2, 2, 1};

  int box1Weight = 0;
  int box2Weight = 0;

  for (int i = 0; i < 4; i++) {
    if (boxes[i] == 1) {
      box1Weight += weights[i];
    } else {
      box2Weight += weights[i];
    }
  }

  int maxWeight = max(box1Weight, box2Weight);

  int itemToMove = -1;
  for (int i = 0; i < 4; i++) {
    if (boxes[i] == 1 && box2Weight - weights[i] < maxWeight) {
      itemToMove = i + 1;
      break;
    } else if (boxes[i] == 2 && box1Weight - weights[i] < maxWeight) {
      itemToMove = i + 1;
      break;
    }
  }

  if (itemToMove == -1) {
    cout << -1 << endl;
  } else {
    cout << itemToMove << endl;
  }

  return 0;
}
