def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][0] = 'x'
        ornament[i][-1] = 'x'

    for i in range(1, min(n, m) - 1):
        ornament[i][i] = 'x'
        ornament[i][-i - 1] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Input
n, m = map(int, input().split())

# Generate and print the ornament
ornament = create_ornament(n, m)
print_ornament(ornament)
