#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; i++) {
        cin >> sizes[i];
    }

    vector<vector<int>> tShirts(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> tShirts[i][j];
        }
    }

    int k;
    cin >> k;

    vector<pair<int, string>> winners(k);
    for (int i = 0; i < k; i++) {
        cin >> winners[i].first >> winners[i].second;
    }

    vector<vector<int>> remainingTShirts(n, vector<int>(m, 0));
    vector<vector<int>> orderedTShirts(n, vector<int>(m, 0));

    for (int i = 0; i < k; i++) {
        int color = winners[i].first - 1;
        string size = winners[i].second;

        bool found = false;

        for (int j = 0; j < m; j++) {
            if (sizes[j] == size && tShirts[color][j] > 0) {
                tShirts[color][j]--;
                found = true;
                break;
            }
        }

        if (!found) {
            for (int j = 0; j < m; j++) {
                if (tShirts[color][j] > 0) {
                    tShirts[color][j]--;
                    orderedTShirts[color][j]++;
                    found = true;
                    break;
                }
            }
        }

        if (!found) {
            for (int j = 0; j < m; j++) {
                for (int s = color + 1; s < n; s++) {
                    if (tShirts[s][j] > 0) {
                        tShirts[s][j]--;
                        orderedTShirts[s][j]++;
                        found = true;
                        break;
                    }
                }
                if (found) {
                    break;
                }
            }
        }

        if (!found) {
            orderedTShirts[color][sizes.size() - 1]++;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << tShirts[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << orderedTShirts[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
