# number of participants
n = int(input())

# dictionary to store participant information
participants = {}

# dictionary to store top participants for each Olympiad
top_participants = {}

# read participant data
for i in range(n):
    data = input().split()
    participants[data[0]] = {"id": data[0], "gender": data[1], "grade": int(data[2]), "age": int(data[3]), "score": int(data[4])}

# number of Olympiads
m = int(input())

# list of Olympiads
olympiads = []

# read Olympiad data
for i in range(m):
    olympiad = input()
    olympiads.append(olympiad)

# sort participants by score in descending order
sorted_participants = sorted(participants.values(), key=lambda x: x["score"], reverse=True)

# get top participants for each Olympiad
for olympiad in olympiads:
    top_participants[olympiad] = []
    for participant in sorted_participants:
        if participant["grade"] >= 10 or (olympiad == "EGOI" and participant["gender"] == "female"):
            top_participants[olympiad].append(participant["id"])
            if len(top_participants[olympiad]) == 5:
                break

# output results
for olympiad in olympiads:
    print(olympiad, ' '.join(str(id) for id in top_participants[olympiad]))