def max_unmarked_sequence_length(n, m, colors):
    try:
        max_lengths = []

        for wheel_colors in colors:
            max_lengths.append(wheel_colors - 1)

        max_lengths.sort(reverse=True)

        result = max_lengths[0]

        for i in range(1, min(n, m)):
            max_lengths[i] = max_lengths[i - 1] - 2

            result = max(result, max_lengths[i])

        return result

    except Exception as e:
        print(f"An error occurred: {e}")


# Input processing
try:
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    # Output the result
    print(max_unmarked_sequence_length(n, m, colors))

except ValueError:
    print("Invalid input. Please enter valid integers.")
except Exception as e:
    print(f"An error occurred: {e}")
