def max_unpainted_segment(n, m, colors):
    max_length = 0
    total_unpainted = sum(colors)
    if total_unpainted <= m:
        return total_unpainted - 1
    
    left, right = 0, sum(colors)
    while left <= right:
        mid = (left + right) // 2
        count = 0
        for c in colors:
            count += min(c, mid)
        if count <= m:
            max_length = max(max_length, mid)
            left = mid + 1
        else:
            right = mid - 1
    return max_length

n, m = map(int, input().split())
colors = list(map(int, input().split()))

result = max_unpainted_segment(n, m, colors)
print(result)
