def determine_team(olympiad, participants):
    if olympiad == 'IOI' or olympiad == 'CEOI' or olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(len(participants), 6 if olympiad == 'BaltOI' else 4)]
    elif olympiad == 'EGOI':
        return sorted([p for p in participants if p[1] == 'female'], key=lambda x: (-x[4], x[0]))[:min(len(participants), 4)]
    elif olympiad == 'EJOI':
        return sorted([p for p in participants if p[3] <= 15], key=lambda x: (-x[4], x[0]))[:min(len(participants), 4)]
    elif olympiad == 'BalkOI':
        return sorted([p for p in participants if p[2] != 11], key=lambda x: (-x[4], x[0]))[:min(len(participants), 4)]
    elif olympiad == 'JBOI':
        return sorted([p for p in participants if p[2] != 11 and p[2] != 10], key=lambda x: (-x[4], x[0]))[:min(len(participants), 4)]
    else:
        return []

n = int(input())
participants = []

for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append((int(id), gender, int(grade), int(age), int(score)))

m = int(input())
olympiads = []

for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)

for olympiad in olympiads:
    team = determine_team(olympiad, participants)
    print(olympiad)
    for participant in sorted(team):
        print(participant[0])