def максимальна_кількість_проходів(n: int, m: int) -> int:
    """Знаходження максимальної кількості проходів робота.

    Args:
        n (int): Кількість рядків.
        m (int): Кількість стовпців.

    Returns:
        int: Максимальна кількість проходів.
    """
    return min(n, m)

if __name__ == "__main__":
    # Зчитуємо введені дані
    рядки = int(input("Введіть кількість рядків: "))
    стовпці = int(input("Введіть кількість стовпців: "))

    # Знаходимо та виводимо результат
    результат = максимальна_кількість_проходів(рядки, стовпці)
    print(f"Максимальна кількість проходів робота: {результат}")
