#include <iostream>
#include <vector>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    int boxWeights[3] = {0};
    for (int i = 0; i < 4; ++i) {
        boxWeights[boxes[i] - 1] += weights[i];
    }
    for (int i = 0; i < 4; ++i) {
        int currentBox = boxes[i] - 1;
        int newBox = 3 - currentBox;

        boxWeights[currentBox] -= weights[i];
        boxWeights[newBox] += weights[i];

        if (std::max(boxWeights[0], std::max(boxWeights[1], boxWeights[2])) <=
            std::max(boxWeights[newBox], std::max(boxWeights[currentBox], boxWeights[3 - currentBox]))) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
        boxWeights[currentBox] += weights[i];
        boxWeights[newBox] -= weights[i];
    }
    std::cout << -1 << std::endl;

    return 0;
}