def solve():
    w = list(map(int, input().split()))
    t = list(map(int, input().split()))

    box1 = [(w[i], i + 1) for i in range(4) if t[i] == 1]
    box2 = [(w[i], i + 1) for i in range(4) if t[i] == 2]

    total_box1 = sum(item[0] for item in box1)
    total_box2 = sum(item[0] for item in box2)

    if total_box1 < total_box2:
        box1, box2, total_box1, total_box2 = box2, box1, total_box2, total_box1

    min_diff = float('inf')
    item_to_move = -1
    for item in box1:
        new_diff = abs((total_box1 - item[0]) - (total_box2 + item[0]))
        if new_diff < min_diff:
            min_diff = new_diff
            item_to_move = item[1]

    if item_to_move == -1 or min_diff >= abs(total_box1 - total_box2):
        print(-1)
    else:
        print(item_to_move)

solve()