def teams(parts, olymp):
    if olymp == 'IOI':
        return sorted(parts, key=lambda x: (-x[4], x[0]))[:4]
    elif olymp == 'CEOI':
        return sorted(parts, key=lambda x: (-x[4], x[0]))[:4]
    elif olymp == 'EGOI':
        female = []
        for part in parts:
            if part[1] == 'female':
                female.append(part)
        return sorted(female, key=lambda x: (-x[4], x[0]))[:4]
    elif olymp == 'EJOI':
        under_15 = []
        for part in parts:
            if part[3] <= 15:
                under_15.append(part)
        return sorted(under_15, key=lambda x: (-x[4], x[0]))[:4]
    elif olymp == 'BaltOI':
        return sorted(parts, key=lambda x: (-x[4], x[0]))[:6]
    elif olymp == 'BalkOI':
        not_11_grade = []
        for part in parts:
            if part[2] != 11:
                not_11_grade.append(part)
        return sorted(not_11_grade, key=lambda x: (-x[4], x[0]))[:4]
    elif olymp == 'JBOI':
        not_11_10_grade = []
        for part in parts:
            if part[2] != 10 and part[2] != 11:
                not_11_10_grade.append(part)
        return sorted(not_11_10_grade, key=lambda x: (-x[4], x[0]))[:4]
    else:
        return []

n = int(input())
parts = []
for i in range(n):
    part_info = list(input().split())
    parts.append(part_info)

m = int(input())
olymps = [input() for i in range(m)]

for olymp in olymps:
    team = teams(parts, olymp)
    print(olymp)
    for part in team:
        print(part[0])

