#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<int> weights(4);
    vector<int> boxes(4);
    
    // Зчитування вхідних даних
    for (int i = 0; i < 4; i++) {
        cin >> weights[i];
    }
    
    for (int i = 0; i < 4; i++) {
        cin >> boxes[i];
    }
    
    // Обчислення ваг коробок
    int weightBox1 = 0;
    int weightBox2 = 0;
    
    for (int i = 0; i < 4; i++) {
        if (boxes[i] == 1) {
            weightBox1 += weights[i];
        } else {
            weightBox2 += weights[i];
        }
    }
    
    // Перебір варіантів переміщення речей
    int minMaxWeight = max(weightBox1, weightBox2);
    int itemToMove = -1;
    
    for (int i = 0; i < 4; i++) {
        int newWeightBox1 = weightBox1;
        int newWeightBox2 = weightBox2;
        
        if (boxes[i] == 1) {
            newWeightBox1 -= weights[i];
            newWeightBox2 += weights[i];
        } else {
            newWeightBox1 += weights[i];
            newWeightBox2 -= weights[i];
        }
        
        int maxWeight = max(newWeightBox1, newWeightBox2);
        
        if (maxWeight < minMaxWeight) {
            minMaxWeight = maxWeight;
            itemToMove = i + 1;
        }
    }
    
    // Виведення результату
    cout << itemToMove << endl;
    
    return 0;
}
