import java.util.Scanner;
import java.util.ArrayList;
import java.util.List;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt(); //количество цветов
        int m = in.nextInt(); //количество размеров

        List<String> sizes = new ArrayList<>();
        for (int size = 0; size < m; size++) {
            sizes.add(in.next());
        }

        int[][] items = new int[m][n];
        for (int color = 0; color < n; color++) {
            for (int size = 0; size < m; size++) {
                items[size][color] = in.nextInt();
            }
        }

        int k = in.nextInt(); //количество получателей

        for (int receiver = 0; receiver < k; receiver++) {
            int thisColor = in.nextInt() - 1;
            //System.out.print(thisColor);
            String thisSizesName = in.next();
            int thisSize = 0;
            for (int size = 0; size < m; size++) {
                if (thisSizesName.equals(sizes.get(size))) {
                    thisSize = sizes.indexOf(thisSizesName);
                }
            }
            //System.out.print(thisSize);

            items[thisSize][thisColor]--;
            if (items[thisSize][thisColor] < 0) {
                boolean itemIsFound = false;
                for (int newColor = 0; newColor < n; newColor++) {
                    if (items[thisSize][newColor] > 0) {
                        items[thisSize][newColor]--;
                        itemIsFound = true;
                        break;
                    }
                }

                if (!itemIsFound) {
                    for (int newSize = thisSize + 1; newSize < m; newSize++) {
                        if (items[newSize][thisColor] > 0) {
                            items[newSize][thisColor]--;
                            itemIsFound = true;
                            break;
                        }

                        for (int newColor = 0; newColor < n; newColor++) {
                            if (items[newSize][newColor] > 0) {
                                items[newSize][newColor]--;
                                itemIsFound = true;
                                break;
                            }
                        }
                    }
                }

                if (itemIsFound) {
                    items[thisSize][thisColor]++;
                }
            }

            for (int color = 0; color < n; color++) {
                for (int size = 0; size < m; size++) {
                    System.out.print(items[size][color]);
                }
                System.out.print("\n");
            }
        }
        /*for (int color = 0; color < n; color++) {
            for (int size = 0; size < m; size++) {
                if (items[size][color] < 0) {
                    System.out.print("0");
                } else {
                    System.out.print(items[size][color]);
                }
            }
            System.out.print("\n");
        }

        for (int color = 0; color < n; color++) {
            for (int size = 0; size < m; size++) {
                if (items[size][color] < 0) {
                    System.out.print(items[size][color] * -1);
                } else {
                    System.out.print(0);
                }

            }
            System.out.print("\n");
        }*/


    }
}
