# Зчитуємо вхідні дані
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Обчислюємо суми ваг речей в кожній коробці
sum_box_1 = sum(weights[i] for i in range(4) if boxes[i] == 1)
sum_box_2 = sum(weights[i] for i in range(4) if boxes[i] == 2)

# Знаходимо різницю між вагами коробок
weight_difference = abs(sum_box_1 - sum_box_2)

# Шукаємо річ, яку потрібно перемістити, щоб зменшити різницю ваг
for i in range(4):
    for j in range(1, 3):
        if boxes[i] != j:
            new_sum_box_1 = sum_box_1 - weights[i] * (boxes[i] == 1) + weights[i] * (j == 1)
            new_sum_box_2 = sum_box_2 - weights[i] * (boxes[i] == 2) + weights[i] * (j == 2)
            new_weight_difference = abs(new_sum_box_1 - new_sum_box_2)
            
            # Перевіряємо, чи переміщення робить коробки більш збалансованими
            if new_weight_difference < weight_difference:
                print(i + 1)  # Виводимо номер речі, яку потрібно перемістити
                exit()

# Якщо жодне переміщення не полегшує ситуацію, виводимо -1
print(-1)
