n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Початкова довжина підвідрізку
initial_length = sum(colors)

# Максимальна довжина підвідрізку перед вибором (m+n)-го колору
max_length = initial_length - m

# Закреслені кольори (початково жоден не закреслений)
marked_colors = set()

# Цикл для вибору кольорів
for _ in range(m):
    # Знайти незакреслений найбільший підвідрізок
    longest_subsegment = max(colors, key=lambda x: (x not in marked_colors, -x))

    # Додати колір до закреслених
    marked_colors.add(longest_subsegment)

    # Оновити довжину підвідрізку
    max_length = max(max_length, initial_length - len(marked_colors))

print(max_length)
