using System;

class Program
{
    static void Main()
    {
        // Зчитуємо кількість кольорових кіл та кількість кольорів, які Міс М хоче ще взяти
        string[] input1 = Console.ReadLine().Split();
        int n = int.Parse(input1[0]);
        long m = long.Parse(input1[1]);

        // Зчитуємо кількість кольорів у кожному кольоровому колі
        int[] a = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);

        // Виводимо результат
        ChooseColors(n, m, a);
    }

    static void ChooseColors(int n, long m, int[] a)
    {
        // Знаходимо максимальний неперервний підвідрізок
        long maxSubarray = 0;
        long currentSubarray = 0;
        for (int i = 0; i < n; i++)
        {
            currentSubarray += a[i];
            if (currentSubarray < 0)
            {
                currentSubarray = 0;
            }
            maxSubarray = Math.Max(maxSubarray, currentSubarray);
        }

        // Знаходимо середню точку підвідрізку
        long middle = maxSubarray % 2 == 0 ? maxSubarray / 2 : maxSubarray / 2 + 1;

        // Виводимо результат
        Console.WriteLine($"{middle} {m}");
    }
}
