using System;

class Solution {
  public static void Main(string[] args) {
      int[] weights = Array.ConvertAll(Console.ReadLine().Split(' '), int.Parse);
      int[] boxes = Array.ConvertAll(Console.ReadLine().Split(' '), int.Parse);
      int[] boxWeights = new int[3];
      for (int i = 0; i < 4; i++) {
          boxWeights[boxes[i]] += weights[i];
      }
      int maxBoxWeight = Math.Max(boxWeights[1], boxWeights[2]);
      int itemToMove = -1;
      for (int i = 0; i < 4; i++) {
          int otherBox = 3 - boxes[i];
          if (boxWeights[boxes[i]] - weights[i] + weights[i] <= maxBoxWeight && boxWeights[otherBox] + weights[i] <= maxBoxWeight) {
              maxBoxWeight = Math.Max(boxWeights[boxes[i]] - weights[i] + weights[i], boxWeights[otherBox] + weights[i]);
              itemToMove = i + 1;
          }
      }
      Console.WriteLine(itemToMove);
  }
}
