using System;
using System.Linq;

public class Program
{
    public static void Main()
    {
        int[] weights = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int[] boxes = Console.ReadLine().Split().Select(int.Parse).ToArray();

        int[] box1 = weights.Where((x, i) => boxes[i] == 1).ToArray();
        int[] box2 = weights.Where((x, i) => boxes[i] == 2).ToArray();

        int minMaxWeight = Math.Max(box1.Sum(), box2.Sum());
        int itemToMove = -1;

        for (int i = 0; i < 4; i++)
        {
            if (boxes[i] == 1)
            {
                int newWeight1 = box1.Sum() - weights[i];
                int newWeight2 = box2.Sum() + weights[i];
                if (Math.Max(newWeight1, newWeight2) < minMaxWeight)
                {
                    minMaxWeight = Math.Max(newWeight1, newWeight2);
                    itemToMove = i + 1;
                }
            }
            else
            {
                int newWeight1 = box1.Sum() + weights[i];
                int newWeight2 = box2.Sum() - weights[i];
                if (Math.Max(newWeight1, newWeight2) < minMaxWeight)
                {
                    minMaxWeight = Math.Max(newWeight1, newWeight2);
                    itemToMove = i + 1;
                }
            }
        }

        Console.WriteLine(itemToMove);
    }
}
