function createPattern(n, m) {
    let pattern = [];
    for (let i = 0; i < n; i++) {
        pattern[i] = [];
        for (let j = 0; j < m; j++) {
            if ((i + j) % 4 === 0 || (i - j) % 4 === 0) {
                pattern[i][j] = 'x';
            } else {
                pattern[i][j] = '.';
            }
        }
    }
    return pattern;
}

function printPattern(pattern) {
    for (let row of pattern) {
        console.log(row.join(''));
    }
}

// Tesztesetek
let testCases = [
    [6, 4],
    [12, 5],
    [21, 12]
];

for (let i = 0; i < testCases.length; i++) {
    let [n, m] = testCases[i];
    console.log(`Answer #${i+1}`);
    let pattern = createPattern(n, m);
    printPattern(pattern);
    console.log();
}
