def max_unmarked_sequence(n, m, a):
    max_length = 0
    if m >= sum(a):
        return max(a)
    l = 0
    for i in range(n):
        l = max(l, a[i])
    r = sum(a)
    while l <= r:
        mid = (l + r) // 2
        count = 0
        for i in range(n):
            count += min(a[i], mid)
        if count >= m:
            max_length = mid
            l = mid + 1
        else:
            r = mid - 1
    return max_length

# Reading input values
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the maximum length of the sequence of unmarked colors
result = max_unmarked_sequence(n, m, a)
print(result)