n, m = map(int, input().split())
a = list(map(int, input().split()))

# Function to find the maximum value in the list
def max_value(arr):
    max_val = 0
    idx = -1
    for i, val in enumerate(arr):
        if val > max_val:
            max_val = val
            idx = i
    return idx

# Function to update the list after choosing a color
def update_arr(arr, idx):
    arr[idx] -= 1
    left = idx - 1
    right = idx + 1
    while arr[idx] > 0 and (left >= 0 or right < len(arr)):
        if left >= 0 and arr[left] > 0:
            arr[left] -= 1
            left -= 1
        elif right < len(arr) and arr[right] > 0:
            arr[right] -= 1
            right += 1
        else:
            break

# Find the maximum length of the sequence of unmarked colors
remaining = sum(a)
max_length = max(a)
while m > 0:
    idx = max_value(a)
    if a[idx] % 2 == 0:
        update_arr(a, idx)
        m -= 1
        remaining -= 1
    else:
        remaining -= (a[idx] // 2) + 1
        break

print(remaining)
