def get_max_sequence_length(n, m, a):
    max_lengths = [(x + 1) // 2 for x in a]
    max_lengths.sort(reverse=True)

    def update_max_lengths():
        nonlocal max_lengths
        max_lengths[0] -= 1
        if max_lengths[0] % 2 == 0:
            max_lengths.append(max_lengths.pop(0) // 2)
            max_lengths.append(max_lengths[0])
        else:
            max_lengths.append(max_lengths.pop(0) // 2)
        max_lengths.sort(reverse=True)

    result = 0
    while m > 0:
        update_max_lengths()
        result = max(result, max_lengths[0])
        m -= 1

    return result

# Input parsing
n, m = map(int, input().split())
a = list(map(int, input().split()))

print(get_max_sequence_length(n, m, a))
