def max_unmarked_length(a, m):
    a.sort(reverse=True)  # Sort the color wheels in descending order
    l = a[0] - 1  # Initial longest sequence of unmarked colors
    for i in range(1, n):
        l = min(l, a[i] - 1)  # Update longest sequence based on color wheels

    remaining = m - n  # Remaining colors to select after initial colors
    if remaining <= 0:
        return max(l, 0)

    for i in range(n):
        if a[i] - 1 > l:
            remaining -= (a[i] - 1 - l)

    if remaining <= 0:
        return max(l, 0)

    return l - ((remaining + n - 1) // n)
