def max_flower_pickups(n, m):
   
    dp = [[0] * m for _ in range(n)]
    dp[0][0] = 1

    for i in range(n):
        for j in range(m):
            if i > 0:
                dp[i][j] += dp[i-1][j]
            if j > 0:
                dp[i][j] += dp[i][j-1]

    return dp[n-1][m-1]

n = int(input())
m = int(input())
result = max_flower_pickups(n, m)
print(result)