def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m // 2)):
        ornament[i][i] = 'x'
        ornament[i][m - i - 1] = 'x'

    if n > 1:
        ornament[1][m // 2] = 'x'
        ornament[0][m // 2] = '.'

    return ornament

# Зчитуємо висоту та ширину вишиванки
n, m = map(int, input().split())

# Створюємо та виводимо орнамент
ornament = create_ornament(n, m)

for row in ornament:
    print(''.join(row))
    