def create_teams(participants, olympiad, team_size):
    participants.sort(key=lambda x: (-x[4], x[0]))

    teams = []

    if olympiad == 'IOI':
        teams = participants[:team_size]
    elif olympiad == 'EGOI':
        teams = [p for p in participants if p[1] == 'female'][:team_size]
    elif olympiad == 'BaltOI':
        teams = participants[:team_size]

    return [p[0] for p in teams]

n = int(input())
participants = [list(map(lambda x: int(x) if x.isdigit() else x, input().split())) for _ in range(n)]

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    teams = create_teams(participants, olympiad, 4)
    print(f"{olympiad}\n{' '.join(map(str, sorted(teams)))}")