def max_color_subsequence_length(n, m, shades):
    max_length = 0

    for i in range(n):
        for j in range(i + 1, n + 1):
            remaining_colors = m + min(i, n - j)
            if remaining_colors % 2 == 0:
                max_length = max(max_length, j - i)

    return max_length


n, m = map(int, input().split())
shades = list(map(int, input().split()))


result = max_color_subsequence_length(n, m, shades)
print(result)