using System;
using System.Linq;

class Program
{
    static void Main()
    {
        int[] input = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int n = input[0];
        long m = input[1];

        long[] a = Console.ReadLine().Split().Select(long.Parse).ToArray();

        long maxSubsegmentLength = 0;

        for (int i = 0; i < n; i++)
        {
            long segmentLength = a[i];
            if (i > 0)
            {
                segmentLength *= a[i] - a[i - 1] - 1;
            }

            maxSubsegmentLength = Math.Max(maxSubsegmentLength, segmentLength);
        }

        Console.WriteLine(maxSubsegmentLength);
    }
}
