def find_item_to_move(weights, boxes):
    total_weight_box1 = sum(w for w, t in zip(weights, boxes) if t == 1)
    total_weight_box2 = sum(w for w, t in zip(weights, boxes) if t == 2)

    for i in range(4):
        if boxes[i] == 1:
            weight_contributed = total_weight_box1 - weights[i] + weights[i]
            if weight_contributed <= total_weight_box2:
                return i + 1

        if boxes[i] == 2:
            weight_contributed = total_weight_box2 - weights[i] + weights[i]
            if weight_contributed <= total_weight_box1:
                return i + 1

    return -1


weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

max_weight_box = boxes[weights.index(max(weights))]
min_weight_box = boxes[weights.index(min(weights))]

if max_weight_box == min_weight_box:
    print(-1)
else:
    item_to_move = weights.index(max(weights)) + 1
    print(item_to_move)