n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participant = {
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    }
    participants.append(participant)

m = int(input())
olympiads = []
for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)


def determine_team(olympiad, participants):
    team = []
    if olympiad == 'IOI' or olympiad == 'CEOI':
        participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in participants[:4]]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p['gender'] == 'female']
        female_participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in female_participants[:4]]
    elif olympiad == 'EJOI':
        under_15_participants = [p for p in participants if p['age'] <= 15]
        under_15_participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in under_15_participants[:4]]
    elif olympiad == 'BaltOI':
        participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in participants[:6]]
    elif olympiad == 'BalkOI':
        non_11th_grade_participants = [p for p in participants if p['grade'] != 11]
        non_11th_grade_participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in non_11th_grade_participants[:4]]
    elif olympiad == 'JBOI':
        non_11th_10th_grade_participants = [p for p in participants if p['grade'] not in [10, 11]]
        non_11th_10th_grade_participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in non_11th_10th_grade_participants[:4]]
    return team


for olympiad in olympiads:
    team = determine_team(olympiad, participants)
    print(olympiad)
    for participant_id in sorted(team):
        print(participant_id)