#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    
    vector<int> a_values(n);
    for (int i = 0; i < n; ++i) {
        cin >> a_values[i];
    }


    sort(a_values.rbegin(), a_values.rend());


    long long max_length = 0;

    for (int i = 0; i < n; ++i) {
        int max_a = a_values[i];


        int remaining_m = m;
        int cycles = remaining_m / max_a;
        max_length += static_cast<long long>(max_a) * cycles;


        int remaining_unmarked = remaining_m % max_a;

 
        if (remaining_unmarked > 0) {
            max_length += min(remaining_unmarked, max_a - 1);
        }


        m -= max_a;
    }

    cout << max_length << endl;

    return 0;
}
