def create_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if (i + j) % (m-1) == 0 or (i - j) % (m-1) == 0:
                pattern[i][j] = 'x'

    for row in pattern:
        print(''.join(row))

n, m = map(int, input().split())

create_pattern(n, m)
