#include <bits/stdc++.h>
using namespace std;
struct Participant {
	int id;
	string gender;
	int grade;
	int age;
	int score;
};
bool compareParticipants(const Participant& p1, const Participant& p2) {
	return p1.score > p2.score;
}
int main() {
	ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
	int n;
	cin >> n;
	vector <Participant> participants(n);
	for (int i = 0; i < n; ++i) {
		cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
	}
	sort(participants.begin(), participants.end(), compareParticipants);
	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		string olympiad;
		cin >> olympiad;
		vector <int> selectedParticipants;
		if (olympiad == "IOI" || olympiad == "CEOI") {
			for (int j = 0; j < 4 && j < n; ++j) {
				selectedParticipants.push_back(participants[j].id);
			}
		} else if (olympiad == "EGOI") {
			int count = 0;
			for (const Participant& participant : participants) {
				if (participant.gender == "female" && count < 4) {
					selectedParticipants.push_back(participant.id);
					++count;
				}
			}
		} else if (olympiad == "EJOI") {
			int count = 0;
			for (const Participant& participant : participants) {
				if (participant.age <= 15 && count < 4) {
					selectedParticipants.push_back(participant.id);
					++count;
				}
			}
		} else if (olympiad == "BaltOI") {
			for (int j = 0; j < 6 && j < n; ++j) {
				selectedParticipants.push_back(participants[j].id);
			}
		} else if (olympiad == "BalkOI") {
			int count = 0;
			for (const Participant& participant : participants) {
				if (participant.grade != 11 && count < 4) {
					selectedParticipants.push_back(participant.id);
					++count;
				}
			}
		} else if (olympiad == "JBOI") {
			int count = 0;
			for (const Participant& participant : participants) {
				if (participant.grade != 11 && participant.grade != 10 && count < 4) {
					selectedParticipants.push_back(participant.id);
					++count;
				}
			}
		}
		cout << olympiad << endl;
		for (int id : selectedParticipants) {
			cout << id << '\n';
		}
	}
	return 0;
}