def find_item_to_move(weights, boxes):
    box1 = [(weights[i], i+1) for i in range(len(weights)) if boxes[i] == 1]
    box2 = [(weights[i], i+1) for i in range(len(weights)) if boxes[i] == 2]
    weight_box1 = sum(item[0] for item in box1)
    weight_box2 = sum(item[0] for item in box2)
    if weight_box1 > weight_box2:
        heaviest_item_in_box1 = max(box1, key=lambda item: item[0])
        lightest_item_in_box2 = min(box2, key=lambda item: item[0]) if box2 else (0, -1)
        if heaviest_item_in_box1[0] > lightest_item_in_box2[0]:
            return heaviest_item_in_box1[1]
    elif weight_box2 > weight_box1:
        heaviest_item_in_box2 = max(box2, key=lambda item: item[0])
        lightest_item_in_box1 = min(box1, key=lambda item: item[0]) if box1 else (0, -1)
        if heaviest_item_in_box2[0] > lightest_item_in_box1[0]:
            return heaviest_item_in_box2[1]
    return -1