def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0

    max_seq = max(a)
    left, right = 1, max_seq * 2

    while left < right:
        mid = (left + right) // 2
        count = sum((x - 1) // 2 for x in a if x > mid)

        if count < m:
            left = mid + 1
        else:
            right = mid

    return left - 1

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)
