# Вхідні дані
n, m = map(int, input().split()) # висота та ширина відповідно

# Обчислення
# Створюємо матрицю n на m, заповнену крапками
matrix = [['.' for j in range(m)] for i in range(n)]

# Позначаємо початкові позиції променів
matrix[0][0] = 'X' # лівий верхній кут
matrix[0][m-1] = 'X' # правий верхній кут

# Визначаємо напрямки променів
dx = [1, 1] # зміна по вертикалі
dy = [1, -1] # зміна по горизонталі

# Визначаємо поточні позиції променів
x = [0, 0] # рядок
y = [0, m-1] # стовпець

# Переміщуємо промені, поки вони не зникнуть
while True:
    # Перевіряємо, чи є якийсь промінь на нижньому краю
    if x[0] == n-1 or x[1] == n-1:
        break # якщо так, то зупиняємо цикл
    # Інакше, переміщуємо кожен промінь на одну клітинку
    for i in range(2):
        # Змінюємо позицію променя
        x[i] += dx[i]
        y[i] += dy[i]
        # Перевіряємо, чи промінь відбився від вертикального краю
        if y[i] == 0 or y[i] == m-1:
            # Якщо так, то змінюємо напрямок по горизонталі
            dy[i] = -dy[i]
        # Позначаємо нову позицію променя
        matrix[x[i]][y[i]] = 'X'

# Вихідні дані
# Виводимо матрицю
for i in range(n):
    for j in range(m):
        print(matrix[i][j], end='')
    print()
