# Вхідні дані
n, m = map(int, input().split()) # кількість кольорових кіл та кількість кольорів, які Міс М хоче ще взяти
a = list(map(int, input().split())) # кількість кольорів на кожному колі
# Створюємо список, який зберігає поточну позицію на кожному колі
pos = [0] * n
# Створюємо список, який зберігає довжину найдовшого підвідрізку незакреслених кольорів на кожному колі
length = [a[i] - 1 for i in range(n)]
# Створюємо змінну, яка зберігає максимальну довжину підвідрізку серед усіх кіл
max_length = max(length)
# Створюємо список, який зберігає індекси кіл, які мають максимальну довжину підвідрізку
max_index = [i for i in range(n) if length[i] == max_length]
# Створюємо список, який зберігає вибрані кольори
colors = []
# Повторюємо m разів
for i in range(m):
    # Виводимо максимальну довжину підвідрізку перед вибором (m+1)-го кольору
    print(max_length)
    # Вибираємо будь-яке коло з максимальною довжиною підвідрізку
    k = max_index[0]
    # Визначаємо, який колір вибрати на цьому колі
    if length[k] % 2 == 1:
        # Якщо довжина підвідрізку непарна, то беремо колір, який рівно посередині
        color = pos[k] + length[k] // 2
    else:
        # Якщо довжина підвідрізку парна, то беремо один із двох кольорів посередині
        color = pos[k] + length[k] // 2 - 1
    # Додаємо вибраний колір до списку
    colors.append((k, color))
    # Закреслюємо вибраний колір як використаний
    pos[k] = color + 1
    length[k] -= 2
    # Оновлюємо максимальну довжину підвідрізку та індекси кіл, які її мають
    max_length = max(length)
    max_index = [i for i in range(n) if length[i] == max_length]

# Вихідні дані
# Виводимо вибрані кольори у форматі (номер кола, номер кольору)
for k, c in colors:
    print(k + 1, c + 1)
