#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int task(int m, int a, vector<int>& memo) {
    if (a <= 1) {
        return m;
    }
    if (memo[a] != -1) {
        return memo[a];
    }
    if (a % 2 == 0) {
        memo[a] = max(task(m / 2, a - 1, memo), task(m / 2, a - 2, memo));
    } else {
        memo[a] = max(task((m + 1) / 2, a - 1, memo), task(m / 2, a - 2, memo));
    }
    return memo[a];
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> memo(m + 1, -1);
    cout << task(a[0], m, memo) << endl;

    return 0;
}