#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Введення ваг речей
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    // Введення номерів коробок, у яких лежать речі
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Знайдемо ваги коробок після можливого переміщення
    int maxWeight = 0;
    int maxWeightIndex = -1;

    for (int i = 0; i < 4; ++i) {
        std::vector<int> tempWeights = weights;
        std::vector<int> tempBoxes = boxes;

        for (int j = 0; j < 4; ++j) {
            if (i != j) {
                // Переміщення речі з коробки j в коробку i
                tempWeights[boxes[j] - 1] += weights[j];
                tempWeights[i] -= weights[j];
                tempBoxes[j] = i + 1;
            }
        }

        // Знайдемо максимальну вагу коробки
        int currentMaxWeight = *std::max_element(tempWeights.begin(), tempWeights.end());

        if (currentMaxWeight < maxWeight || maxWeightIndex == -1) {
            maxWeight = currentMaxWeight;
            maxWeightIndex = i;
        }
    }

    if (maxWeightIndex != -1) {
        std::cout << maxWeightIndex + 1 << std::endl;
    } else {
        std::cout << -1 << std::endl;
    }

    return 0;
}


