#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    // Введення ваг речей та номерів коробок
    std::vector<int> weights(4), boxes(4);
    for (int i = 0; i < 4; ++i)
        std::cin >> weights[i];
    for (int i = 0; i < 4; ++i)
        std::cin >> boxes[i];

    int maxWeight = 0, maxWeightIndex = -1;

    // Перебір усіх можливих переміщень речей
    for (int i = 0; i < 4; ++i) {
        std::vector<int> tempWeights = weights, tempBoxes = boxes;

        // Переміщення речей та знаходження максимальної ваги
        for (int j = 0; j < 4; ++j) {
            if (i != j) {
                tempWeights[boxes[j] - 1] += weights[j];
                tempWeights[i] -= weights[j];
                tempBoxes[j] = i + 1;
            }
        }

        int currentMaxWeight = *std::max_element(tempWeights.begin(), tempWeights.end());

        // Запам'ятовування оптимального варіанту
        if (currentMaxWeight < maxWeight || maxWeightIndex == -1) {
            maxWeight = currentMaxWeight;
            maxWeightIndex = i;
        }
    }

    // Виведення результату
    std::cout << (maxWeightIndex != -1 ? maxWeightIndex + 1 : -1) << std::endl;

    return 0;
}
