#include <iostream>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    // Initialize the ornament pattern
    char ornament[n][m];

    // Fill the ornament pattern
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ornament[i][j] = '.';
        }
    }

    // Create the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            // Check if the cell is on the ornament's rays
            if (i == j || i + j == m - 1) {
                ornament[i][j] = '*';
            }
        }
    }

    // Output the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ornament[i][j];
        }
        cout << '\n';
    }

    return 0;
}

