#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> colors(n);
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    long long max_length = 0;
    for (int i = 0; i < m; ++i) {
        // Знаходимо найбільший незакреслений підвідрізок
        long long max_subsegment = 0;
        int idx = -1;
        for (int j = 0; j < n; ++j) {
            if (j == 0 || (j > 0 && colors[j] - colors[j - 1] > max_subsegment)) {
                max_subsegment = colors[j] - (j > 0 ? colors[j - 1] : 0);
                idx = j;
            }
        }

        // Позначаємо вибраний колір як використаний
        colors[idx] = (max_subsegment % 2 == 0) ? (colors[idx] + colors[idx - 1]) / 2 : colors[idx];

        // Оновлюємо максимальну довжину
        max_length = max(max_length, max_subsegment);
    }

    cout << max_length << endl;

    return 0;
}
