def select_participants(olympiad, participants):
    if olympiad == "IOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        females = [p for p in participants if p[1] == 'female']
        return sorted(females, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EJOI":
        juniors = [p for p in participants if p[3] <= 15]
        return sorted(juniors, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        seniors = [p for p in participants if p[3] != 11]
        return sorted(seniors, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "JBOI":
        non_10_11_graders = [p for p in participants if p[3] not in [10, 11]]
        return sorted(non_10_11_graders, key=lambda x: (-x[4], x[0]))[:4]

n = int(input())
participants = []

for _ in range(n):
    data = input().split()
    participants.append((int(data[0]), data[1], int(data[2]), int(data[3]), int(data[4])))

m = int(input())

for _ in range(m):
    olympiad = input().strip()
    selected_participants = select_participants(olympiad, participants)
    print(olympiad)
    for participant in sorted(selected_participants, key=lambda x: x[0]):
        print(participant[0])

