def max_unmarked_sequence_length(n, m, a):
    max_sequence = max(a)
    total = sum(a) - n  # Subtract n as we've already chosen one color from each wheel

    while total < m:
        max_sequence = (max_sequence + 1) // 2  # Calculate the maximum unmarked sequence length
        total += n  # Increment the total colors available considering all wheels

    return max_sequence

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_sequence_length(n, m, a)
print(result)