def max_subarray_length(n, m, a):
    prefix_sum = [0]
    for ai in a:
        prefix_sum.append(prefix_sum[-1] + ai)

    max_length = 0
    for i in range(n):
        for j in range(i, n):
            length = prefix_sum[j + 1] - prefix_sum[i]
            if length % 2 == 1:
                max_length = max(max_length, length)
    
    return max_length

# Зчитування вхідних даних
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Виведення результату
result = max_subarray_length(n, m, a)
print(result)
