#include <iostream>
using namespace std;

int main() {
    int weights[4];
    int boxes[4];

    // Input weights of each item
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }

    // Input numbers of boxes for each item
    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    // Calculate the weights of each box
    int box_weights[3] = {0};
    for (int i = 0; i < 4; ++i) {
        box_weights[boxes[i] - 1] += weights[i];
    }

    // Find the item to move for minimizing the maximum box weight
    for (int i = 0; i < 4; ++i) {
        int current_box_weight = box_weights[boxes[i] - 1];
        int other_box_weight = box_weights[3 - boxes[i]];
        if (current_box_weight - weights[i] <= other_box_weight) {
            cout << i + 1 << endl;
            return 0;
        }
    }

    // If no move is needed
    cout << -1 << endl;

    return 0;
}
