#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // Input weights of each item
    int w[4];
    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }

    // Input numbers of the boxes for each item
    int t[4];
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    // Calculate the initial weights of the boxes
    int box1Weight = w[0] * (t[0] == 1) + w[1] * (t[1] == 1);
    int box2Weight = w[2] * (t[2] == 2) + w[3] * (t[3] == 2);
    int maxWeight = max(box1Weight, box2Weight);

    // Check if it is optimal not to change anything
    if (maxWeight == max(box1Weight - w[0] + w[1], box2Weight - w[2] + w[3])) {
        cout << "-1" << endl;
    } else {
        // Check each item for possible moves
        for (int i = 0; i < 4; ++i) {
            int currentBox = t[i];
            int otherBox = (currentBox == 1) ? 2 : 1;

            int currentWeight = (currentBox == 1) ? box1Weight : box2Weight;
            int otherWeight = (currentBox == 1) ? box2Weight : box1Weight;

            // Calculate the maximum weight after moving the item
            int newCurrentWeight = currentWeight - w[i];
            int newOtherWeight = otherWeight + w[i];

            if (max(newCurrentWeight, newOtherWeight) < maxWeight) {
                cout << i + 1 << endl;  // Output the number of the item to be moved
                return 0;
            }
        }
    }

    return 0;
}
