#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    // Create an n x m matrix to represent the ornament
    vector<vector<char>> ornament(n, vector<char>(m, '.'));

    // Fill the rays
    for (int i = 0; i < n; ++i) {
        int j = 0; // Leftmost column

        while (i - j >= 0 && j < m) {
            ornament[i - j][j] = '/';
            ornament[i - j][m - 1 - j] = '\\';
            ++j;
        }
    }

    // Display the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ornament[i][j];
        }
        cout << "\n";
    }

    return 0;
}

