#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    cout<<n/10<<" "<<n%10<<"\n";
}
def organize_tshirts(n, m, participants):
    # Initialize tables for available and missing t-shirts
    available_tshirts = [[0] * m for _ in range(n)]
    missing_tshirts = [[0] * m for _ in range(n)]

    # Organize the t-shirts based on the algorithm
    for participant in participants:
        color, size = participant[0] - 1, participant[1] - 1

        if available_tshirts[color][size] > 0:
            available_tshirts[color][size] -= 1
        else:
            found = False
            for next_size in range(size + 1, m):
                if available_tshirts[color][next_size] > 0:
                    available_tshirts[color][next_size] -= 1
                    found = True
                    break

            if not found:
                for next_color in range(color + 1, n):
                    for next_size in range(m):
                        if available_tshirts[next_color][next_size] > 0:
                            available_tshirts[next_color][next_size] -= 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                missing_tshirts[color][size] += 1

    return available_tshirts, missing_tshirts

# Example usage
n = 4  # Number of colors
m = 3  # Number of sizes
participants = [
    (1, 2), (2, 3), (3, 1),
    (1, 2), (4, 2), (2, 1),
    (3, 2), (2, 3), (1, 1),
    (4, 1), (3, 3), (1, 2)
]

available, missing = organize_tshirts(n, m, participants)

# Output the results
print("Extra T-Shirts:")
for row in available:
    print(" ".join(map(str, row)))

print("\nMissing T-Shirts:")
for row in missing:
    print(" ".join(map(str, row)))
