#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    vector<bool> used(n, false);

    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    int maxLength = 0;

    while (m--) {
        int start, end;
        cin >> start >> end;

        --start;
        --end;

        int length = 0;

        for (int i = start; i <= end; ++i) {
            if (!used[i]) {
                ++length;
                used[i] = true;
            }
        }

        if (length % 2 == 1) {
            // If the length is odd, take the color in the middle
            int middle = (length + 1) / 2;
            cout << colors[start + middle - 1] << endl;
        } else {
            // If the length is even, take one of the two colors in the middle
            int middle1 = length / 2;
            int middle2 = middle1 + 1;
            cout << colors[start + middle1 - 1] << " " << colors[start + middle2 - 1] << endl;
        }

        maxLength = max(maxLength, length);
    }

    cout << maxLength << endl;

    return 0;
}
