import java.util.Scanner;

public class EmbroideryOrnament {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Введення розмірів вишиванки
        int n = scanner.nextInt();
        int m = scanner.nextInt();

        // Задаємо символи для виводу орнаменту
        char cornerChar = '+';
        char rayChar = '-';

        // Будуємо орнамент
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                // Якщо це верхній лівий або верхній правий кут, виводимо кутовий символ
                if ((i == 0 && j == 0) || (i == 0 && j == m - 1)) {
                    System.out.print(cornerChar);
                }
                // Якщо це лінія променя, виводимо променевий символ
                else if (i == 0 && (j % (m - 1)) == 0) {
                    System.out.print(rayChar);
                }
                // Якщо це останній ряд, виводимо символи променів у випадку верхнього правого та нижнього лівого кутів
                else if (i == n - 1 && (j == 0 || j == m - 1)) {
                    System.out.print(rayChar);
                }
                // В інших випадках виводимо пробіл
                else {
                    System.out.print(" ");
                }
            }
            // Перехід на новий рядок після завершення кожного рядка
            System.out.println();
        }
    }
}
