import java.util.Scanner;

public class MoveBoxes {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Зчитування ваг та номерів коробок
        int[] weights = new int[4];
        for (int i = 0; i < 4; i++) {
            weights[i] = scanner.nextInt();
        }

        int[] boxes = new int[4];
        for (int i = 0; i < 4; i++) {
            boxes[i] = scanner.nextInt();
        }

        // Знаходження рішення
        int result = findOptimalMove(weights, boxes);

        // Виведення результату
        System.out.println(result);

        // Закриваємо Scanner
        scanner.close();
    }

    private static int findOptimalMove(int[] weights, int[] boxes) {
        for (int i = 0; i < 4; i++) {
            for (int j = i + 1; j < 4; j++) {
                if (boxes[i] != boxes[j] && weights[i] != weights[j]) {
                    // Знайдено дві різні коробки з різними вагами
                    return i + 1; // Повертаємо номер речі для переміщення
                }
            }
        }

        // Якщо немає різниці між коробками чи вагами, повертаємо -1
        return -1;
    }
}