#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; i++) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < k; i++) {
        int c;
        char s;
        cin >> c >> s;

        int size_idx = find(sizes.begin(), sizes.end(), string(1, s)) - sizes.begin();

        bool found = false;

        if (available[c - 1][size_idx] > 0) {
            available[c - 1][size_idx]--;
            found = true;
        } else {
            for (int j = 0; j < n; j++) {
                if (available[j][size_idx] > 0) {
                    available[j][size_idx]--;
                    remaining[j][size_idx]++;
                    found = true;
                    break;
                }
            }

            for (int j = size_idx + 1; j < m; j++) {
                for (int l = 0; l < n; l++) {
                    if (available[l][j] > 0) {
                        available[l][j]--;
                        remaining[l][j]++;
                        found = true;
                        break;
                    }
                }
                if (found) {
                    break;
                }
            }
        }

        if (!found) {
            to_order[c - 1][size_idx]++;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << remaining[i][j] << " ";
        }
        cout << "\n";
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << to_order[i][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}
