def main():
    n, m = map(int, input().split())
    sizes = input().split()

    available = [list(map(int, input().split())) for _ in range(n)]

    k = int(input())

    remaining = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for _ in range(k):
        c, s = input().split()
        c = int(c)

        size_idx = sizes.index(s)

        found = False

        if available[c - 1][size_idx] > 0:
            available[c - 1][size_idx] -= 1
            found = True
        else:
            for j in range(n):
                if available[j][size_idx] > 0:
                    available[j][size_idx] -= 1
                    remaining[j][size_idx] += 1
                    found = True
                    break

            for j in range(size_idx + 1, m):
                for l in range(n):
                    if available[l][j] > 0:
                        available[l][j] -= 1
                        remaining[l][j] += 1
                        found = True
                        break
                if found:
                    break

        if not found:
            to_order[c - 1][size_idx] += 1

    for row in remaining:
        print(*row)

    for row in to_order:
        print(*row)


if __name__ == "__main__":
    main()
