def process_gifts(n, m, sizes, available_tshirts, k, winners):
    remaining_tshirts = [[available_tshirts[i][j] for j in range(m)] for i in range(n)]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = winners[i]
        color -= 1  # Adjust to 0-based indexing
        size_index = sizes.index(size)

        found = False
        for j in range(size_index, m):
            if remaining_tshirts[color][j] > 0:
                remaining_tshirts[color][j] -= 1
                found = True
                break

        if not found:
            for j in range(size_index + 1, m):
                for c in range(n):
                    if remaining_tshirts[c][j] > 0:
                        remaining_tshirts[c][j] -= 1
                        needed_tshirts[c][j] += 1
                        found = True
                        break
                if found:
                    break

        if not found:
            needed_tshirts[color][size_index] += 1

    return remaining_tshirts, needed_tshirts


# Input
n, m = map(int, input().split())
sizes = input().split()
available_tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())

winners = [list(map(str, input().split())) for _ in range(k)]

# Process gifts
remaining, needed = process_gifts(n, m, sizes, available_tshirts, k, winners)

# Output
for row in remaining:
    print(" ".join(map(str, row)))

for row in needed:
    print(" ".join(map(str, row)))