#include <iostream>

using namespace std;

long long maxUnselectedLength(int colors[], int n, long long m) {
    long long max_length = 0;
    long long current_length = m;

    for (int i = 0; i < n; i++) {
        long long c = colors[i];
        while (colors[i] != 0) {
            current_length = current_length - 1;
            colors[i]--;
        }

        max_length += current_length / c;
    }

    return max_length;
}

int main() {
    int n;
    long long m;
    cin >> n >> m;

    int colors[n];
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    long long max_length = maxUnselectedLength(colors, n, m);

    cout << max_length;

    return 0;
}