#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    priority_queue<int, vector<int>, greater<int>> pq; // min-heap

    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        pq.push(a);
    }

    long long totalColors = 0;
    while (m > 0) {
        int maxLength = pq.top();
        pq.pop();

        int newLength = maxLength / 2;
        pq.push(newLength);
        pq.push(maxLength - newLength);

        totalColors += maxLength;
        --m;
    }

    cout << totalColors << endl;

    return 0;
}