def relocation():
    # Ввід ваг та номерів коробок
    weights = list(map(int, input().split()))

    boxes = list(map(int, input().split()))

    # Розділення ваг по коробках
    box1 = [weights[i] for i in range(4) if boxes[i] == 1]
    box2 = [weights[i] for i in range(4) if boxes[i] == 2]

    # Знаходження максимальної ваги коробки
    max_weight = max(sum(box1), sum(box2))

    # Перевірка можливості зменшення максимальної ваги коробки
    for i in range(4):
        if boxes[i] == 1:
            new_box1_weight = sum(box1) - weights[i]
            new_box2_weight = sum(box2) + weights[i]
            if max(new_box1_weight, new_box2_weight) < max_weight:
                return i + 1
        else:
            new_box1_weight = sum(box1) + weights[i]
            new_box2_weight = sum(box2) - weights[i]
            if max(new_box1_weight, new_box2_weight) < max_weight:
                return i + 1

    return -1

print(relocation())