from heapq import nlargest

def form(members, olymp, num_teams):
    criteria = {
        "IOI": ('score', 4),
        "CEOI": ('score', 4),
        "EGOI": ('score', 4, 'gender', 'female'),
        "EJOI": ('score', 4, 'age', 15),
        "BaltOI": ('score', 6),
        "BalkOI": ('score', 4, 'grade', 11),
        "JBOI": ('score', 4, 'grade', [10, 11])
    }
    teams = {olymp: [] for olymp in olymps}
    for olymp in olymps:
        crit = criteria[olymp]
        arr = []
        for p in members:
            q = True
            for i in range(0, len(crit), 2):
                key, v = crit[i], crit[i + 1]
                if key == 'grade' and p[key] not in v:
                    q = False
                    break
                elif key == 'age' and p[key] >= v:
                    q = False
                    break
                elif key == 'gender' and p[key] != v:
                    q = False
                    break
                elif p[key] < v:
                    q = False
                    break
            if q:
                arr.append(p)
        num = min(num_teams[olymp], len(arr))
        selected = nlargest(num, arr, key=lambda x: x['score'])
        teams[olymp] = sorted([p['id'] for p in selected])
    return teams

n = int(input())
members = []
for x in range(n):
    p = {}
    p['id'], p['gender'], p['grade'], p['age'], p['score'] = input().split()
    p['id'] = int(p['id'])
    p['grade'] = int(p['grade'])
    p['age'] = int(p['age'])
    p['score'] = int(p['score'])
    members.append(p)
m = int(input())
olymps = [input().strip() for x in range(m)]
num_teams = {
    "IOI": 4, "CEOI": 4, "EGOI": 4, "EJOI": 4, "BaltOI": 6, "BalkOI": 4, "JBOI": 4
}
teams = form(members, olymps, num_teams)
for olymp in olymps:
    print(olymp)
    for pid in teams[olymp]:
        print(pid)