#include <iostream>
#include <vector>

using namespace std;

void printOrnament(int n, int m) {
    vector<vector<char>> shirt(n, vector<char>(m, '.'));

    int leftRay = 0, rightRay = m - 1;
    int leftDirection = 1, rightDirection = -1; 

    for (int i = 0; i < n; ++i) {
        shirt[i][leftRay] = 'x';
        shirt[i][rightRay] = 'x';

        leftRay += leftDirection;
        rightRay += rightDirection;

        if (leftRay == 0 || leftRay == m - 1) leftDirection *= -1;
        if (rightRay == 0 || rightRay == m - 1) rightDirection *= -1;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << shirt[i][j];
        }
        cout << endl;
    }
}

int main() 
{
    int n,m;
    cin>>n>>m;
    printOrnament(n, m);

    return 0;
}