n, m = map(int, input().split())
sizes = input().split()
inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [tuple(input().split()) for _ in range(k)]

remaining_inventory = [row[:] for row in inventory]
needed_orders = [[0] * m for _ in range(n)]

for color, size in requests:
    size_index = sizes.index(size)
    color_index = int(color) - 1
    
    if remaining_inventory[color_index][size_index] > 0:
        remaining_inventory[color_index][size_index] -= 1
    else:
        found_alternative = False
        for alt_color_index in range(n):
            if remaining_inventory[alt_color_index][size_index] > 0:
                remaining_inventory[alt_color_index][size_index] -= 1
                needed_orders[alt_color_index][size_index] += 1
                found_alternative = True
                break

        alt_size_index = size_index + 1
        while not found_alternative and alt_size_index < m:
            for alt_color_index in range(n):
                if remaining_inventory[alt_color_index][alt_size_index] > 0:
                    remaining_inventory[alt_color_index][alt_size_index] -= 1
                    needed_orders[alt_color_index][alt_size_index] += 1
                    found_alternative = True
                    break
            alt_size_index += 1

for row in remaining_inventory:
    print(*row)

for row in needed_orders:
    print(*row)
