#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    vector<int> weights(4), boxes(4), boxWeights(3, 0);
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }
    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
        boxWeights[boxes[i]] += weights[i];
    }

    int currentDiff = abs(boxWeights[1] - boxWeights[2]);
    int itemToMove = -1;
    
    for (int i = 0; i < 4; ++i) {
        int newWeight1 = boxWeights[1] + (boxes[i] == 2 ? weights[i] : -weights[i]);
        int newWeight2 = boxWeights[2] + (boxes[i] == 1 ? weights[i] : -weights[i]);
        int newDiff = abs(newWeight1 - newWeight2);

        if (newDiff < currentDiff && max(newWeight1, newWeight2) < max(boxWeights[1], boxWeights[2])) {
            currentDiff = newDiff;
            itemToMove = i + 1;
        }
    }

    cout << itemToMove << endl;

    return 0;
}
