#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> a(n);

    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (n > 1) {
        sort(a.begin(), a.end(), greater<long long>());
        long long max_seq = a[0]; 
        long long p2 = 1; 
        while (m > 0 && p2 <= m) {
            max_seq--;
            max_seq /= 2; 
            m -= p2; 
            p2 *= 2; 
        }

        cout << max_seq*n << endl;
    } 
    else {
        long long max = a[0];
        m--;
        long long p2 = 1;
        while(m > 0) {
            max--;
            max /= 2;
            p2 *= 2;
            m -= p2;
        }
        cout << max << endl;
    }
    return 0;
}
