w = map(int, input().split(" ")) # item's weight
t = map(int, input().split(" ")) # item's box

items = list(zip(t, w))

def box_weights(items):
    box1_weight = sum(weight for box, weight in items if box == 1)
    box2_weight = sum(weight for box, weight in items if box == 2)
    return box1_weight, box2_weight

def best_move(items, box1_weight, box2_weight):
    best_move = (None, float('inf'))

    for i, (box, weight) in enumerate(items):
        if box == 1:
            new_box1_weight = box1_weight - weight
            new_box2_weight = box2_weight + weight
        else:
            new_box1_weight = box1_weight + weight
            new_box2_weight = box2_weight - weight

        new_max_weight = max(new_box1_weight, new_box2_weight)

        if new_max_weight < best_move[1]:
            best_move = (i + 1, new_max_weight)

    return best_move

box1_weight, box2_weight = box_weights(items)
item_to_move, new_max_weight = best_move(items, box1_weight, box2_weight)

if new_max_weight < max(box1_weight, box2_weight):
    print(item_to_move)
else:
    print(-1)