def choose_colors(n, m, colors):
    used = [False] * n
    result = []
    
    for _ in range(m):
        longest_subarray = 0
        start = -1
        end = -1
        
        for i in range(n):
            if not used[i]:
                j = i
                while j < n and not used[j]:
                    j += 1
                if j - i > longest_subarray:
                    longest_subarray = j - i
                    start = i
                    end = j - 1
        
        
            result.append(colors[start + longest_subarray // 2])
            used[start + longest_subarray // 2] = True
        else:
            result.append(colors[start + longest_subarray // 2 - 1])
            used[start + longest_subarray // 2 - 1] = True
    
    max_length = 0
    current_length = 0
    for i in range(n):
        if not used[i]:
            current_length += 1
        else:
            max_length = max(max_length, current_length)
            current_length = 0
    
    return result, max_length

# Приклад використання
n = 5
m = 3
colors = [0, 0, 1, 0, 1, 0, 0, 1]
print(choose_colors(n, m, colors))
