#include <iostream>
#include <vector>

int main() {
    // Зчитуємо ваги та номери коробок
    std::vector<int> w(4), t(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> w[i];
    }
    for (int i = 0; i < 4; ++i) {
        std::cin >> t[i];
    }

    // Знаходимо вагу кожної коробки
    std::vector<int> box_weights(2, 0);
    for (int i = 0; i < 4; ++i) {
        box_weights[t[i] - 1] += w[i];
    }

    // Шукаємо номер речі, яку можна перемістити, щоб зменшити різницю ваг коробок
    for (int i = 0; i < 4; ++i) {
        int current_box = t[i] - 1;
        int other_box = 1 - current_box;

        int new_weight_current_box = box_weights[current_box] - w[i];
        int new_weight_other_box = box_weights[other_box] + w[i];

        // Перевіряємо, чи зменшення різниці ваг на 1 або менше
        if (std::abs(new_weight_current_box - new_weight_other_box) <= 1) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // Якщо оптимально нічого не змінювати
    std::cout << "-1" << std::endl;

    return 0;
}
