#include <bits/stdc++.h>
using namespace std;

pair<int, int> sumWeightsInBox(const vector<int>& weights, const vector<int>& boxNumbers) {
    int sum1 = 0;
    int sum2 = 0;

    for (size_t i = 0; i < weights.size(); i++) {
        if (boxNumbers[i] == 1) {
            sum1 += weights[i];
        } else {
            sum2 += weights[i];
        }
    }

    return make_pair(sum1, sum2);
}

int main() {
    int w1, w2, w3, w4, t1, t2, t3, t4;
    cin >> w1 >> w2 >> w3 >> w4;
    cin >> t1 >> t2 >> t3 >> t4;

    vector<int> weights = {w1, w2, w3, w4};
    vector<int> boxNumbers = {t1, t2, t3, t4};

    pair<int, int> sums = sumWeightsInBox(weights, boxNumbers);
    int sum1 = sums.first;
    int sum2 = sums.second;

    if (sum1 == sum2) {
        cout << -1 << endl;
        return 0;
    }

    int biggerBox = (sum1 > sum2) ? 1 : 2;
    int maxWeightDifference = abs(sum1 - sum2);
    int indexToMove = -1; 

    //ми знаємо початкову різницю між їх масами, оптимальніший варіант буде меншим. Тому робимо цикл у шукаємо меншу різницю

    for (int i = 0; i < 4; i++) {
        if (boxNumbers[i] == biggerBox) {
            int weightDifference;
            int localSum1 = sum1;
            int localSum2 = sum2;
            if (sum1 > sum2){
                localSum1 -= weights[i];
                localSum2 += weights[i];
                weightDifference = abs(localSum1 - localSum2);
            } else{
                localSum1 += weights[i];
                localSum2 -= weights[i];
                weightDifference = abs(localSum2 - localSum1);
            }
            if (weightDifference < maxWeightDifference) {
                maxWeightDifference = weightDifference;
                indexToMove = i + 1;
            }
        }
    }

    cout << indexToMove << endl;

    return 0;
}