def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if (i + j) % 2 == 0:
                ornament[i][j] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Read input values
n, m = map(int, input().split())

# Generate and print the ornament
ornament = create_ornament(n, m)
print_ornament(ornament)
