def main():
    n, m = map(int, input().split())
    sizes = input().split()
    shirts_count = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    
    remaining_shirts = [[0] * m for _ in range(n)]
    needed_shirts = [[0] * m for _ in range(n)]
    
    for _ in range(k):
        color, size = input().split()
        size_index = sizes.index(size)
        
        if shirts_count[int(color)-1][size_index] > 0:
            shirts_count[int(color)-1][size_index] -= 1
        else:
            found = False
            for j in range(size_index + 1, m):
                if shirts_count[int(color)-1][j] > 0:
                    shirts_count[int(color)-1][j] -= 1
                    remaining_shirts[int(color)-1][size_index] += 1
                    found = True
                    break
            
            if not found:
                for j in range(size_index + 1, m):
                    if shirts_count[int(color)-1][j] > 0:
                        shirts_count[int(color)-1][j] -= 1
                        remaining_shirts[int(color)-1][j] += 1
                        break
                else:
                    needed_shirts[int(color)-1][size_index] += 1
    
    for row in remaining_shirts:
        print(" ".join(map(str, row)))
    
    for row in needed_shirts:
        print(" ".join(map(str, row)))


if __name__ == "__main__":
    main()

