class Participant:
    def __init__(self, id, gender, grade, age, score):
        self.id = id
        self.gender = gender
        self.grade = grade
        self.age = age
        self.score = score

participants_count = int(input())
participants = []

for i in range(participants_count):
    id, gender, grade, age, score = input().split(" ")
    id = int(id)
    grade = int(grade)
    age = int(age)
    score = int(score)
    participants.append(Participant(id, gender, grade, age, score))

participants.sort(key=lambda participant: participant.score, reverse=True)

competitions_count = int(input())
competitions = []

for i in range(competitions_count):
    name = input()
    selected = []

    if name in ("IOI", "CEOI"):
        selected = [p.id for p in participants[:4]]
    elif name == "EGOI":
        selected = [p.id for p in participants if p.gender == "female"][:4]
    elif name == "EJOI":
        selected = [p.id for p in participants if p.age <= 15][:4]
    elif name == "BaltOI":
        selected = [p.id for p in participants[:6]]
    elif name == "BalkOI":
        selected = [p.id for p in participants if p.grade != 11][:4]
    elif name == "JBOI":
        selected = [p.id for p in participants if p.grade != 10 and p.grade != 11][:4]

    selected.sort()

    print(name)
    print("\n".join(str(id) for id in selected))
    print()
