def max_unmarked_length(n, m, a):
    a.sort(reverse=True)
    max_length = a[0]

    for i in range(1, n):
        if a[i] >= i + 1:
            max_length = max(max_length, i + 1)
        else:
            break

    remaining_colors = m - (n * (n + 1) // 2)
    if remaining_colors > 0:
        max_length += remaining_colors // n

    return max_length

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_length(n, m, a)
print(result)