import math

def max_unmarked_sequence(n, m, a):
    max_sequence = 0

    for i in range(n):
        max_sequence = max(max_sequence, a[i])

    remaining_colors = m - max_sequence

    if remaining_colors > 0:
        max_sequence += math.ceil(remaining_colors / n)

    return max_sequence

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, a)
print(result)