#include <stdio.h>
#include <string.h>

#define MAX_OLYMPIADS 6
#define MAX_PARTICIPANTS 1000

int determine_team_size(char* olympiad, int num_participants) {
    if (strcmp(olympiad, "IOI") == 0 || strcmp(olympiad, "CEOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "EGOI") == 0 || strcmp(olympiad, "EJOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "BaltOI") == 0) {
        return num_participants < 6 ? num_participants : 6;
    } else if (strcmp(olympiad, "BalkOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else {
        return 0;
    }
}

int main() {
    char olympiads[MAX_OLYMPIADS][10];
    int participants[MAX_PARTICIPANTS][5];

    int n, m;
    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
        scanf("%d %s %d %d %d", &participants[i][0], participants[i][1], &participants[i][2], &participants[i][3], &participants[i][4]);
    }

    scanf("%d", &m);

    for (int i = 0; i < m; ++i) {
        scanf("%s", olympiads[i]);
    }

    // Sorting the participants based on score and ID
    for (int j = 0; j < m; ++j) {
        char* olympiad = olympiads[j];
        int team_size = determine_team_size(olympiad, n);

        for (int k = 0; k < n - 1; ++k) {
            for (int l = 0; l < n - k - 1; ++l) {
                if (participants[l][4] < participants[l + 1][4] || (participants[l][4] == participants[l + 1][4] && participants[l][0] > participants[l + 1][0])) {
                    // Swap participants
                    for (int m = 0; m < 5; ++m) {
                        int temp = participants[l][m];
                        participants[l][m] = participants[l + 1][m];
                        participants[l + 1][m] = temp;
                    }
                }
            }
        }

        // Printing team members
        printf("%s\n", olympiad);
        for (int i = 0; i < team_size; ++i) {
            printf("%d\n", participants[i][0]);
        }
    }

    return 0;
}