import heapq

def max_sequence(n, m, a):
    pq = []
    for ai in a:
        pq.append((-ai, ai))
    heapq.heapify(pq)
    for _ in range(m):
        longest, original = heapq.heappop(pq)
        longest = -longest
        middle = (longest + 1) // 2
        heapq.heappush(pq, (-middle, original))
    return -pq[0][0]

if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    print(max_sequence(n, m, a))