#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main(){
    long long n,m;
    cin>>n>>m;
    vector<string> sizes(m);
    for(long long i=0; i<m; i++) {
        cin>>sizes[i];
    }
    vector<vector<long long>> stocks(n,vector<long long>(m));
    for(long long i=0; i<n; i++){
        for(long long j=0; j<m; j++){
            cin>>stocks[i][j];
        }
    }
    long long k;
    cin>>k;
    vector<vector<long long>> left(n,vector<long long>(m));
    vector<vector<long long>> order(n,vector<long long>(m,0));
    for(long long i=0; i<k; i++){
        long long color;
        string size;
        cin>>color>>size;
        long long s=-1;
        for(long long j=0; j<m; j++){
            if(sizes[j]==size){
                s=j;
                break;
            }
        }
        if(s>=0 && stocks[color-1][s]>0){
            stocks[color-1][s]-=1;
        }else{
            order[color-1][s]+=1; 
        }
    }
    for(long long i=0; i<n; i++){
        for(long long j=0; j<m; j++){
            left[i][j]=stocks[i][j];
        }
    }
    for(long long i=0; i<n; i++){
        for(long long j=0; j<m; j++){
            cout<<left[i][j]<<" ";
        }
        cout<<endl;
    }
    for(long long i=0; i<n; i++){
        for(long long j=0; j<m; j++){
            cout<<order[i][j]<<" ";
        }
        cout<<endl;
    }
}