#include <iostream>

int main() {
    // Input height and width
    int n, m;
    std::cin >> n >> m;

    // Initialize the ornament array
    char ornament[n][m];

    // Fill the ornament array with spaces
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ornament[i][j] = ' ';
        }
    }

    // Draw the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            // Draw the diagonal rays
            if (i == j || i == m - j - 1) {
                ornament[i][j] = '*';
            }
        }
    }

    // Output the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << ornament[i][j];
        }
        std::cout << std::endl;
    }

    return 0;
}
