def calculate_outcome(current_val, current_adr, w, t):
    sum1 = 0
    sum2 = 0
    for i in range(4):
        if t[i] == 1:
            sum1 += w[i]
        else:
            sum2 += w[i]

    if current_adr == 2:
        sum1 += current_val
        sum2 -= current_val
    else:
        sum1 -= current_val
        sum2 += current_val

    return abs(sum1 - sum2)

def find_min(projected_val, t):
    temp = projected_val[0]
    adr1 = 0
    for i in range(1, 4):
        if temp > projected_val[i]:
            temp = projected_val[i]
            adr1 = i
    return adr1 + 1

w = [int(x) for x in input().split()]
t = [int(x) for x in input().split()]

projected_outcome = [calculate_outcome(w[i], t[i], w, t) for i in range(4)]
sum1 = sum(w[i] for i in range(4) if t[i] == 1)
sum2 = sum(w[i] for i in range(4) if t[i] == 2)
default_outcome = abs(sum1 - sum2)

best = find_min(projected_outcome, t)

if projected_outcome[best - 1] < default_outcome:
    print(best)
else:
    print(-1)