def max_unmarked_length(n, m, a):
    if n == 1:
        return max(1, a[0] - m)

    max_unmarked = max(a)  # Find the maximum number of unmarked colors on any wheel

    low, high = 0, max_unmarked  # Initial range for binary search
    answer = 0

    while low <= high:
        mid = (low + high) // 2

        total_unmarked = sum(max(0, wheel - mid) for wheel in a)

        if total_unmarked >= m:
            answer = mid
            low = mid + 1
        else:
            high = mid - 1

    return n + answer

# Example usage
n, m = map(int, input().split())
a = list(map(int, input().split()))
result = max_unmarked_length(n, m, a)
print(result)
