using System;

class Program
{
    static void Main()
    {
        string[] weights = Console.ReadLine().Split();
        string[] boxes = Console.ReadLine().Split();

        int[] w = Array.ConvertAll(weights, int.Parse);
        int[] t = Array.ConvertAll(boxes, int.Parse);

        int totalWeight1 = 0, totalWeight2 = 0;
        int maxWeight = int.MinValue;
        int itemToMove = -1;

        for (int i = 0; i < 4; i++)
        {
            if (t[i] == 1)
                totalWeight1 += w[i];
            else
                totalWeight2 += w[i];
        }

        maxWeight = Math.Max(totalWeight1, totalWeight2);

        for (int i = 0; i < 4; i++)
        {
            int currentWeight1 = totalWeight1, currentWeight2 = totalWeight2;
            if (t[i] == 1)
            {
                currentWeight1 -= w[i];
                currentWeight2 += w[i];
            }
            else
            {
                currentWeight2 -= w[i];
                currentWeight1 += w[i];
            }

            int currentMax = Math.Max(currentWeight1, currentWeight2);
            if (currentMax < maxWeight)
            {
                maxWeight = currentMax;
                itemToMove = i + 1;
            }
        }

        Console.WriteLine(itemToMove);
    }
}
