using System;

class Program
{
    static void Main()
    {
        string[] inputs = Console.ReadLine().Split();
        int n = int.Parse(inputs[0]); // Height
        int m = int.Parse(inputs[1]); // Width

        char[,] ornament = new char[n, m];

        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                // Check if it's the corner or part of the rays
                if ((i == 0 && j == 0) || (i == 0 && j == m - 1) || (i == n - 1 && j == 0) || (i == n - 1 && j == m - 1))
                {
                    ornament[i, j] = 'x';
                }
                else if (i % 2 == 0 && (j == i / 2 || j == m - 1 - (i / 2)))
                {
                    ornament[i, j] = 'x';
                }
                else
                {
                    ornament[i, j] = '.';
                }
            }
        }

        // Printing the ornament
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(ornament[i, j]);
            }
            Console.WriteLine();
        }
    }
}
