# Input
n, m = map(int, input().split())
sizes = input().split()
available = []
for _ in range(n):
    available.append(list(map(int, input().split())))
k = int(input())
requests = []
for _ in range(k):
    color, size = input().split()
    requests.append((int(color), size))

# Initialize tables
remaining = [[0] * m for _ in range(n)]
to_be_purchased = [[0] * m for _ in range(n)]

# Process requests
for color, size in requests:
    found = False
    for i in range(n):
        if available[i][sizes.index(size)] > 0:
            available[i][sizes.index(size)] -= 1
            remaining[i][sizes.index(size)] += 1
            found = True
            break
    if not found:
        for i in range(n):
            if available[i][sizes.index(size)] == 0:
                continue
            for j in range(sizes.index(size) + 1, m):
                if available[i][j] > 0:
                    available[i][j] -= 1
                    remaining[i][j] += 1
                    found = True
                    break
            if found:
                break
    if not found:
        for i in range(n):
            for j in range(sizes.index(size) + 1, m):
                if available[i][j] > 0:
                    available[i][j] -= 1
                    remaining[i][j] += 1
                    found = True
                    break
            if found:
                break
    if not found:
        to_be_purchased[color - 1][sizes.index(size)] += 1

# Output
for row in remaining:
    print(*row)
for row in to_be_purchased:
    print(*row)
