n, m = map(int, input().split())

sizes = input().split()

size_index = {}
for i in range(m):
    size_index[sizes[i]] = i

tshirts = []
for i in range(n):
    tshirts.append(list(map(int, input().split())))

k = int(input())

requests = []
for i in range(k):
    c, s = input().split()
    c = int(c) - 1
    s = size_index[s]
    requests.append((c, s))

absent = [[0] * m for i in range(n)]

def find_next(c, s):
    if tshirts[c][s] > 0:
        tshirts[c][s] -= 1
        return (c, s)
    for i in range(n):
        if tshirts[i][s] > 0:
            tshirts[i][s] -= 1
            return (i, s)
    for j in range(s + 1, m):
        if tshirts[c][j] > 0:
            tshirts[c][j] -= 1
            return (c, j)
        for i in range(n):
            if tshirts[i][j] > 0:
                tshirts[i][j] -= 1
                return (i, j)
    return None

for c, s in requests:
    result = find_next(c, s)
    if result is None:
        absent[c][s] += 1
    else:
        print(result[0] + 1, sizes[result[1]]) 

for i in range(n):
    print(*tshirts[i])

for i in range(n):
    print(*absent[i])