import heapq

def max_unmarked_sequence(n, m, a):
    pq = []
    for i in range(n):
        a[i] = a[i]*2 + 1
        heapq.heappush(pq, -a[i])
    for _ in range(m):
        top = -heapq.heappop(pq)
        heapq.heappush(pq, -(top//2))
    return -pq[0]//2

print(max_unmarked_sequence(1, 1, [11]))
print(max_unmarked_sequence(1, 3, [11]))
print(max_unmarked_sequence(1, 5, [11]))
print(max_unmarked_sequence(1, 109, [1033]))
print(max_unmarked_sequence(3, 1145, [4034, 5912, 9134]))
