#include <bits/stdc++.h>
using namespace std;
using ll = long long;
ll n, m;

map<string, ll> conv;



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        string s;
        cin >> s;
        conv[s] = i;
    }
    
    vector<set<ll>> s(m);
    vector<vector<ll>> left(n, vector<ll>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> left[i][j];
            if (left[i][j] > 0) {
                s[j].insert(i);
            }
        }
    }

    vector<vector<ll>> dont(n, vector<ll>(m));

    ll q;
    cin >> q;
    while (q--) {
        ll c; string t;
        cin >> c >> t;
        c--;
        ll sz = conv[t];

        bool found = false;
        for (int j = sz; j < m; j++) {
            if (left[c][j] > 0) {
                left[c][j]--;
                if (left[c][j] == 0) {
                    s[j].erase(c);
                }
                found = true;
                break;
            }
            else if (s[j].size() > 0) {
                ll here = *s[j].begin();
                left[here][j]--;
                if (left[here][j] == 0) {
                    s[j].erase(here);
                }
                found = true;
                break;
            }
        }

        if (!found) {
            dont[c][sz]++;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            printf("%lld ", left[i][j]);
        }
        printf("\n");
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            printf("%lld ", dont[i][j]);
        }
        printf("\n");
    }
}