#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<int> w_arr(4);
    vector<int> t_arr(4);

    // Input weights
    for (int i = 0; i < 4; i++) {
        cin >> w_arr[i];
    }

    // Input box numbers
    for (int i = 0; i < 4; i++) {
        cin >> t_arr[i];
    }

    // Calculate the total weight in each box
    int sum_box1 = 0, sum_box2 = 0;
    for (int i = 0; i < 4; i++) {
        if (t_arr[i] == 1) {
            sum_box1 += w_arr[i];
        } else {
            sum_box2 += w_arr[i];
        }
    }

    // Check if it's optimal to not change anything
    if (sum_box1 == sum_box2) {
        cout << -1 << endl;
    } else {
        // Find the item to be moved
        for (int i = 0; i < 4; i++) {
            if ((t_arr[i] == 1 && sum_box1 - w_arr[i] == sum_box2) ||
                (t_arr[i] == 2 && sum_box2 - w_arr[i] == sum_box1)) {
                cout << i + 1 << endl;
                break;
            }
        }
    }

    return 0;
}
