#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }
    
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    int totalWeightBox1 = 0, totalWeightBox2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            totalWeightBox1 += weights[i];
        } else {
            totalWeightBox2 += weights[i];
        }
    }

    // Check which item needs to be moved
    for (int i = 0; i < 4; ++i) {
        int newTotalWeightBox1 = totalWeightBox1 + weights[i];
        int newTotalWeightBox2 = totalWeightBox2 - weights[i];

        if (newTotalWeightBox1 == newTotalWeightBox2) {
            // If the total weights in both boxes are equal after moving the item
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // If it's optimal to not change anything
    std::cout << "-1" << std::endl;

    return 0;
}