#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

int n, m;
long long grade[1000], age[1000], gender[1000];
long long score[1000], id[1000];
string gen, s;

int main() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> id[i] >> gen >> grade[i] >> age[i] >> score[i];
		if (gen == "male") gender[i] = 1;
		if (gen == "female") gender[i] = 2;
	}
	cin >> m;
	for (int t = 1; t <= m; t++) {
		cin >> s;
		
		if (s == "IOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 4; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i]==false) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "IOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}

		if (s == "CEOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 4; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i] == false) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "CEOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}

		if (s == "EGOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 4; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i] == false && gender[i]==2) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "EGOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}

		if (s == "EJOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 4; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i] == false && age[i] <= 15) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "EJOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}

		if (s == "BaltOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 6; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i] == false) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "BaltOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}

		if (s == "BalkOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 4; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i] == false && grade[i]<11) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "BalkOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}

		if (s == "JBOI") {
			vector <long long> arr;
			bool seen[1000] = { 0 };
			for (int r = 1; r <= 4; r++) {
				int mx = -1;
				int w = 0;
				for (int i = 0; i < n; i++) {
					if (mx < score[i] && seen[i] == false && grade[i]<10) {
						mx = score[i];
						w = i;
					}
				}
				if (mx != -1) {
					arr.push_back(id[w]);
					seen[w] = true;
				}
				else break;
			}
			sort(arr.begin(), arr.end());
			cout << "JBOI" << endl;
			for (int i = 0; i < arr.size(); i++) {
				cout << arr[i] << endl;
			}
            cout<<endl;
		}
	}
}