
def max_subarray_length(n, m, a):
    total_colors = sum(a)
    remaining_colors = total_colors
    max_length = 0

    for i in range(n):
        length = min(a[i], remaining_colors)
        remaining_colors -= length

        if length % 2 == 0:
            length //= 2

        max_length = max(max_length, length)

    return max_length * 2 + min(remaining_colors, m)



n, m = map(int, input().split())
a = list(map(int, input().split()))


result = max_subarray_length(n, m, a)
print(result)