def main():
    n, m = map(int, input().split())
    sizes = input().split()
    colors = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    
    remaining = [[colors[i][j] for j in range(m)] for i in range(n)]
    needed = [[0 for _ in range(m)] for _ in range(n)]
    
    for _ in range(k):
        c, s = input().split()
        c = int(c) - 1
        s_index = sizes.index(s)
        
        if remaining[c][s_index] > 0:
            remaining[c][s_index] -= 1
        else:
            found = False
            for size_index in range(s_index + 1, m):
                for color_index in range(n):
                    if remaining[color_index][size_index] > 0:
                        remaining[color_index][size_index] -= 1
                        found = True
                        break
                if found:
                    break
            
            if not found:
                # print("Not found")
                needed[c][size_index] += 1
                # for size_index in range(s_index + 1, m):
                #     for color_index in range(n):
                #         if needed[color_index][size_index] > 0:
                #             print(needed)
                #             needed[color_index][size_index] -= 1
                #             found = True
                #             break
                #     if found:
                #         break
    
    for row in remaining:
        print(' '.join(map(str, row)))
    
    for row in needed:
        print(' '.join(map(str, row)))

if __name__ == "__main__":
    main()