#include <iostream>
#include <vector>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Зчитуємо вхідні дані: ваги предметів та номери коробок
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Знаходимо вагу кожної коробки
    int weight_box1 = 0, weight_box2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            weight_box1 += weights[i];
        } else {
            weight_box2 += weights[i];
        }
    }

    // Якщо ваги коробок однакові, нічого переміщувати
    if (weight_box1 == weight_box2) {
        std::cout << "-1" << std::endl;
        return 0;
    }

    // Знаходимо важчу коробку та предмет в ній
    int heavier_box = (weight_box1 > weight_box2) ? 1 : 2;
    int item_to_move = -1;
    int max_weight_in_box = -1;

    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == heavier_box && weights[i] > max_weight_in_box) {
            max_weight_in_box = weights[i];
            item_to_move = i + 1; // Нумерація з 1
        }
    }

    std::cout << item_to_move << std::endl;
    return 0;
}
