#include <iostream>
#include <vector>
#include <unordered_map>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Зчитуємо вхідні дані
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    std::unordered_map<int, int> box_weights;

    // Обчислюємо суми ваг речей у кожній коробці
    for (int i = 0; i < 4; ++i) {
        if (box_weights.find(boxes[i]) == box_weights.end()) {
            box_weights[boxes[i]] = weights[i];
        } else {
            box_weights[boxes[i]] += weights[i];
        }
    }

    int target_box = -1;

    // Перевіряємо, чи можемо зрівняти вагу коробок
    for (int i = 0; i < 4; ++i) {
        if (box_weights[boxes[i]] - weights[i] == box_weights[3 - boxes[i]]) {
            target_box = i + 1;
            break;
        }
    }

    // Виводимо результат
    std::cout << target_box << std::endl;

    return 0;
}
