#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void find_remaining_and_order(int n, int m, vector<char>& sizes, vector<vector<int>>& quantities, int k, vector<pair<int, char>>& winners) {
    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            remaining[i][j] = quantities[i][j];
        }
    }

    for (int i = 0; i < k; ++i) {
        int color = winners[i].first - 1;
        char size = winners[i].second;

        auto sizeIt = find(sizes.begin(), sizes.end(), size);
        if (sizeIt != sizes.end() && remaining[color][distance(sizes.begin(), sizeIt)] > 0) {
            remaining[color][distance(sizes.begin(), sizeIt)]--;
        } else {
            bool found = false;
            int sizeIndex = distance(sizes.begin(), sizeIt);
            for (int c = 0; c < n; ++c) {
                if (remaining[c][sizeIndex] > 0) {
                    to_order[c][sizeIndex]++;
                    remaining[c][sizeIndex]--;
                    found = true;
                    break;
                }
            }

            if (!found) {
                for (int s = sizeIndex + 1; s < m; ++s) {
                    for (int c = 0; c < n; ++c) {
                        if (remaining[c][s] > 0) {
                            remaining[c][s]--;
                            to_order[c][s]++;
                            found = true;
                            break;
                        }
                    }
                    if (found) {
                        break;
                    }
                }
                if (!found) {
                    to_order[color][sizeIndex]++;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    // отримання вхідних даних

    return 0;
}