#include <iostream>
#include <vector>

int main() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> grid(n, std::vector<char>(m, '.'));

    int leftRay = 0, rightRay = m - 1;
    int leftDir = 1, rightDir = -1;

    for (int i = 0; i < n; ++i) {

        grid[i][leftRay] = 'x';
        grid[i][rightRay] = 'x';


        leftRay += leftDir;
        rightRay += rightDir;


        if (leftRay == 0 || leftRay == m - 1) leftDir *= -1;
        if (rightRay == 0 || rightRay == m - 1) rightDir *= -1;
    }


    for (const auto& row : grid) {
        for (char c : row) {
            std::cout << c;
        }
        std::cout << "\n";
    }

    return 0;
}
