#include <iostream>
#include <vector>
#include <queue>

int main() {
    long long n, m;
    std::cin >> n >> m;
    
    std::priority_queue<long long> sequences;

    for (long long i = 0; i < n; ++i) {
        long long a;
        std::cin >> a;
        sequences.push(a);
    }

    while (m--) {
        long long longest = sequences.top();
        sequences.pop();

        if (longest % 2 == 0) {
            sequences.push(longest / 2);
            sequences.push(longest / 2 - 1);
        } else {
            long long half = longest / 2;
            sequences.push(half);
            sequences.push(half);
        }
    }

    std::cout << sequences.top() << std::endl;

    return 0;
}
