#include <bits/stdc++.h>
#include <vector>
#include <algorithm>
using namespace std;

struct participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool incl(string ol, participant p) {
    if (ol == "IOI"){
            return true;
    } else if (ol == "CEOI") {
            return true;
    } else if (ol == "EGOI") {
            return p.gender == "female";
    } else if (ol == "EJOI") {
            return p.age <= 15;
    } else if (ol == "BaltOI") {
            return true;
    } else if (ol == "BalkOI") {
            return p.grade < 11;
    } else if (ol == "JBOI") {
            return p.grade < 10;
    }
}

int top_participants(string ol){
    return ol == "BaltOI" ? 6 : 4;
}

bool score_sorter(participant a, participant b){
    return a.score > b.score;
}

bool id_sorter(participant a, participant b){
    return a.id < b.id;
}

vector<participant> find_participants(string ol, vector<participant> ps){
    vector<participant> result;
    for (auto&& elem : ps){
        if (incl(ol, elem)) {
            result.push_back(elem);
        }
    }
    sort(result.begin(), result.end(), score_sorter);
    if (top_participants(ol) < result.size()){
        result.erase(result.begin() + top_participants(ol), result.end());
    }
    sort(result.begin(), result.end(), id_sorter);
    return result;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<participant> ps;
    for (int i=0; i<n; i++){
        participant p;
        cin >> p.id;
        cin >> p.gender;
        cin >> p.grade;
        cin >> p.age;
        cin >> p.score;
        ps.push_back(p); 
    }
    int m;
    cin >> m;

    for (int i=0; i<m; i++){
        string ol;
        cin >> ol;
        vector<participant> r = find_participants(ol, ps);
        cout << ol << '\n';
        for (int i=0; i<r.size(); i++){
            cout << r[i].id << '\n';
        }
        cout << '\n';
    }
        
}
