#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;


priority_queue<lli> pq;
map<lli, lli> mp;

void solve()
{
    lli n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        lli x;
        cin >> x;
        if(mp[x]==0)pq.push(x);
        mp[x]++;
    }
    m--;
    while (!pq.empty()) {
        lli x = pq.top();
        pq.pop();
        if (mp[x] > m) {
            cout << x;
            return;
        }
        m -= mp[x];
        x--;
        if (x % 2 == 0) {
            if (mp[x/2]==0)pq.push(x / 2);
            mp[x / 2] += mp[x+1] * 2;
            mp[x+1] = 0;
        }
        else {
            if (mp[x / 2] == 0)pq.push(x / 2);
            mp[x / 2] += mp[x+1];
            if (mp[x / 2 + 1] == 0)pq.push(x / 2 + 1);
            mp[x / 2 + 1] += mp[x+1];
            mp[x+1] = 0;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

