from collections import defaultdict

def process_gifts(n, m, sizes, stocks, k, requests):
    stock_dict = defaultdict(lambda: defaultdict(int))

    # Записати наявність футболок у словник
    for i in range(n):
        for j in range(m):
            stock_dict[sizes[j]][i] = stocks[i][j]

    present_dict = defaultdict(lambda: defaultdict(int))

    # Перебрати запити переможців
    for i in range(k):
        color_idx, size = requests[i]
        size_idx = sizes.index(size)
        found = False

        # Шукати футболку заданого розміру та кольору
        if stock_dict[size][color_idx] > 0:
            stock_dict[size][color_idx] -= 1
            present_dict[size][color_idx] += 1
            found = True

        # Шукати футболку такого ж розміру, але іншого кольору
        if not found:
            for j in range(n):
                if stock_dict[size][j] > 0:
                    stock_dict[size][j] -= 1
                    present_dict[size][j] += 1
                    found = True
                    break

        # Якщо футболки потрібного розміру взагалі немає
        if not found:
            for j in range(size_idx + 1, m):
                for l in range(n):
                    if stock_dict[sizes[j]][l] > 0:
                        stock_dict[sizes[j]][l] -= 1
                        present_dict[sizes[j]][l] += 1
                        found = True
                        break
                if found:
                    break

        # Якщо футболки не знайдено, записати як відсутню
        if not found:
            present_dict[size][color_idx] += 1

    # Вивід залишків та футболок, які потрібно докупити
    for i in range(n):
        stock_left = [stock_dict[sizes[j]][i] for j in range(m)]
        present_needed = [0 if present_dict[sizes[j]][i] == 0 else present_dict[sizes[j]][i] for j in range(m)]
        print(*stock_left)
        print(*present_needed)

# Зчитати вхідні дані
n, m = map(int, input().split())
sizes = input().split()
stocks = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [map(str, input().split()) for _ in range(k)]

# Виклик функції для обробки даних та виведення результату
process_gifts(n, m, sizes, stocks, k, requests)
