def create_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]
    
    # Generating the upper rays
    for i in range(min(n, m)):
        pattern[i][i] = 'X'
        pattern[i][m - i - 1] = 'X'
    
    # Converting pattern to string
    for row in pattern:
        print(''.join(row))

# Taking input
n, m = map(int, input().split())

# Generating the pattern
create_pattern(n, m)
