def create_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]
    
    # Generating the upper rays
    x, y = 0, 0
    while x >= 0 and y >= 0 and x < n and y < m:
        pattern[x][y] = 'X'
        x += 1
        y += 1
        if y == m or x == n:
            break
    
    x, y = 0, m - 1
    while x >= 0 and y >= 0 and x < n and y < m:
        pattern[x][y] = 'X'
        x += 1
        y -= 1
        if y == -1 or x == n:
            break
    
    # Converting pattern to string
    for row in pattern:
        print(''.join(row))

# Taking input
n, m = map(int, input().split())

# Generating the pattern
create_pattern(n, m)

# Correcting the comment
# PRINT CORRECT
