def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Create the upper-left ray
    for i in range(min(n, m)):
        ornament[i][i] = 'x'

    # Create the upper-right ray
    for i in range(min(n, m)):
        ornament[i][m - i - 1] = 'x'

    # Print the ornament
    for row in ornament:
        print(''.join(row))

# Input
n, m = map(int, input().split())

# Output
create_ornament(n, m)
