n, m = map(int, input().split())
a = list(map(int, input().split()))

# Function to find the next color according to the rules
def next_color(colors):
    longest = max(colors)
    index = colors.index(longest)
    if longest % 2 == 0:
        return index, longest // 2
    else:
        return index, longest // 2 + 1

# Calculate the sequence lengths for each color wheel
sequences = [((count // (a[i] + 1)) * (a[i] + 1)) + min(count % (a[i] + 1), a[i]) for i, count in enumerate(a)]

# Calculate the maximum sequence of unmarked colors
max_sequence = max(sequences)
remaining = m + n - sum(a)
if remaining <= max_sequence:
    print(max_sequence)
else:
    remaining -= max_sequence
    max_sequence += remaining // n * max(sequences)
    remaining %= n
    while remaining > 0:
        idx, length = next_color(sequences)
        sequences[idx] = length
        max_sequence += length
        remaining -= 1
    print(max_sequence)
