n, m = map(int, input().split())
a = list(map(int, input().split()))

def calc_max_seq_length(a, m):
    a.sort(reverse=True)
    l = len(a)
    left, right = 1, sum(a) + m

    while left < right:
        mid = (left + right) // 2
        cnt = 0

        for i in range(l):
            cnt += min(a[i], mid)

        if cnt >= (mid + 1) // 2:
            left = mid + 1
        else:
            right = mid

    return left - 1

result = calc_max_seq_length(a, m)
print(result)
