def find_max_length(a, m):
    left, right = 0, sum(a)

    while left < right:
        mid = (left + right + 1) // 2
        count = 0
        current_sum = 0

        for ai in a:
            current_sum += ai
            if current_sum >= mid:
                count += 1
                current_sum = 0

        if count >= m + 1:
            left = mid
        else:
            right = mid - 1

    return left

# Введення даних
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Знаходимо та виводимо відповідь
result = find_max_length(a, m)
print(result)
