import java.util.*;
class Participant {
    int id;
    String gender;
    int grade;
    int age;
    int score;

    public Participant(int id, String gender, int grade, int age, int score) {
        this.id = id;
        this.gender = gender;
        this.grade = grade;
        this.age = age;
        this.score = score;
    }
}

public class OlympiadTeamSelection {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        List<Participant> participants = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            int id = scanner.nextInt();
            String gender = scanner.next();
            int grade = scanner.nextInt();
            int age = scanner.nextInt();
            int score = scanner.nextInt();
            participants.add(new Participant(id, gender, grade, age, score));
        }
        int m = scanner.nextInt();
        for (int i = 0; i < m; i++) {
            String olympiad = scanner.next();
            List<Integer> selectedIds = selectTeam(participants, olympiad);
            System.out.println(olympiad);
            for (int id : selectedIds) {
                System.out.println(id);
            }
        }
        scanner.close();
    }
    private static List<Integer> selectTeam(List<Participant> participants, String olympiad) {
        List<Integer> selectedIds = new ArrayList<>();
        switch (olympiad) {
            case "IOI":
                break;
            case "CEOI":
                break;
            default:
                System.out.println("Invalid olympiad");
        }
        return selectedIds;
    }
}