import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        System.out.println(fMaxS(n, m, a));
    }

    public static int fMaxS(int n, int m, int[] a) {
        int[] dp = new int[n];
        dp[0] = a[0];
        int maxSum = dp[0];

        for (int i = 1; i < n; i++) {
            dp[i] = Math.max(a[i], dp[i - 1] + a[i]);
            maxSum = Math.max(maxSum, dp[i]);
        }

        if (maxSum > m) {
            return -1;
        } else {
            return maxSum;
        }
    }
}