def max_unmarked_sequence(n, m, a):
    max_length = 0

    for ai in a:
        max_length = max(max_length, (ai + 1) // 2)

    remaining_m = m
    if remaining_m > max_length:
        remaining_m -= max_length
        max_length += (remaining_m + n - 1) // n

    return max_length


# Input reading
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output result
result = max_unmarked_sequence(n, m, a)
print(result)
# Test the provided examples

# Example 1
n1, m1, a1 = 1, 1, [11]
result1 = max_unmarked_sequence(n1, m1, a1)
print(result1)  # Output should be 11

# Example 2
n2, m2, a2 = 1, 3, [11]
result2 = max_unmarked_sequence(n2, m2, a2)
print(result2)  # Output should be 5

# Example 3
n3, m3, a3 = 1, 5, [11]
result3 = max_unmarked_sequence(n3, m3, a3)
print(result3)  # Output should be 2

# Example 4
n4, m4, a4 = 1, 109, [1033]
result4 = max_unmarked_sequence(n4, m4, a4)
print(result4)  # Output should be 15

# Example 5
n5, m5, a5 = 3, 1145, [4034, 5912, 9134]
result5 = max_unmarked_sequence(n5, m5, a5)
print(result5)  # Output should be 22

