import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int m = scanner.nextInt();

        // Знаходимо НСД для (n-1) і (m-1)
        int gcd = gcd(n - 1, m - 1);

        // Обчислюємо максимальну кількість проходів робота
        int result = (n - 1) / gcd + (m - 1) / gcd;

        System.out.println(result);
    }

    // Рекурсивна функція для знаходження НСД
    private static int gcd(int a, int b) {
        return b == 0 ? a : gcd(b, a % b);
    }
}
