import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int[] weights = new int[4];
        int[] boxes = new int[4];

        for (int i = 0; i < 4; i++) {
            weights[i] = scanner.nextInt();
        }

        for (int i = 0; i < 4; i++) {
            boxes[i] = scanner.nextInt();
        }

        int optimalBox = findOptimalBox(weights, boxes);
        System.out.println(optimalBox);
    }

    private static int findOptimalBox(int[] weights, int[] boxes) {
        int totalWeightBox1 = (boxes[0] == 1) ? weights[0] : 0;
        int totalWeightBox2 = (boxes[0] == 2) ? weights[0] : 0;

        for (int i = 1; i < 4; i++) {
            if (boxes[i] == 1) {
                totalWeightBox1 += weights[i];
            } else {
                totalWeightBox2 += weights[i];
            }
        }

        if (totalWeightBox1 >= totalWeightBox2) {
            return (boxes[0] == 1) ? -1 : 1;
        } else {
            return (boxes[0] == 2) ? -1 : 2;
        }
    }
}

