def max_unmarked_subsegment_length(n, m, a):
    prefix_sum = [0] * (n + 1)
    for i in range(n):
        prefix_sum[i + 1] = prefix_sum[i] + a[i]

    left, right = 0, n

    def check(mid):
        for i in range(mid, n + 1):
            if (prefix_sum[i] - prefix_sum[i - mid]) % 2 == 0:
                return True
        return False

    result = 0

    while left <= right:
        mid = (left + right) // 2
        if check(mid):
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

# Зчитуємо вхідні дані
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Знаходимо та виводимо відповідь
answer = max_unmarked_subsegment_length(n, m, a)
print(answer)
