def find_max_subarray_length(n, m, a):
    left, right = 1, 10**18

    while left < right:
        mid = (left + right + 1) // 2

        if check(n, m, a, mid):
            left = mid
        else:
            right = mid - 1

    return left


def check(n, m, a, length):
    additional_colors = m
    for i in range(n):
        additional_colors -= max(0, a[i] - length + 1)
        if additional_colors <= 0:
            return True
    return False


if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    result = find_max_subarray_length(n, m, a)
    print(result)

