#include <bits/stdc++.h>
#include <string>
#include <vector>
using namespace std;

struct Student{
    int id;
    bool gender;
    int grade;
    int age;
    int score;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;

    vector<Student> students;
    for (int i = 0; i < n; ++i){
        string temp;
        Student tempStudent;
        cin >> tempStudent.id
            >> temp
            >> tempStudent.grade
            >> tempStudent.age
            >> tempStudent.score;
        if (temp == "female"){
            tempStudent.gender = true;
        }
        else{
            tempStudent.gender = false;
        }
        students.push_back(tempStudent);
    }
    bool olymps[7] {false};
    int num;
    cin >> num;
    for (int i = 0; i < num; ++i){
        string temp;
        cin >> temp;
        if (temp == "IOI"){
            olymps[0] = true;
        }
        if (temp == "CEOI"){
            olymps[1] = true;
        }
        if (temp == "EGOI"){
            olymps[2] = true;
        }
        if (temp == "EJOI"){
            olymps[3] = true;
        }
        if (temp == "BaltOI"){
            olymps[4] = true;
        }
        if (temp == "BalkOI"){
            olymps[5] = true;
        }
        if (temp == "JBOI"){
            olymps[6] = true;
        }
    }

    sort(students.begin(), students.end(), [](Student a, Student b){
            return a.score > b.score;
        });

    if(olymps[0]){
        cout << "IOI\n";
        
        vector<Student> tempStudents;
        tempStudents.push_back(students[0]);
        tempStudents.push_back(students[1]);
        tempStudents.push_back(students[2]);
        tempStudents.push_back(students[3]);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        cout << tempStudents[0].id << "\n"
                << tempStudents[1].id << "\n"
                << tempStudents[2].id << "\n"
                << tempStudents[3].id << "\n\n";
    }
    if(olymps[1]){
        cout << "CEOI\n";
        
        vector<Student> tempStudents;
        tempStudents.push_back(students[0]);
        tempStudents.push_back(students[1]);
        tempStudents.push_back(students[2]);
        tempStudents.push_back(students[3]);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        cout << tempStudents[0].id << "\n"
                << tempStudents[1].id << "\n"
                << tempStudents[2].id << "\n"
                << tempStudents[3].id << "\n\n";
    }
    if(olymps[2]){
        cout << "EGOI\n";
        
        vector<Student> tempStudents {};
        int j = 0;
        do{
            if (students[j].gender){
                tempStudents.push_back(students[j]);
            }
            ++j;
            if (j > n){
                break;
            }
        } while(tempStudents.size() <= 4);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        for (int i = 0; i < tempStudents.size(); ++i){
            cout << tempStudents[i].id << "\n";
        }

        cout << "\n";
    }
    if(olymps[3]){
        cout << "EJOI\n";
        
        vector<Student> tempStudents {};
        int j = 0;
        do{
            if (students[j].age <= 15){
                tempStudents.push_back(students[j]);
            }
            ++j;
            if (j > n){
                break;
            }
        } while(tempStudents.size() <= 4);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        for (int i = 0; i < tempStudents.size(); ++i){
            cout << tempStudents[i].id << "\n";
        }

        cout << "\n";
    }
    if(olymps[4]){
        cout << "BaltOI\n";
        
        vector<Student> tempStudents;
        tempStudents.push_back(students[0]);
        tempStudents.push_back(students[1]);
        tempStudents.push_back(students[2]);
        tempStudents.push_back(students[3]);
        tempStudents.push_back(students[4]);
        tempStudents.push_back(students[5]);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        cout << tempStudents[0].id << "\n"
                << tempStudents[1].id << "\n"
                << tempStudents[2].id << "\n"
                << tempStudents[3].id << "\n"
                << tempStudents[4].id << "\n"
                << tempStudents[5].id << "\n\n";
    }
    if(olymps[5]){
        cout << "BalkOI\n";
        
        vector<Student> tempStudents {};
        int j = 0;
        do{
            if (students[j].grade != 11){
                tempStudents.push_back(students[j]);
            }
            ++j;
            if (j > n){
                break;
            }
        } while(tempStudents.size() <= 4);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        for (int i = 0; i < tempStudents.size(); ++i){
            cout << tempStudents[i].id << "\n";
        }

        cout << "\n";
    }
    if(olymps[6]){
        cout << "BalkOI\n";
        
        vector<Student> tempStudents {};
        int j = 0;
        do{
            if (students[j].grade != 11 && students[j].grade != 10){
                tempStudents.push_back(students[j]);
            }
            ++j;
            if (j > n){
                break;
            }
        } while(tempStudents.size() <= 4);

        sort(tempStudents.begin(), tempStudents.end(), [](Student a, Student b){
            return a.id < b.id;
        });

        for (int i = 0; i < tempStudents.size(); ++i){
            cout << tempStudents[i].id << "\n";
        }

        cout << "\n";
    }
}
