import math

def solve(n, m, a):
    max_length = max(a) - 1
    a.sort(reverse=True)
    max_value = a[0]
    second_max = a[1] if n > 1 else 0
    remaining_steps = m - 1
    
    if remaining_steps == 0:
        return max_length
    
    full_cycles = remaining_steps // n
    remaining_colors = remaining_steps % n
    full_cycle_length = (max_value + second_max) * full_cycles
    remaining_length = (max_value + second_max) if remaining_colors == 1 else max_value
    
    return full_cycle_length + remaining_length

n, m = map(int, input().split())
a = list(map(int, input().split()))
result = solve(n, m, a)
print(result)
