def max_unmarked_length(n, m, colors):
    colors.sort(reverse=True)

    max_length = colors[0] - 1

    for i in range(1, m):
        max_length = max(max_length, (colors[i] - colors[i - 1]) // 2)

    max_length = max(max_length, n - colors[m - 1])

    return max_length

n, m = map(int, input().split())
colors = list(map(int, input().split()))

result = max_unmarked_length(n, m, colors)
print(result)
