#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    vector<int> weights(4);
    vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    vector<int> box_weights(2, 0);

    for (int i = 0; i < 4; ++i) {
        box_weights[boxes[i] - 1] += weights[i];
    }

    int max_weight = *max_element(box_weights.begin(), box_weights.end());
    int item_to_move = -1;

    for (int i = 0; i < 4; ++i) {
        int from_box = boxes[i] - 1;
        int to_box = 1 - from_box;
        int current_weight = box_weights[from_box] - weights[i] + box_weights[to_box];

        if (current_weight < max_weight) {
            max_weight = current_weight;
            item_to_move = i + 1;
        }
    }

    if (item_to_move != -1) {
        cout << item_to_move << endl;
    }
    else {
        cout << -1 << endl;
    }

    return 0;
}
