def create_embroidery_pattern(height, width):
    pattern = [['.' for _ in range(width)] for _ in range(height)]

    for i in range(min(height, width)):
        pattern[i][0] = 'x'
        pattern[0][i] = 'x'

    return pattern

def print_pattern(pattern):
    for row in pattern:
        print(''.join(row))

def main():
    n, m = map(int, input().split())
    pattern = create_embroidery_pattern(n, m)
    print_pattern(pattern)

if __name__ == "__main__":
    main()





