def process_requests(n, m, sizes, available, winners):
    remaining = [[0] * m for _ in range(n)]
    needed = [[0] * m for _ in range(n)]

    for winner in winners:
        color, size = winner
        size_index = sizes.index(size)

        found = False
        for i in range(size_index, m):
            if available[color - 1][i] > 0:
                available[color - 1][i] -= 1
                found = True
                break

        if not found:
            for i in range(size_index):
                if available[color - 1][i] > 0:
                    available[color - 1][i] -= 1
                    break

        if not found:
            for i in range(size_index, m):
                for j in range(n):
                    if available[j][i] > 0:
                        available[j][i] -= 1
                        break

        if not found:
            needed[color - 1][size_index] += 1

    return remaining, needed

def print_table(table):
    for row in table:
        print(" ".join(map(str, row)))


n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
winners = [tuple(input().split()) for _ in range(k)]


