
def printIds(ids):
    ids = sorted(ids)
    for id in ids:
        print(id)

class Person:
    def __init__(self, id, gender, grade, age, score):
        self.id = id
        self.gender = gender
        self.grade = int(grade)
        self.age = int(age)
        self.score = score


people = []

n = int(input())
for i in range(n):
    id, gender, grade, age, score = input().split()
    people.append(Person(id, gender, grade, age, score))

people = sorted(people, key=lambda person: person.score, reverse=True)

m = int(input())

comps = []

for i in range(m):
    comps.append(str(input()))

#print(comps)

for comp in comps:
    if comp == "IOI" or comp == "CEOI":
        print(comp)
        ids = []
        for i in range(4):
            ids.append(people[i].id)
        printIds(ids)
        print()

    elif comp == "EGOI":
        print(comp)
        c = 0
        ids = []
        for person in people:
            if c >= 4:
                exit
            else:
                if person.gender == "female":
                    c+=1
                    ids.append(person.id)
        printIds(ids)
        print()

    elif comp == "EJOI":
        print(comp)
        c = 0
        ids = []
        for person in people:
            if c >= 4:
                exit
            else:
                if person.age <= 15:
                    c += 1
                    ids.append(person.id)
        printIds(ids)
        print()

    elif comp == "BaltOI":
        print(comp)
        ids = []
        for i in range(6):
            ids.append(person.id)
        printIds(ids)
        print()

    elif comp == "BalkOI":
        print(comp)
        c = 0
        ids = []
        for person in people:
            if c >= 4:
                exit
            else:
                if person.grade != 11:
                    c += 1
                    ids.append(person.id)
        printIds(ids)
        print()

    elif comp == "JBOI":
        print(comp)
        c = 0
        ids = []
        for person in people:
            if c >= 4:
                exit
            else:
                if person.grade not in [10,11]:
                    c += 1
                    ids.append(person.id)
        printIds(ids)
        print()









