#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<int> w(4);
    vector<int> t(4);

    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }

    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    // Calculate the total weight in each box.
    int totalWeightInBox1 = 0, totalWeightInBox2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (t[i] == 1) {
            totalWeightInBox1 += w[i];
        } else {
            totalWeightInBox2 += w[i];
        }
    }

    // Check which item can be moved to minimize the maximum weight in a box.
    for (int i = 0; i < 4; ++i) {
        int currentWeightInBox1 = totalWeightInBox1;
        int currentWeightInBox2 = totalWeightInBox2;

        if (t[i] == 1) {
            currentWeightInBox1 -= w[i];
            currentWeightInBox2 += w[i];
        } else {
            currentWeightInBox1 += w[i];
            currentWeightInBox2 -= w[i];
        }

        if (max(currentWeightInBox1, currentWeightInBox2) <= max(totalWeightInBox1, totalWeightInBox2)) {
            cout << i + 1 << endl;
            return 0;
        }
    }

    // If no item needs to be moved to achieve the minimum maximum weight, print -1.
    cout << -1 << endl;

    return 0;
}
