#include <iostream>

using namespace std;

void generateOrnament(int n, int m) {
    char** ornament = new char*[n];
    for (int i = 0; i < n; ++i) {
        ornament[i] = new char[m];
        for (int j = 0; j < m; ++j) {
            if ((j == i || j == m - i - 1) && i < n / 2) {
                ornament[i][j] = 'x';
            } else if ((j == n - i - 1 || j == i - n / 2) && i >= n / 2) {
                ornament[i][j] = 'x';
            } else {
                ornament[i][j] = '.';
            }
        }
    }

    // Вивід орнаменту
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ornament[i][j];
        }
        cout << endl;
    }

    // Звільнення пам'яті
    for (int i = 0; i < n; ++i) {
        delete[] ornament[i];
    }
    delete[] ornament;
}

int main() {
    int n, m;
    cin >> n >> m;

    // Генеруємо та виводимо орнамент
    generateOrnament(n, m);

    return 0;
}
