# Зчитуємо вхідні дані
n, m = map(int, input().split()) # кількість кольорів та розмірів
sizes = input().split() # розміри футболок
t = [] # кількість футболок кожного кольору та розміру
for i in range(n):
    t.append(list(map(int, input().split())))
k = int(input()) # кількість переможців
c = [] # колір футболки кожного переможця
s = [] # розмір футболки кожного переможця
for i in range(k):
    ci, si = input().split()
    c.append(int(ci) - 1) # зменшуємо індекс на 1, щоб починати з 0
    s.append(sizes.index(si)) # знаходимо індекс розміру в списку розмірів

# Ініціалізуємо вихідні дані
l = [[0] * m for i in range(n)] # кількість футболок, які залишилися
n = [[0] * m for i in range(n)] # кількість футболок, які потрібно докупити

# Обробляємо запити переможців
for i in range(k):
    color = c[i] # потрібний колір
    size = s[i] # потрібний розмір
    found = False # чи знайшли футболку
    # Спробуємо знайти футболку потрібного кольору та розміру
    if t[color][size] > 0:
        t[color][size] -= 1 # віднімаємо одну футболку
        found = True # знайшли футболку
    else:
        # Якщо не знайшли, то шукаємо футболку того ж розміру, але іншого кольору
        for j in range(len(n)): # використовуємо len(n) замість n
            if t[j][size] > 0:
                t[j][size] -= 1 # віднімаємо одну футболку
                found = True # знайшли футболку
                break # виходимо з циклу
    if not found:
        # Якщо все ще не знайшли, то шукаємо футболку наступного більшого розміру, але з пріоритетом кольору
        for j in range(size + 1, m): # перебираємо розміри в порядку зростання
            if t[color][j] > 0:
                t[color][j] -= 1 # віднімаємо одну футболку
                found = True # знайшли футболку
                break # виходимо з циклу
            else:
                # Якщо немає футболки з пріоритетним кольором, то шукаємо футболку з мінімальним номером кольору
                for k in range(len(n)): # використовуємо len(n) замість n
                    if t[k][j] > 0:
                        t[k][j] -= 1 # віднімаємо одну футболку
                        found = True # знайшли футболку
                        break # виходимо з циклу
                if found:
                    break # виходимо з циклу
    if not found:
        # Якщо ніяка футболка не підійшла, то записуємо її як відсутню
        n[color][size] += 1 # додаємо одну футболку

# Копіюємо залишки футболок в l
for i in range(len(n)): # використовуємо len(n) замість n
    for j in range(m):
        l[i][j] = t[i][j]

# Виводимо вихідні дані
for i in range(len(n)): # використовуємо len(n) замість n
    print(*l[i]) # виводимо кількість футболок, які залишилися
for i in range(len(n)): # використовуємо len(n) замість n
    print(*n[i]) # виводимо кількість футболок, які потрібно докупити
