def convert_to_byte_calendar(day, month, from_calendar):
    # Мапа кількості днів у місяці для обох календарів
    days_in_month = {
        'byte': [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
        'bitu': [30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30]
    }

    # Конвертуємо дату до Байтуліанського календаря
    total_days = day
    for i in range(1, month):
        total_days += days_in_month[from_calendar][i]

    return total_days

# Зчитуємо вхідні дані
day_month_byte = list(map(int, input().split()))
day_month_bitu = list(map(int, input().split()))

# Конвертуємо дати до Байтуліанського календаря
converted_day_byte = convert_to_byte_calendar(day_month_byte[0], day_month_byte[1], 'bitu')
converted_day_bitu = convert_to_byte_calendar(day_month_bitu[0], day_month_bitu[1], 'bitu')

# Перевіряємо, чи дати однакові
if converted_day_byte == converted_day_bitu:
    print("Same birthday!")
else:
    print("Not the same")
