def create_complex_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        pattern[i][0] = 'x'
        pattern[0][i] = 'x'

    for i in range(1, min(n, m)):
        pattern[i][i] = 'o'

    return pattern

def print_pattern(pattern):
    for row in pattern:
        print(' '.join(row))


n, m = map(int, input().split())


pattern = create_complex_pattern(n, m)
print_pattern(pattern)


