#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    priority_queue<int> colorWheels;

    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        colorWheels.push(a);
    }

    long long totalLength = 0;

    while (m > 0) {
        int maxSequenceLength = colorWheels.top();
        colorWheels.pop();

        if (maxSequenceLength % 2 == 1) {
            totalLength += maxSequenceLength / 2 + 1;
            colorWheels.push(maxSequenceLength / 2);
            colorWheels.push(maxSequenceLength / 2);
        } else {
            totalLength += maxSequenceLength / 2;
            colorWheels.push(maxSequenceLength / 2);
            colorWheels.push(maxSequenceLength / 2 - 1);
        }

        --m;
    }

    cout << totalLength << endl;

    return 0;
}
