#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    for (int i = 0; i < n; i++) {
        cin >> colors[i];
    }

    int maxLength = 0;
    for (int i = 0; i < n; i++) {
        int count = 0;
        for (int j = 0; j < n; j++) {
            if (colors[j] >= colors[i]) {
                count++;
            }
        }
        maxLength = max(maxLength, count);
    }

    int remaining = m - n;
    int additional = remaining / n;
    int remainder = remaining % n;

    int result = maxLength + additional;
    if (remainder > 0) {
        result++;
    }

    cout << result << endl;

    return 0;
}
