#include <iostream>
using namespace std;
int binomial(int n, int k) {
    if (k > n || k < 0) return 0;
    if (k == 0 || k == n) return 1;
    return binomial(n - 1, k - 1) + binomial(n - 1, k);
}
int max_passes(int n, int m) {
    int paths = binomial(n + m - 2, n - 1);
    int min_flowers = min(n, m);
    int max_passes = (n * m) / min_flowers;
    return max_passes;
}

int main() {
    int n, m;
    cin >> n >> m;
    int ans = max_passes(n, m);
    cout  << ans << endl;
    return 0;
}