#include <iostream>
#include <vector>
using namespace std;

int max_p(int n, int m) {
    vector<vector<int>> d(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        d[i][0] = i + 1;
    }
    for (int j = 0; j < m; j++) {
        d[0][j] = j + 1;
    }
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < m; j++) {
            d[i][j] = max(d[i-1][j], d[i][j-1]) + 1;
        }
    }
    return d[n-1][m-1];
}

int main() {
    int n, m;
    cin >> n >> m;
    cout << max_p(n, m) << endl;
    return 0;
}
