#include <bits/stdc++.h>
using namespace std;

int findItemToMove(vector<int> weight, vector<int> box) {
    int tbox1 = 0, tbox2 = 0;
    for (int i = 0; i < 4; i++) {
        if (box[i] == 1) {
            tbox1 += weight[i];
        }
        else {
            tbox2 += weight[i];
        }
    }
    int maxWeight = 0, itemToMove = -1;
    for (int i = 0; i < 4; i++) {
        if ((tbox1 > tbox2 && box[i] == 1) || (tbox2 > tbox1 && box[i] == 2)) {
            if (weight[i] > maxWeight) {
                maxWeight = weight[i];
                itemToMove = i;
            }
        }
    }
    return itemToMove;
}

int main() {
    vector<int> weight(4);
    for (int i = 0; i < 4; i++) {
        cin >> weight[i];
    }
    vector<int> box(4);
    for (int i = 0; i < 4; i++) {
        cin >> box[i];
    }
    int itemToMove = findItemToMove(weight, box);
    if (itemToMove != -1) {
        cout << itemToMove + 1 << "\n";
    }
    else {
        cout << "-1\n";
    }

    return 0;
}
