participants = {}
for _ in range(int(input())):
    id_num, gender, grade, age, score = input().split()
    id_num, grade, age, score = map(int, (id_num, grade, age, score))
    participants.setdefault('IOI', []).append((id_num, score))
    participants.setdefault('CEOI', []).append((id_num, score))
    if gender == 'female':
        participants.setdefault('EGOI', []).append((id_num, score))
    if age <= 15:
        participants.setdefault('EJOI', []).append((id_num, score))
    participants.setdefault('BaltOI', []).append((id_num, score))
    if grade != 11:
        participants.setdefault('BalkOI', []).append((id_num, score))
    if grade not in [11, 10]:
        participants.setdefault('JBOI', []).append((id_num, score))

# Sorting participants by score
for k in participants:
    participants[k].sort(key=lambda x: (-x[1], x[0]))

olympiads = [input() for _ in range(int(input()))]

for olympiad in olympiads:
    team_size = 6 if olympiad == 'BaltOI' else 4
    team = participants.get(olympiad, [])[:team_size]
    print(olympiad)
    for participant in sorted(p[0] for p in team):
        print(participant)
