import heapq

def max_unmarked_sequence(n, m, wheels):
    max_len = 0
    heap = [-wheel for wheel in wheels]
    heapq.heapify(heap)

    while m > 0:
        wheel = -heapq.heappop(heap)
        remaining_colors = wheel

        if remaining_colors >= m:
            max_len += m
            break
        else:
            max_len += remaining_colors
            m -= remaining_colors

        if remaining_colors > 1:
            heapq.heappush(heap, -(remaining_colors // 2))

    return max_len
n, m = map(int, input().split())
wheels = list(map(int, input().split()))
print(max_unmarked_sequence(n, m, wheels))