n, m = map(int, input().split())

# Функція для перетворення індексу добутку на двовимірні координати
def idx_to_coords(idx, n, m):
    row = idx // m
    col = idx % m
    return row, col

# Функція для перетворення двовимірних координат на індекс добутку
def coords_to_idx(row, col, n, m):
    return row * m + col

# Створення орнаменту
ornament = [['.'] * m for _ in range(n)]
for i in range(n * m):
    row, col = idx_to_coords(i, n, m)
    if row == 0 or row == n - 1 or col == 0 or col == m - 1:
        ornament[row][col] = 'x'

# Виведення орнаменту
for row in ornament:
    print(''.join(row))