def team_composition(participants, olympiad):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(4, len(participants))]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        return sorted(female_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(female_participants))]
    elif olympiad == "EJOI":
        under_15_participants = [p for p in participants if p[3] <= 15]
        return sorted(under_15_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(under_15_participants))]
    elif olympiad == "BaltOI" or olympiad == "BalkOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(6, len(participants))]
    elif olympiad == "JBOI":
        non_10_11_graders = [p for p in participants if p[2] < 10]
        return sorted(non_10_11_graders, key=lambda x: (-x[4], x[0]))[:min(4, len(non_10_11_graders))]

# Input
n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participant_info[0] = int(participant_info[0])
    participant_info[3] = int(participant_info[3])
    participant_info[4] = int(participant_info[4])
    participants.append(participant_info)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Process and output
for olympiad in olympiads:
    selected_participants = team_composition(participants, olympiad)
    print(olympiad)
    for participant in selected_participants:
        print(participant[0])
