def max_unmarked_sequence(n, m, a):
    # Sort the color wheels in descending order
    a.sort(reverse=True)

    # Calculate the maximum length of the sequence of unmarked colors
    result = 0
    for i in range(n):
        if a[i] <= i:
            break
        result = i + 1

    # Calculate the remaining colors to be chosen
    remaining_colors = m - result

    # If there are remaining colors, adjust the result based on the algorithm
    if remaining_colors > 0:
        result += remaining_colors // (n + 1) * n
        remaining_colors %= (n + 1)
        
        if remaining_colors > 0:
            result += remaining_colors

    return result

# Input reading
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output result
print(max_unmarked_sequence(n, m, a))
