#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (string& s : sizes) cin >> s;

    map<string, int> size_to_idx;
    for (int i = 0; i < m; ++i) size_to_idx[sizes[i]] = i;

    vector<vector<int>> tshirts(n, vector<int>(m));
    for (vector<int>& t : tshirts)
        for (int& x : t) cin >> x;

    int k;
    cin >> k;

    vector<vector<int>> needed(n, vector<int>(m));
    vector<vector<int>> remaining = tshirts;

    while (k--) {
        int c;
        string s;
        cin >> c >> s;
        --c;

        int idx = size_to_idx[s];
        bool found = false;

        for (int i = idx; i < m && !found; ++i)
            for (int j = 0; j < n && !found; ++j)
                if (remaining[j][i] > 0) {
                    --remaining[j][i];
                    found = true;
                    if (i != idx || j != c) ++needed[c][idx];
                }

        if (!found) ++needed[c][idx];
    }

    for (const vector<int>& t : remaining) {
        for (int x : t) cout << x << ' ';
        cout << '\n';
    }

    for (const vector<int>& t : needed) {
        for (int x : t) cout << x << ' ';
        cout << '\n';
    }

    return 0;
}
