from collections import defaultdict
def find_shirt(shirts, color, size):
    if shirts[color][size] > 0:
        shirts[color][size] -= 1
        return True
    for other_color in sorted(shirts.keys()):
        if shirts[other_color][size] > 0:
            shirts[other_color][size] -= 1
            return True
    for bigger_size in sorted(sizes[sizes.index(size):]):
        for other_color in sorted(shirts.keys()):
            if shirts[other_color][bigger_size] > 0:
                shirts[other_color][bigger_size] -= 1
                return True
    return False
n, m = map(int, input().split())
sizes = input().split()
shirts = defaultdict(lambda: defaultdict(int))
for i in range(n):
    line = list(map(int, input().split()))
    for j in range(m):
        shirts[i + 1][sizes[j]] = line[j]
k = int(input())
needed_shirts = defaultdict(lambda: defaultdict(int))
for _ in range(k):
    color, size = input().split()
    color = int(color)
    if not find_shirt(shirts, color, size):
        needed_shirts[color][size] += 1
for i in range(1, n + 1):
    for j in range(m):
        print(shirts[i][sizes[j]], end=" ")
    print()
for i in range(1, n + 1):
    for j in range(m):
        print(needed_shirts[i][sizes[j]], end=" ")
    print()