def form_teams(participants, olympiad):
    teams = []
    if olympiad == "IOI":
        teams = sorted(participants, key=lambda x: (-x["score"], x["id"]))[:min(4, len(participants))]
    elif olympiad == "CEOI":
        teams = sorted(participants, key=lambda x: (-x["score"], x["id"]))[:min(4, len(participants))]
    elif olympiad == "EGOI":
        female_participants = [participant for participant in participants if participant["gender"] == "female"]
        teams = sorted(female_participants, key=lambda x: (-x["score"], x["id"]))[:min(4, len(female_participants))]
        return teams
n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = map(str, input().split())
    participant = {
        "id": int(id),
        "gender": gender,
        "grade": int(grade),
        "age": int(age),
        "score": int(score)
    }
    participants.append(participant)
m = int(input())
olympiads = []
for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)
for olympiad in olympiads:
    teams = form_teams(participants, olympiad)
    teams_ids = [str(team["id"]) for team in teams]
    print(olympiad)
    print(" ".join(teams_ids))