n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Створення масиву частот для підрахунку кількості кожного числа
frequency = [0] * (max(colors) + 1)
for color in colors:
    frequency[color] += 1

# Створення масиву префіксних сум
prefix_sums = [0] * (len(colors) + 1)
for i in range(1, len(prefix_sums)):
    prefix_sums[i] = prefix_sums[i - 1] + frequency[colors[i - 1]]

# Обчислення різниці між сумами префіксних сум
max_difference = 0
for i in range(len(prefix_sums)):
    for j in range(i + 1, len(prefix_sums)):
        difference = prefix_sums[j] - prefix_sums[i]
        max_difference = max(max_difference, difference)

# Знаходження максимальної різниці
result = max_difference - 1 if max_difference % 2 == 0 else max_difference

print(result)