#include <iostream>

// Функція для знаходження НСД
int gcd(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main() {
    // Зчитування вхідних даних
    int n, m;
    std::cin >> n >> m;

    // Знаходження НСД
    int commonDivisor = gcd(n, m);

    // Результат - кількість проходів робота
    int result = (n / commonDivisor) * (m / commonDivisor);

    // Виведення результату
    std::cout << result << std::endl;

    return 0;
}
