#include <iostream>
#include <vector>
#include <unordered_map>

int main() {
    // Введення ваг речей
    std::vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    // Введення номерів коробок
    std::vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Використовуємо unordered_map для збереження індексів речей
    std::unordered_map<int, int> lastBox;

    // Пошук речі, яку можна перемістити
    for (int i = 0; i < 4; ++i) {
        if (lastBox.find(weights[i]) != lastBox.end() && lastBox[weights[i]] != boxes[i]) {
            // Знайдено річ, яку можна перемістити
            std::cout << i + 1 << std::endl;
            return 0;
        }
        lastBox[weights[i]] = boxes[i];
    }

    // Якщо не знайдено речі для переміщення
    std::cout << "-1" << std::endl;

    return 0;
}
