#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    for (int i = 0; i < n; i++) {
        cin >> colors[i];
    }

    int max_length = 0;
    for (int i = 0; i < m; i++) {
        int max_subarray_length = 0;
        int current_length = 0;

        for (int j = 0; j < n; j++) {
            if (colors[j] != 0) {
                current_length++;
            } else {
                max_subarray_length = max(max_subarray_length, current_length);
                current_length = 0;
            }
        }

        max_subarray_length = max(max_subarray_length, current_length);
        max_length += max_subarray_length;

        if (max_subarray_length % 2 == 0) {
            max_length++;
        }

        if (i < m - 1) {
            colors[max_subarray_length / 2] = 0;
        }
    }

    cout << max_length << endl;

    return 0;
}
