weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

box_weights = [0, 0]

for i in range(4):
    box_weights[boxes[i] - 1] += weights[i]

max_weight = max(box_weights)
items_to_move = []

for i in range(4):
    from_box = boxes[i] - 1
    to_box = 1 - from_box
    current_weight = box_weights[from_box] - weights[i] + box_weights[to_box]

    if current_weight < max_weight:
        max_weight = current_weight
        items_to_move = [i + 1]
    elif current_weight == max_weight:
        items_to_move.append(i + 1)

print(*items_to_move)
