def item_to_move(w, t):
    box1, box2 = 0, 0
    for i in range(4):
        if t[i] == 1:
            box1 += w[i]
        else:
            box2 += w[i]

    box_weights = [box1, box2]
    box_max_weight = max(box_weights)
    box_min_weight = min(box_weights)

    if box_max_weight == box_min_weight:
        return -1

    for i in range(4):
        if t[i] == 1 and box1 + w[i] == box_max_weight:
            return i + 1
        elif t[i] == 2 and box2 + w[i] == box_max_weight:
            return i + 1

# test cases
print(item_to_move([5, 2, 4, 3], [1, 2, 2, 1])) # Output: -1
print(item_to_move([4, 2, 3, 7], [2, 1, 1, 2])) # Output: 1