def min_max_weight(weights, boxes):
    current_max = sum(weight for weight, box in zip(weights, boxes) if box in (1, 2))
    best_move = -1

    for i, (weight, box) in enumerate(zip(weights, boxes)):
        if box == 0:
            continue
        next_max = current_max - weight + (weight if box in (1, 2) else 0)
        if next_max < current_max:
            current_max = next_max
            best_move = i + 1

    return best_move

# Input
weights = [5, 2, 4, 3]
boxes = [1, 2, 2, 1]

# Output
print(min_max_weight(weights, boxes))
