def draw_ornament(n, m):
    # Initialization
    ornament = []
    x = "x"
    d = "."
    width = m
    height = n

    # Calculate the width and height of the top ray
    top_ray_width = width // 2
    top_ray_height = height // 2

    # Draw the top ray
    for i in range(top_ray_height):
        ornament.append(x + d * (top_ray_width - 1 - i) + x)

    # Calculate the width and height of the bottom ray
    bottom_ray_width = top_ray_width + (width + 1) % 2
    bottom_ray_height = height - top_ray_height

    # Draw the bottom ray
    for i in range(bottom_ray_height):
        ornament.append(d * i + x + d * (bottom_ray_width - 1 - i) + x)

    # Output the ornament
    for row in ornament:
        print(row)


if __name__ == "__main__":
    # Read input data
    n, m = map(int, input().split())

    # Draw and output the ornament
    draw_ornament(n, m)