def create_ornament(n, m):
    ornament = []

    for i in range(n):
        row = ['.'] * m

        if i == 0 or i == n - 1:
            # Перший і останній рядок мають 'x' в кутах
            row[0] = 'x'
            row[m - 1] = 'x'
        elif i < m - 1:
            # Для інших рядків створити відображуваний візерунок
            row[i] = 'x'
            row[m - i - 1] = 'x'

        ornament.append(''.join(row))

    return ornament

# Читання введених даних від користувача
n, m = map(int, input().split())

# Генерація та вивід орнаменту у вигляді прикладу
ornament = create_ornament(n, m)
for i, row in enumerate(ornament):
    print(row, end='')
    if i < n - 1:
        print()

