def solve(n, m, a):
    used = [False] * (n+1)
    colors = [0] * (n+1)
    total_colors = sum(a) + n
    current_max = 0
    next_color = n + 1
    next_index = 0

    while next_color <= total_colors:
        current_max = max(current_max, next_color - next_index)
        next_index += 1
        next_color += a[next_index % n]
        if next_index % n == 0:
            used[next_index // n] = True

    if current_max < total_colors:
        current_max = total_colors

    return current_max


def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    print(solve(n, m, a))


if __name__ == "__main__":
    main()