def max_sequence_length(n, m, a):
    # Calculate the maximum length of the sequence of unmarked colors
    max_length = 0
    
    # Find the longest sequence among all the color wheels
    for wheel in a:
        max_length = max(max_length, wheel)
    
    # Calculate the number of colors Miss M will select
    total_colors = m + n
    
    # Calculate the maximum length of the sequence of unmarked colors before selecting the (m+n)-th color
    max_length += (total_colors - 1) // 2
    
    return max_length

# Example usage
n = 1
m = 3
a = [11]
result = max_sequence_length(n, m, a)
print(result)
