def max_sequence_length(n, m, a):
    try:
        max_length = 0
        for i in range(n):
            max_length = max(max_length, a[i])
        remaining_colors = m - n
        if remaining_colors <= 0:
            return max_length
        max_length += remaining_colors // n * max(a)
        remaining_colors %= n
        if remaining_colors > 0:
            max_length += max(a[:remaining_colors])
        return max_length
    except Exception as e:
        print(f"An error occurred: {e}")

try:
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    print(max_sequence_length(n, m, a))
except ValueError:
    print("Invalid input. Please enter integers only.")
except Exception as e:
    print(f"An error occurred: {e}")
