// function findItemToMove(weights, boxes) {
//     weights = []
//     boxes = []
//   const maxWeight = Math.max(
//     (boxes[0] === 1 ? weights[0] : 0) + (boxes[1] === 1 ? weights[1] : 0),
//     (boxes[0] === 2 ? weights[0] : 0) + (boxes[1] === 2 ? weights[1] : 0),
//     (boxes[2] === 1 ? weights[2] : 0) + (boxes[3] === 1 ? weights[3] : 0),
//     (boxes[2] === 2 ? weights[2] : 0) + (boxes[3] === 2 ? weights[3] : 0)
//   );

//   for (let i = 0; i < 4; i++) {
//     if (boxes[i] === 1 && weights[i] + (boxes[(i + 1) % 4] === 2 ? weights[(i + 1) % 4] : 0) === maxWeight) {
//       return i + 1
//     }else if (boxes[i] === 2 && weights[i] + (boxes[(i + 1) % 4] === 1 ? weights[(i + 1) % 4] : 0) === maxWeight) {
//       return i + 1
//     }
    
//   }

//   return -1
// }

// console.log(findItemToMove([5, 2, 4, 3], [1, 2, 2, 1]))

// function findItemToMove(weights, boxes) {
//   const maxWeight = Math.max(
//     (boxes[0] === 1 ? weights[0] : 0) + (boxes[1] === 1 ? weights[1] : 0),
//     (boxes[0] === 2 ? weights[0] : 0) + (boxes[1] === 2 ? weights[1] : 0),
//     (boxes[2] === 1 ? weights[2] : 0) + (boxes[3] === 1 ? weights[3] : 0),
//     (boxes[2] === 2 ? weights[2] : 0) + (boxes[3] === 2 ? weights[3] : 0)
//   );

//   for (let i = 0; i < 4; i++) {
//     if (boxes[i] === 1 && weights[i] + (boxes[(i + 1) % 4] === 2 ? weights[(i + 1) % 4] : 0) === maxWeight) {
//       return i + 1;
//     } else if (boxes[i] === 2 && weights[i] + (boxes[(i + 1) % 4] === 1 ? weights[(i + 1) % 4] : 0) === maxWeight) {
//       return i + 1;
//     }
//   }

//   return -1;
// }

// console.log(findItemToMove([4, 2, 3, 7], [2, 1, 1, 2])); 

// function findItemToMove(weights, boxes) {
//   const box1Weight = (boxes[0] === 1 ? weights[0] : 0) + (boxes[1] === 1 ? weights[1] : 0) + (boxes[2] === 1 ? weights[2] : 0) + (boxes[3] === 1 ? weights[3] : 0);
//   const box2Weight = (boxes[0] === 2 ? weights[0] : 0) + (boxes[1] === 2 ? weights[1] : 0) + (boxes[2] === 2 ? weights[2] : 0) + (boxes[3] === 2 ? weights[3] : 0);
//   const maxWeight = Math.max(box1Weight, box2Weight);

//   for (let i = 0; i < 4; i++) {
//     if (boxes[i] === 1) {
//       const box1WithoutItem = box1Weight - weights[i];
//       const box2WithItem = box2Weight + weights[i];

//       if (Math.max(box1WithoutItem, box2WithItem) === maxWeight) {
//         return i + 1;
//       }
//     } else if (boxes[i] === 2) {
//       const box2WithoutItem = box2Weight - weights[i];
//       const box1WithItem = box1Weight + weights[i];

//       if (Math.max(box2WithoutItem, box1WithItem) === maxWeight) {
//         return i + 1;
//       }
//     }
//   }

//   return -1;
// }

// console.log(findItemToMove([4, 2, 3, 7], [2, 1, 1, 2])); 
function findItemToMove(weights, boxes) {
    const totalWeight = weights.reduce((acc, curr) => acc + curr, 0);
    const maxBoxWeight = Math.max(...boxes);

    for (let i = 0; i < weights.length; i++) {
        const newBoxWeight = totalWeight - weights[i];
        const newMaxBoxWeight = Math.max(newBoxWeight, maxBoxWeight);
        
        if (newMaxBoxWeight <= totalWeight - newBoxWeight) {
            return i + 1;
        }
    }
    
    return -1;
}

const readline = require('readline');
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout
});

let weights, boxes;
rl.question('', (weightsInput) => {
    weights = weightsInput.split(' ').map(Number);
    rl.question('', (boxesInput) => {
        boxes = boxesInput.split(' ').map(Number);
        
        const result = findItemToMove(weights, boxes);
        console.log(result);
        
        rl.close();
    });
});
