#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    
    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long max_length = 0;
    long long sum_a = 0;

    for (int i = 0; i < n; ++i) {
        sum_a += a[i];
        max_length = max(max_length, a[i]);
    }

    long long additional_colors = m - n;
    long long result = 0;

    if (additional_colors > sum_a) {
        result = max_length + (additional_colors - sum_a + n - 1) / n;
    } else {
        result = max_length;
    }

    cout << result << endl;

    return 0;
}
