#pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class T> using oset=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<class T> bool umin(T& a, const T& b){return b < a ? a = b, 1 : 0;}
template<class T> bool umax(T& a, const T& b){return a < b ? a = b, 1 : 0;}

#define sz(x) (int)(x).size()
#define int long long
#define rep(i,l,r) for(int i=l;i<=(r);++i)
#define repd(i,r,l) for(int i=r;i>=(l);--i)
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define lb lower_bound
#define ub upper_bound
#define all(x) x.begin(),x.end()
#define ins insert
#define mp make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"
#define SORT(x) {sort(all(x));x.erase(unique(all(x)),end(x));}
#define SH(x) {cout<<(#x)<<" = "<<x<<'\n';}
#define PR(x) {cout<<(#x)<<" : ";for(auto i:x)cout<<i<<' ';cout<<'\n';}
#define HR() {cout<<"here\n";}
#define LN() {cout<<"-------------\n";}

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<vi> vvi;
typedef vector<vll> vvll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

constexpr int N = 2e5 + 5;
constexpr int mod = 1e9 + 7;
constexpr int infe9 = 1e9 + 5;
constexpr ll infe18 = (ll) 1e18 + 5;

int cnt[111][111];
int need[111][111];

void solve() {
    int n, m;
    cin >> n >> m;
    map<string, int> id;
    for (int i = 0; i < m; ++i) {
        string c;
        cin >> c;
        id[c] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cnt[i][j];
        }
    }
    int q;
    cin >> q;
    for (int cq = 0; cq < q; ++cq) {
        int color;
        string c;
        cin >> color >> c; color--;
        int sz = id[c];

        if (cnt[color][sz]) {
            cnt[color][sz]--;
            continue;
        }
        {
            bool b = 0;
            for (int i = 0; i < n; ++i) {
                if (cnt[i][sz]) {
                    cnt[i][sz]--;
                    b = 1;
                    break;
                }
            }
            if (b) continue;
        }
        {
            bool b = 0;
            for (int i = sz + 1; i < m; ++i) {
                if (cnt[color][i]) {
                    cnt[color][i]--;
                    b = 1;
                    break;
                }
                bool bb = 0;
                for (int j = 0; j < n; ++j) {
                    if (cnt[j][i]) {
                        cnt[j][i]--;
                        bb = 1;
                        break;
                    }
                }
                if (bb) {
                    b = 1;
                    break;
                }
            }
            if (b) continue;
        }
        need[color][sz]++;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << cnt[i][j] << ' ';
        }
        cout << '\n';
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << need[i][j] << ' ';
        }
        cout << '\n';
    }
}

int32_t main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) solve();
}

