def find_min_max_weight_move(weights, boxes):
    total_weights = [0, 0]
    for weight, box in zip(weights, boxes):
        total_weights[box - 1] += weight

    current_max_weight = max(total_weights)

    item_to_move = -1
    new_max_weight = current_max_weight

    for i in range(len(weights)):
        weight, box = weights[i], boxes[i]

        new_box_weights = total_weights.copy()
        new_box_weights[box - 1] -= weight
        new_box_weights[1 - (box - 1)] += weight

        if max(new_box_weights) < new_max_weight:
            new_max_weight = max(new_box_weights)
            item_to_move = i + 1  
    return item_to_move

weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

item_to_move = find_min_max_weight_move(weights, boxes)

print(item_to_move)
