def залишок_біткопійок(n: int, m: int) -> int:
    """Функція розрахунку залишку біткопійок у Міс М.

    Args:
        n (int): Загальна кількість біткопійок.
        m (int): Кількість переможців.

    Returns:
        int: Залишок біткопійок у Міс М.
    """
    кількість_біткопійок_на_переможця = 3
    залишок = n - (m * кількість_біткопійок_на_переможця)
    return залишок

if __name__ == "__main__":
    # Зчитуємо введені дані
    загальна_кількість_біткопійок = int(input("Введіть кількість біткопійок: "))
    кількість_переможців = int(input("Введіть кількість переможців: "))

    # Розраховуємо та виводимо результат
    залишок = залишок_біткопійок(загальна_кількість_біткопійок, кількість_переможців)
    print(f"Залишок біткопійок у Міс М: {залишок}")