python

# Частина 4: Реалізація коду

def create_embroidery_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    # Заповнення верхнього та нижнього краю вишиванки
    for i in range(m):
        pattern[0][i] = '/'
        pattern[n - 1][i] = '\\'

    # Заповнення променів
    for i in range(1, n - 1):
        pattern[i][0] = '/'
        pattern[i][m - 1] = '\\'

    return pattern

# Введення висоти та ширини вишиванки
n, m = map(int, input().split())

# Створення та виведення орнаменту
embroidery_pattern = create_embroidery_pattern(n, m)
for row in embroidery_pattern:
    print(''.join(row))