#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

pair<ll, ll> searchmax(vector<pair<bool, ll>> a) {
	ll maxind, max = 0;
	for (ll i = 0; i < a.size(); i++) {
		if (a[i].second > max && a[i].first) {
			maxind = i;
			max = a[i].second;
		}
	}
	return { max, maxind };
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0); cin.tie(0);
	ll n, m;
	pair<ll, ll> max;
	cin >> n >> m;
	vector<pair<bool, ll>> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].second;
		a[i].first = true;
	}
	for (ll i = 1; i < m; i++) {
		max = searchmax(a);
		a[max.second].first = false;
		if (max.first % 2 != 0) {
			a.push_back({ true, (max.first - 1) / 2});
			a.push_back({ true, (max.first - 1) / 2});
		}
		else {
			a.push_back({ true, (max.first - 1) / 2});
			a.push_back({ true, max.first - 1 - a[a.size() - 1].second});
		}
	}
	max = searchmax(a);
	cout << max.first << '\n';
}