def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]
    for i in range(min(n, m)):
        if i % 2 == 0:
            ornament[i][i] = 'x'
            if i != m - 1:
                ornament[i][m - 1 - i] = 'x'
            if i != n - 1:
                ornament[n - 1 - i][i] = 'x'
        else:
            ornament[i][m - 1 - i] = 'x'
            if i != m - 1:
                ornament[i][i] = 'x'
            if i != n - 1:
                ornament[n - 1 - i][m - 1 - i] = 'x'
    return '\n'.join(''.join(row) for row in ornament)

n, m = map(int, input().split())
print(create_ornament(n, m))