#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<char>> ornament(n, vector<char>(m, '.'));

    for (int start = 0; start <= m-1; start += m-1) {
        int x = 0, y = start, dx = 1, dy = (start == 0) ? 1 : -1;

        while (x < n) {
            ornament[x][y] = 'x';
            x++;
            y += dy;

            if (y == m || y == -1) {
                dy *= -1;
                y += dy;
            }
        }
    }

    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << ornament[i][j];
        }
        cout << endl;
    }

    return 0;
}
