# Функція для знаходження номеру речі, яку потрібно перемістити
def find_item_to_move(weights, boxes):
    total_weight = [0, 0]  # ваги коробок
    for i in range(4):
        total_weight[boxes[i] - 1] += weights[i]  # додаємо вагу речі до відповідної коробки
    
    max_weight = max(total_weight)  # знаходимо максимальну вагу серед коробок
    
    for i in range(4):
        if total_weight[boxes[i] - 1] == max_weight:
            return i + 1  # повертаємо номер речі, яку потрібно перемістити

    return -1  # якщо не потрібно нічого переміщувати


# Вхідні дані
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Вивід результату
result = find_item_to_move(weights, boxes)
print(result)

