using System;

class Program
{
    static void Main()
    {
        // Зчитування вхідних даних
        string[] input = Console.ReadLine().Split();
        int n = int.Parse(input[0]);
        int m = int.Parse(input[1]);

        // Генерація орнаменту
        char[,] ornament = GenerateOrnament(n, m);

        // Виведення орнаменту
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(ornament[i, j]);
            }
            Console.WriteLine();
        }
    }

    static char[,] GenerateOrnament(int n, int m)
    {
        char[,] ornament = new char[n, m];

        // Ініціалізація орнаменту
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                ornament[i, j] = '.';
            }
        }

        // Генерація променів
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                if ((i % 3 == 0 || i % 3 == 2) && j % 2 == 0)
                {
                    ornament[i, j] = 'x';
                }
                else if (i % 3 == 1 && j % 2 == 1)
                {
                    ornament[i, j] = 'x';
                }
            }
        }

        return ornament;
    }
}
