#include <iostream>
#include <vector>

void generateOrnament(int n, int m) {
    std::vector<std::vector<char>> ornament(n, std::vector<char>(m, '.'));

    // Генерація променів
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if ((i % 2 == 0 && j % 3 == 0) || (i % 2 == 1 && j % 3 == 1)) {
                ornament[i][j] = 'x';
            }
        }
    }

    // Виведення орнаменту
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cout << ornament[i][j];
        }
        std::cout << std::endl;
    }
}

int main() {
    // Зчитування вхідних даних
    int n, m;
    std::cin >> n >> m;

    // Генерація та виведення орнаменту
    generateOrnament(n, m);

    return 0;
}
