using System;
using System.Linq;

class Program
{
    static void Main()
    {
        string[] input1 = Console.ReadLine().Split();
        int n = int.Parse(input1[0]);
        long m = long.Parse(input1[1]);

        string[] input2 = Console.ReadLine().Split();
        long[] colors = new long[n];
        for (int i = 0; i < n; i++)
        {
            colors[i] = long.Parse(input2[i]);
        }

        // Визначимо максимальну довжину підпослідовності
        long maxLength = 0;

        // Для кожного кольору визначимо його вагу
        long[] weights = colors.Select(color => Math.Min(color, color + 1) / 2).ToArray();

        // Додаємо ваги для початкових кольорів
        maxLength += weights.Sum();

        // Рахуємо максимальну довжину підпослідовності для залишку (m+n)-го кольору
        long remainingLength = Math.Max(m + n - 1 - colors.Length, 0);
        maxLength += Math.Min(remainingLength, weights.Sum() / 2);

        // Виводимо результат
        Console.WriteLine(maxLength);
    }
}
