def max_unmarked_sequence(n, m, a):
    if m >= sum(a):
        return max(a)
    
    l = 0
    r = 10**18
    
    while l < r:
        mid = (l + r + 1) // 2
        count = 0
        for i in range(n):
            count += min(a[i], mid)
        if count <= m:
            l = mid
        else:
            r = mid - 1

    return l

# Reading input values
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the maximum length of the sequence of unmarked colors
result = max_unmarked_sequence(n, m, a)
print(result)
