n, m = map(int, input().split())
a = list(map(int, input().split()))

# Function to find the maximum length of unmarked colors
def max_unmarked_length(a, m):
    a.sort(reverse=True)  # Sort the color wheels in descending order
    l = a[0] - 1  # Initial longest sequence of unmarked colors
    for i in range(1, n):
        l = min(l, a[i] - 1)  # Update longest sequence based on color wheels

    remaining = m - n  # Remaining colors to select after initial colors
    if remaining <= 0:
        return max(l, 0)

    # Subtract the number of colors taken from each wheel
    for i in range(n):
        if a[i] - 1 > l:
            remaining -= (a[i] - 1 - l)

    return l - (remaining // n) - (remaining % n > 0)

result = max_unmarked_length(a, m)
print(result)
