using System;

class Program
{
    static void Main()
    {
       
        string[] weightsInput = Console.ReadLine().Split();
        int[] weights = Array.ConvertAll(weightsInput, int.Parse);

    
        string[] boxesInput = Console.ReadLine().Split();
        int[] boxes = Array.ConvertAll(boxesInput, int.Parse);

     
        int moveItem = FindMoveItem(weights, boxes);


        Console.WriteLine(moveItem);
    }

    static int FindMoveItem(int[] weights, int[] boxes)
    {
        int sumBox1 = 0;
        int sumBox2 = 0;

        for (int i = 0; i < 4; i++)
        {
            if (boxes[i] == 1)
                sumBox1 += weights[i];
            else
                sumBox2 += weights[i];
        }

        for (int i = 0; i < 4; i++)
        {
            if (boxes[i] == 1 && sumBox1 - weights[i] == sumBox2)
                return i + 1;
            else if (boxes[i] == 2 && sumBox2 - weights[i] == sumBox1)
                return i + 1;
        }

        return -1;
    }
}
