def process_gifts(n, m, sizes, stock, k, orders):
    remaining_stock = [row.copy() for row in stock]
    additional_orders = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = int(orders[i][0]) - 1, sizes.index(orders[i][1])

        for new_size in range(size, m):
            if remaining_stock[color][new_size] > 0:
                remaining_stock[color][new_size] -= 1
                break
        else:
            for new_color in range(n):
                if remaining_stock[new_color][size] > 0:
                    remaining_stock[new_color][size] -= 1
                    break
            else:
                additional_orders[color][size] += 1

    return remaining_stock, additional_orders

def main():
    n, m = map(int, input().split())
    sizes = input().split()
    stock = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    orders = [input().split() for _ in range(k)]

    remaining_stock, additional_orders = process_gifts(n, m, sizes, stock, k, orders)

    for row in remaining_stock:
        print(*row)

    for row in additional_orders:
        print(*row)

if __name__ == "__main__":
    main()
    