using System;
using System.Collections.Generic;
using System.Linq;

class Program
{
    static void Main()
    {
        int n, m;
        string[] sizes;
        string[] input = Console.ReadLine().Split();
        n = int.Parse(input[0]);
        m = int.Parse(input[1]);
        sizes = Console.ReadLine().Split();
        int[,] t = new int[n, m];
        for (int i = 0; i < n; i++)
        {
            int[] row = Console.ReadLine().Split().Select(int.Parse).ToArray();
            for (int j = 0; j < m; j++)
            {
                t[i, j] = row[j];
            }
        }
        int k = int.Parse(Console.ReadLine());
        List<Tuple<int, string>> winnersRequests = new List<Tuple<int, string>>();
        for (int i = 0; i < k; i++)
        {
            string[] request = Console.ReadLine().Split();
            int colorIndex = int.Parse(request[0]) - 1;
            string size = request[1];
            winnersRequests.Add(new Tuple<int, string>(colorIndex, size));
        }
        List<int[,]> remaining = new List<int[,]>();
        for (int i = 0; i < n; i++)
        {
            remaining.Add(new int[1, m]);
        }
        List<int[,]> toOrder = new List<int[,]>();
        for (int i = 0; i < n; i++)
        {
            toOrder.Add(new int[1, m]);
        }

        foreach (var request in winnersRequests)
        {
            int colorIndex = request.Item1;
            string size = request.Item2;

            bool found = false;

            for (int i = 0; i < m; i++)
            {
                if (sizes[i] == size && t[colorIndex, i] > 0)
                {
                    t[colorIndex, i]--;
                    remaining[colorIndex][0, i]++;
                    found = true;
                    break;
                }
            }

            
            if (!found)
            {
                for (int i = 0; i < m; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (sizes[i] == size && t[j, i] > 0)
                        {
                            t[j, i]--;
                            remaining[j][0, i]++;
                            found = true;
                            break;
                        }
                    }
                    if (found) break;
                }
            }

           
            if (!found)
            {
                for (int i = Array.IndexOf(sizes, size) + 1; i < m; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (t[j, i] > 0)
                        {
                            t[j, i]--;
                            remaining[j][0, i]++;
                            found = true;
                            break;
                        }
                    }
                    if (found) break;
                }
            }

           
            while (!found)
            {
                for (int i = 0; i < m; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (t[j, i] > 0)
                        {
                            t[j, i]--;
                            remaining[j][0, i]++;
                            found = true;
                            break;
                        }
                    }
                    if (found) break;
                }
            }
        }

        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(remaining[i][0, j] + " ");
            }
            Console.WriteLine();
        }

        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(toOrder[i][0, j] + " ");
            }
            Console.WriteLine();
        }
    }
}