#include <iostream>
#include <algorithm>


int gcd(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}


int lcm(int a, int b) {
    return (a * b) / gcd(a, b);
}


int max_passes(int n, int m) {
    return lcm(n, m) / n;
}

int main() {

    int n, m;
    std::cin >> n >> m;


    std::cout << max_passes(n, m) << std::endl;

    return 0;
}
