#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;


    vector<long long> a(n);
    

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }


    sort(a.begin(), a.end());


    long long max_sequence = 0;


    for (int i = 0; i < n; ++i) {

        long long remaining = a[i] - 1;
        

        long long take = min(remaining, (long long)m);
        

        max_sequence = max(max_sequence, a[i] - take);


        m -= take;

        if (m == 0) break;
    }


    cout << max_sequence + m / n << endl;

    return 0;
}
