from itertools import combinations

def solve():
    w = list(map(int, input().split()))
    t = list(map(int, input().split()))
    min_diff = float('inf')
    item_to_move = -1
    for i in range(1, 2**4):
        box1 = [w[j] for j in range(4) if (i & (1 << j)) != 0]
        box2 = [w[j] for j in range(4) if (i & (1 << j)) == 0]
        diff = abs(sum(box1) - sum(box2))
        if diff < min_diff:
            min_diff = diff
            item_to_move = i
    if item_to_move == -1:
        print(-1)
    else:
        for i in range(4):
            if ((item_to_move & (1 << i)) != 0) != (t[i] == 1):
                print(i + 1)
                break

solve()