def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][0] = 'x'
        ornament[0][i] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print("".join(row))

def main():
    n, m = map(int, input().split())
    ornament = create_ornament(n, m)
    
    # Additional logic to handle reflected rays
    for i in range(1, min(n, m)):
        ornament[i][i] = 'x'
        ornament[i][0] = '.'
        ornament[0][i] = '.'

    print_ornament(ornament)

if __name__ == "__main__":
    main()
