n, m = map(int, input().split())
vishivanka = [["." for j in range(m)] for i in range(n)]
vishivanka[0][0] = "x"
vishivanka[0][m-1] = "x"

def get_next_j(j, direction):
    if direction == "right":
        return j + 1 if j + 1 < m else j - 1
    else:
        return j - 1 if j - 1 >= 0 else j + 1

direction1, direction2 = "right", "left"
for i in range(1, n):
    j1 = vishivanka[i-1].index("x")
    j2 = vishivanka[i-1].index("x", j1+1)

    j1_new = get_next_j(j1, direction1)
    j2_new = get_next_j(j2, direction2)

    vishivanka[i][j1_new] = "x"
    vishivanka[i][j2_new] = "x"

    direction1 = "left" if j1_new == j1 else "right"
    direction2 = "left" if j2_new == j2 else "right"

for row in vishivanka:
    print("".join(row))