def print_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]
    ornament[0][0] = 'x'
    ornament[0][m - 1] = 'x'

    j1, j2 = 1, m - 2
    for i in range(1, n):
        ornament[i][j1] = 'x'
        ornament[i][j2] = 'x'
        
        j1 = (j1 + 2) % m
        j2 = (j2 - 2) % m

    for row in ornament:
        print(''.join(row))

n, m = map(int, input().split())
print_ornament(n, m)