def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0

    max_value = max(a)

    for _ in range(m):
        mid = (max_value - max_value % 2) // 2
        max_value = max(mid, max_value - mid)

    return max_value

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)
