def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    max_val = max(a)
    left, right = 1, max_val
    
    while left < right:
        mid = (left + right + 1) // 2
        count = sum(min(ai, mid * 2 - 1) for ai in a)
        
        if count > m:
            right = mid - 1
        else:
            left = mid

    return left

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)
