import heapq

def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    max_sequence = max(a)
    remaining_unmarked_colors = total_length + m - n

    if remaining_unmarked_colors % 2 == 1:
        max_sequence = max(max_sequence, remaining_unmarked_colors)
    else:
        max_sequence = max(max_sequence, remaining_unmarked_colors + 1)

    return max_sequence

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)
