w = list(map(int, input().split())) # ваги кожної з чотирьох речей
t = list(map(int, input().split())) # номери коробок, у яких лежать відповідні речі

# Обчислення
# Знаходимо сумарну вагу кожної коробки
s1 = 0 # сумарна вага першої коробки
s2 = 0 # сумарна вага другої коробки
for i in range(4):
    if t[i] == 1:
        s1 += w[i]
    else:
        s2 += w[i]

# Знаходимо максимальну вагу коробки
m = max(s1, s2) # максимальна вага коробки

# Знаходимо номер речі, яку потрібно перемістити в іншу коробку
p = -1 # номер речі, яку потрібно перемістити
for i in range(4):
    # Якщо річ лежить в першій коробці, то перевіряємо, чи зменшиться максимальна вага, якщо перемістити її в другу
    if t[i] == 1:
        # Якщо сумарна вага першої коробки без цієї речі менша за сумарну вагу другої коробки з цією річчю, то це означає, що максимальна вага зменшиться
        if s1 - w[i] < s2 + w[i]:
            # Якщо максимальна вага зменшиться більше, ніж при попередніх варіантах, то запам'ятовуємо номер цієї речі
            if m - (s2 + w[i]) > m - max(s1 - w[i], s2 + w[i]):
                p = i + 1
                m = max(s1 - w[i], s2 + w[i])
    # Якщо річ лежить в другій коробці, то перевіряємо, чи зменшиться максимальна вага, якщо перемістити її в першу
    else:
        # Якщо сумарна вага другої коробки без цієї речі менша за сумарну вагу першої коробки з цією річчю, то це означає, що максимальна вага зменшиться
        if s2 - w[i] < s1 + w[i]:
            # Якщо максимальна вага зменшиться більше, ніж при попередніх варіантах, то запам'ятовуємо номер цієї речі
            if m - (s1 + w[i]) > m - max(s2 - w[i], s1 + w[i]):
                p = i + 1
                m = max(s2 - w[i], s1 + w[i])

# Вихідні дані
print(p) # виведення результату
