#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] = -a[i]; 
    }

    make_heap(a.begin(), a.end()); 

    for (int i = 0; i < m - 1; ++i) {
        int longest_sequence = -a.front(); 
        pop_heap(a.begin(), a.end()); 
        a.pop_back(); 

        int smaller_sequence1 = longest_sequence / 2;
        int smaller_sequence2 = longest_sequence - 1 - smaller_sequence1;

        a.push_back(-smaller_sequence1); 
        push_heap(a.begin(), a.end()); 
        a.push_back(-smaller_sequence2); 
        push_heap(a.begin(), a.end()); 
    }

    int max_length = -a.front(); 
    cout << max_length << endl;

    return 0;
}