#include <queue>
#include <iostream>

using namespace std;

struct Compare {
    bool operator() (const long long& a, const long long& b) {
        return a < b;
    }
};

int main() {
    int n;
    long long m;
    cin >> n >> m;
    
    priority_queue<long long, vector<long long>, Compare> pq;
    
    for (int i = 0; i < n; i++) {
        long long ai;
        cin >> ai;
        pq.push(ai);
    }
    
    for (long long i = 0; i < m-1; i++) {
        long long longest_sequence = pq.top();
        pq.pop();
        long long smaller_sequence1 = longest_sequence / 2;
        long long smaller_sequence2 = longest_sequence - 1 - smaller_sequence1;
        pq.push(smaller_sequence1);
        pq.push(smaller_sequence2);
    }
    
    cout << pq.top() << endl;
    
    return 0;
}
