n = int(input())

participants = []
for _ in range(n):
    data = input().split()
    participant = {
        "id": int(data[0]),
        "gender": data[1],
        "grade": int(data[2]),
        "age": int(data[3]),
        "score": int(data[4])
    }
    participants.append(participant)

participants.sort(key=lambda x: x["score"], reverse=True)

m = int(input())
olympiads = []
for _ in range(m):
    olympiads.append(input())

for olympiad in olympiads:
    selected = []

    if olympiad == "IOI" or olympiad == "CEOI":
        selected = [p["id"] for p in participants[:4]]

    elif olympiad == "EGOI":
        girls = [p for p in participants if p["gender"] == "female"]
        selected = [p["id"] for p in girls[:4]]

    elif olympiad == "EJOI":
        young = [p for p in participants if p["age"] <= 15]
        selected = [p["id"] for p in young[:4]]

    elif olympiad == "BaltOI":
        selected = [p["id"] for p in participants[:6]]

    elif olympiad == "BalkOI":
        grades = [p for p in participants if p["grade"] != 11]
        selected = [p["id"] for p in grades[:4]]

    elif olympiad == "JBOI":
        grades = [p for p in participants if p["grade"] not in [10, 11]]
        selected = [p["id"] for p in grades[:4]]

    selected.sort()
    print(olympiad, *selected)
    