#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<char>> embroidery(n, vector<char>(m, '.'));

    // Create the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i == 0 || j == 0 || i == n - 1 || j == m - 1) {
                // Draw border
                embroidery[i][j] = '*';
            } else if (i == j || i + j == m - 1) {
                // Draw rays
                embroidery[i][j] = '*';
            }
        }
    }

    // Output the ornament
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << embroidery[i][j];
        }
        cout << '\n';
    }

    return 0;
}


