#include <iostream>

void createPattern(int n, int m) {
    char pattern[n][m];

    // Заповнення матриці крапками
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            pattern[i][j] = '.';
        }
    }

    // Зміна крапок на 'x' відповідно до умови
    for (int i = 0; i < std::min(n, m); ++i) {
        pattern[i][0] = 'x'; // Ліва верхня грань
        pattern[0][i] = 'x'; // Верхня горизонталь
        pattern[i][m - 1 - i] = 'x'; // Права верхня грань
        pattern[n - 1 - i][i] = 'x'; // Нижня горизонталь
    }

    // Вивід матриці орнаменту
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << pattern[i][j];
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    createPattern(n, m);

    return 0;
}

