import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        long m = scanner.nextLong();
        long[] a = new long[n];

        for (int i = 0; i < n; i++) {
            a[i] = scanner.nextLong();
        }

        // Знаходимо максимальну довжину підвідрізку незакреслених кольорів
        long maxLength = 0;
        for (int i = 1; i < n; i++) {
            maxLength = Math.max(maxLength, a[i] - a[i - 1] - 1);
        }

        // Визначаємо, скільки кольорів залишиться після вибору (m+n)-го коліра
        long remainingColors = maxLength - m;

        // Обчислюємо максимальну довжину підвідрізку незакреслених кольорів перед вибором (m+n)-го коліра
        long result = a[0] + remainingColors;

        System.out.println(result);
    }
}
