from heapq import heapify, heappop, heappush

def solve(n, m, a_values):
    heap = [-a_values[i] for i in range(n)]
    heapify(heap)

    for _ in range(m):
        max_value = -heappop(heap)
        remaining = max_value // 2
        heappush(heap, -remaining)
    
    return -max(heap)

n, m = map(int, input().split())
a_values = list(map(int, input().split()))

result = solve(n, m, a_values)
print(result)
