#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<int> w(4), t(4);

    // Input weights of items
    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }

    // Input box numbers for each item
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    int maxWeight = INT_MIN, moveIndex = -1;

    // Iterate through each item to simulate moving
    for (int i = 0; i < 4; ++i) {
        // Simulate moving the item to the other box
        t[i] = 3 - t[i]; // Switch the box number

        // Calculate the maximum weight of the two boxes
        int curMaxWeight = max(w[t[0] - 1] + w[t[1] - 1], w[t[2] - 1] + w[t[3] - 1]);

        // Update moveIndex if the current move results in a smaller maximum weight
        if (curMaxWeight < maxWeight) {
            maxWeight = curMaxWeight;
            moveIndex = i;
        }

        // Switch back to the original box number for the next iteration
        t[i] = 3 - t[i];
    }

    cout << moveIndex + 1 << "\n"; // Output 1-indexed item to move

    return 0;
}
