#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> availableTshirts(n, vector<int>(m));
    vector<vector<int>> requestedTshirts(n, vector<int>(m, 0));

    // Input available T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> availableTshirts[i][j];
        }
    }

    // Input number of winners
    int k;
    cin >> k;

    // Process winners' requests
    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;
        int sizeIndex = s - 'A';

        // Check if the requested T-shirt is available
        if (availableTshirts[c - 1][sizeIndex] > 0) {
            availableTshirts[c - 1][sizeIndex]--;
        } else {
            // Find an alternative T-shirt based on Miss M's algorithm
            for (int size = sizeIndex + 1; size < m; ++size) {
                for (int color = 0; color < n; ++color) {
                    if (availableTshirts[color][size] > 0) {
                        availableTshirts[color][size]--;
                        requestedTshirts[c - 1][sizeIndex]++;
                        break;
                    }
                }
            }
        }
    }

    // Output remaining T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << availableTshirts[i][j] << " ";
        }
        cout << "\n";
    }

    // Output missing T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << requestedTshirts[i][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}
