#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    return a.score > b.score;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        int teamSize;
        if (olympiad == "IOI" || olympiad == "CEOI") {
            teamSize = 4;
        } else if (olympiad == "EGOI" || olympiad == "EJOI") {
            teamSize = 4;
        } else if (olympiad == "BaltOI") {
            teamSize = 6;
        } else {
            teamSize = 4;
        }

        vector<Participant> team;
        for (int j = 0; j < min(teamSize, n); ++j) {
            if ((olympiad == "EGOI" && participants[j].gender == "female") ||
                (olympiad == "EJOI" && participants[j].age <= 15) ||
                (olympiad == "BalkOI" && participants[j].grade != 11) ||
                (olympiad == "JBOI" && participants[j].grade < 10)) {
                team.push_back(participants[j]);
            }
        }

        cout << olympiad << " Team:\n";
        for (const auto& participant : team) {
            cout << participant.id << " ";
        }
        cout << "\n";
    }

    return 0;
}

