#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> colors(n);

    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    int m;
    cin >> m;

    vector<bool> used(n, false);
    int maxUncut = 0;

    for (int i = 0; i < m; ++i) {
        int length = 0;
        int start = 0;

        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                length++;

                if (length % 2 == 0) {
                    used[start + length / 2 - 1] = true;
                } else {
                    used[start + length / 2] = true;
                }
            } else {
                start = j + 1;
                length = 0;
            }
        }

        maxUncut = max(maxUncut, length);
    }

    cout << maxUncut << '\n';

    return 0;
}
