#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    int64_t m;
    cin >> n >> m;

    vector<int64_t> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int64_t totalColors = accumulate(a.begin(), a.end(), 0LL);

    if (m >= totalColors) {
        cout << totalColors << "\n";
        return 0;
    }

    int64_t maxSubsegment = 0;
    for (int i = 0; i < n; ++i) {
        int64_t remainingColors = totalColors - a[i];
        int64_t colorsToChoose = min(m, remainingColors);
        int64_t currentSubsegment = (a[i] - colorsToChoose) / 2 + colorsToChoose;
        maxSubsegment = max(maxSubsegment, currentSubsegment);
    }

    cout << maxSubsegment + m << "\n";

    return 0;
}

