#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    long long m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long max_length = 0;

    // Iterate through each colored circle
    for (int i = 0; i < n; ++i) {
        long long remaining_colors = m;
        long long length = 0;

        // Simulate the process of choosing colors
        for (int j = 0; j < n; ++j) {
            long long colors_in_circle = a[(i + j) % n];
            long long available_colors = min(colors_in_circle, remaining_colors);

            // Update the length of the current subsegment
            length += 2 * available_colors - (available_colors > 0);

            // Update remaining colors
            remaining_colors -= available_colors;

            // Break if all colors are used
            if (remaining_colors == 0) break;
        }

        // Update the maximum length
        max_length = max(max_length, length);
    }

    cout << max_length << "\n";

    return 0;
}
