import java.util.Scanner;

public class BirthdayComparison {
    public static void main(String[] args) {
        try {
            // Створюємо об'єкт Scanner для зчитування введених даних
            Scanner scanner = new Scanner(System.in);

            // Зчитуємо день та місяць за Байтуліанським календарем
            System.out.print("Введіть день та місяць за Байтуліанським календарем (через пробіл): ");
            int d1 = scanner.nextInt();
            int m1 = scanner.nextInt();

            // Зчитуємо день та місяць за Бітуліанським календарем
            System.out.print("Введіть день та місяць за Бітуліанським календарем (через пробіл): ");
            int d2 = scanner.nextInt();
            int m2 = scanner.nextInt();

            // Викликаємо функцію порівняння дат та виводимо результат
            if (compareDates(d1, m1, d2, m2)) {
                System.out.println("Same birthday!");
            } else {
                System.out.println("Not the same");
            }

            // Закриваємо Scanner
            scanner.close();

        } catch (Exception e) {
            System.out.println("Некоректні дані. Будь ласка, введіть цілі числа для дня та місяця.");
        }
    }

    // Функція порівняння дат
    private static boolean compareDates(int d1, int m1, int d2, int m2) {
        return d1 == d2 && m1 == m2;
    }
}
