import java.util.Scanner;

public class Main
{
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Зчитування висоти та ширини вишиванки
        int n = scanner.nextInt();
        int m = scanner.nextInt();

        // Створення орнаменту
        char[][] ornament = createOrnament(n, m);

        // Виведення результату
        printOrnament(ornament);

        // Закриваємо Scanner
        scanner.close();
    }

    private static char[][] createOrnament(int n, int m) {
        char[][] ornament = new char[n][m];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if ((i + j) % 2 == 0) {
                    ornament[i][j] = 'x';
                } else {
                    ornament[i][j] = '.';
                }
            }
        }

        return ornament;
    }

    private static void printOrnament(char[][] ornament) {
        for (char[] row : ornament) {
            for (char cell : row) {
                System.out.print(cell);
            }
            System.out.println();
        }
    }
}