import java.util.Scanner;

public class CrossStitchPattern {

    public static void printPattern(int n, int m) {
        char[][] pattern = new char[n][m];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if ((i + j) % 2 == 0 || (i - j) % 2 == 0) {
                    pattern[i][j] = 'x';
                } else {
                    pattern[i][j] = '.';
                }
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(pattern[i][j]);
            }
            System.out.println();
        }
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int m = scanner.nextInt();

        printPattern(n, m);
    }
}
