def read_input():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    return n, m, a

def find_max_sequence_length(n, m, a):
    max_length = 0
    while m > 0:
        max_length_current = 0
        for i in range(n):
            length = 0
            while a[i] > 0:
                length += 1
                i = (i + 1) % n
                a[i] -= 1
            max_length_current = max(max_length_current, length)
        max_length = max(max_length, max_length_current)
        m -= 1
    return max_length

def main():
    n, m, a = read_input()
    max_length = find_max_sequence_length(n, m, a)
    print(max_length)

if __name__ == "__main__":
    main()
