# def get_slice(matrix, start_row, end_row, start_col, end_col):
#     return [row[start_col:end_col] for row in matrix[start_row:end_row]]

def get_columns_to_right(matrix, start_column):
     return [row[start_column:] for row in matrix]

def column(matrix, i):
    return [row[i] for row in matrix]

def find(col, size, available):
    if available[col][size]:
        return True, col, size

    elif any(column(available, size)):
        for new_col in range(colours_n):
            if available[new_col][size]: 
                return True, new_col, size

    elif any(any(row) for row in get_columns_to_right(available, size+1)):
        for new_size in range(size+1, sizes_n):
            if available[col][new_size]: 
                return True, col, new_size
            elif any(column(available, new_size)):
                for new_col in range(colours_n):
                    if available[new_col][new_size]: 
                        return True, new_col, new_size

    else:
        return False, col, size


colours_n, sizes_n = map(int, input().split())
colours_list = list(map(str, input().split()))

available = []
for _ in range(colours_n):
    available.append(list(map(int, input().split())))

winners_n = int(input())

needed = [[0]*sizes_n for x in range(colours_n)]
for _ in range(winners_n):
    s = input().split()
    s[1] = colours_list.index(s[1])
    col, size = map(int, s)
    col -= 1
    is_found, new_col, new_size = find(col, size, available)
    if is_found:
        available[new_col][new_size] -= 1
    else:
        needed[new_col][new_size] += 1
        



for row in available:
    print(*row)
    
for row in needed:
    print(*row)
