#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants;
    for (int i = 0; i < n; i++) {
        Participant p;
        cin >> p.id >> p.gender >> p.grade >> p.age >> p.score;
        participants.push_back(p);
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    for (int i = 0; i < m; i++) {
        string olympiad;
        cin >> olympiad;

        int teamSize;
        if (olympiad == "IOI" || olympiad == "CEOI") {
            teamSize = 4;
        } else if (olympiad == "EGOI" || olympiad == "EJOI") {
            teamSize = 4;
        } else if (olympiad == "BaltOI") {
            teamSize = 6;
        } else {
            teamSize = 4;
        }

        vector<int> teamMembers;
        for (const auto &participant : participants) {
            if ((olympiad == "EGOI" && participant.gender == "female") ||
                (olympiad == "EJOI" && participant.age <= 15) ||
                (olympiad == "BalkOI" && participant.grade != 11) ||
                (olympiad == "JBOI" && participant.grade < 10)) {
                teamMembers.push_back(participant.id);
            }
        }

        cout << olympiad << "\n";
        for (int j = 0; j < min((int)teamMembers.size(), teamSize); j++) {
            cout << teamMembers[j] << "\n";
        }
    }

    return 0;
}
