class Person:

    def __init__(self, pid, gender, grade, age, score):
        self.pid = int(pid)
        self.gender = gender
        self.grade = int(grade)
        self.age = int(age)
        self.score = int(score)


def get_inputs() -> dict:
    """Get input data, return dict"""
    participant_count = int(input())
    participants = []
    for _ in range(participant_count):
        participant = Person(*input().split())
        participants.append(participant)

    olympiad_count = int(input())
    olympiads = []
    for _ in range(olympiad_count):
        olympiads.append(input())

    data = {"participants": participants, "olympiads": olympiads}
    return data


data = get_inputs()
for olympiad in data["olympiads"]:
    if "IOI" in olympiad:
        winners = sorted(data["participants"][::], key=lambda x: x.score, reverse=True)
        print("IOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))