import re

def get_inputs() -> dict:
    """Get input data, return dict"""
    wheel_count, color_count = list(map(int, input().split()))
    wheels = list(map(int, input().split()))

    data = {"colors": color_count, "wheels": wheels}
    return data


data = {"colors": 3, "wheels": [11]}
wheel = ["0"] * data["wheels"][0]

for _ in range(data["colors"]):
    wheel = re.split("[^0]", "".join(list(map(str, wheel))))
    wheel = sorted(wheel, key=len, reverse=True)
    
    element = list(wheel[0])
    element[len(element)//2] = "1"
    wheel[0] = "".join(element)
    wheel = "1".join(wheel)

print(len(element))
