colors, sizes = map(int, input().split())

delivered_sizes = list(input().split())
shirts_by_colors = [[0 for _ in range(sizes)] for _ in range(colors)]

for i in range(colors):
    t = list(map(int, input().split()))
    for size in range(sizes):
        shirts_by_colors[i][size] += t[size]

k = int(input())
required = []
# Color | Size
unsatisfied = []

for i in range(k):
    color, size = input().split()
    required.append((int(color)-1, delivered_sizes.index(size)))
required.reverse()


# GIVING SHIRTS
rev_count = list(range(len(required)))
rev_count.reverse()
for winner_id in rev_count:
    winner = required[winner_id]
    to_continue = False

    # In case we have both color AND size
    if shirts_by_colors[winner[0]][winner[1]] > 0:
        shirts_by_colors[winner[0]][winner[1]] -= 1
        required.pop()
        to_continue = True

    if to_continue:
        continue

    # In case we don`t have color BUT have size
    for col_id in range(len(shirts_by_colors)):
        if shirts_by_colors[col_id][winner[1]] > 0:
            shirts_by_colors[col_id][winner[1]] -= 1
            required.pop()
            to_continue = True
            break

    if to_continue:
        continue

    # In case we have color(or not) BUT don`t have size
    for size_id in range(winner[1], sizes):
        if shirts_by_colors[winner[0]][size_id] > 0:
            shirts_by_colors[winner[0]][size_id] -= 1
            required.pop()
            to_continue = True
            break
        for col_id in range(len(shirts_by_colors)):
            if shirts_by_colors[col_id][size_id] > 0:
                shirts_by_colors[col_id][size_id] -= 1
                required.pop()
                to_continue = True
                break
        if to_continue:
            break

    if to_continue:
        continue

    unsatisfied.append(winner)


for col in shirts_by_colors:
    for sym in col:
        print(sym, end=' ')
    print()

requested = [[0 for _ in range(sizes)] for _ in range(colors)]
for sad in unsatisfied:
    requested[sad[0]][sad[1]] += 1

for col in requested:
    for sym in col:
        print(sym, end=' ')
    print()
#
# print(required)
