#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    vector<int> weights(4);
    vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    int box1_weight = 0, box2_weight = 0;
    int item_to_move = -1;
    int max_weight = max(box1_weight, box2_weight);

    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            int temp_box1_weight = box1_weight - weights[i];
            int temp_box2_weight = box2_weight + weights[i];
            int temp_max_weight = max(temp_box1_weight, temp_box2_weight);

            if (temp_max_weight < max_weight) {
                max_weight = temp_max_weight;
                item_to_move = i + 1;
            }
        }
    }

    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 2) {
            int temp_box1_weight = box1_weight + weights[i];
            int temp_box2_weight = box2_weight - weights[i];
            int temp_max_weight = max(temp_box1_weight, temp_box2_weight);

            if (temp_max_weight < max_weight) {
                max_weight = temp_max_weight;
                item_to_move = i + 1;
            }
        }
    }

    cout << item_to_move << endl;

    return 0;
}