def main():
    n, m = map(int, input().split())
    sizes = input().split()

    available = []
    for _ in range(n):
        available.append(list(map(int, input().split())))

    winners_count = int(input())

    needed = [[0] * m for _ in range(n)]
    for _ in range(winners_count):
        color, size = input().split()
        size_index = sizes.index(size)
        color_index = int(color) - 1

        if available[color_index][size_index] > 0:
            available[color_index][size_index] -= 1
        else:
            found = False
            for i in range(size_index + 1, m):
                if available[color_index][i] > 0:
                    available[color_index][i] -= 1
                    needed[color_index][size_index] += 1
                    found = True
                    break

            if not found:
                for i in range(color_index + 1, n):
                    for j in range(m):
                        if available[i][j] > 0:
                            available[i][j] -= 1
                            needed[i][j] += 1
                            found = True
                            break
                    if found:
                        break

    # Output
    for row in available:
        print(' '.join(map(str, row)))

    for row in needed:
        print(' '.join(map(str, row)))


if __name__ == "__main__":
    main()