def max_subarray_length(n, m, colors):
    # Визначення підвідрізків незакреслених кольорів перед вибором (m+1)-го кольору
    diff = [colors[0] - 1]  # Різниця між кольорами
    for i in range(1, n):
        diff.append(colors[i] - colors[i - 1] - 1)
    
    left = 0
    right = max(diff)  # Максимальна різниця
    result = 0
    
    # Бінарний пошук максимальної довжини підвідрізку перед вибором (m+1)-го коліру
    while left <= right:
        mid = (left + right) // 2
        cnt = 0
        for d in diff:
            cnt += d // mid
        if cnt >= m:
            result = mid
            left = mid + 1
        else:
            right = mid - 1
    
    return result

# Зчитування вхідних даних
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Виведення результату
print(max_subarray_length(n, m, colors))