def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][i] = '*'
        ornament[i][m - i - 1] = 'xx'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Зчитуємо вхідні дані
n, m = map(int, input().split())

# Створюємо та виводимо орнамент
ornament = create_ornament(n, m)
print_ornament(ornament)