def find_max_subsegment_length(n, m, a):
    colors = [(ai + 1) for ai in a]  # отримуємо кількість кольорів на кожному колі
    colors.sort(reverse=True)  # сортуємо кольори у порядку спадання
    total_colors = sum(colors)  # загальна кількість кольорів
    remaining_colors = total_colors  # кількість залишених кольорів

    while m > 0:
        max_color = colors[0]  # беремо найбільший доступний кільор
        colors.pop(0)  # видаляємо його зі списку кольорів
        remaining_colors -= max_color  # віднімаємо вибраний кількість кольорів
        m -= 1  # зменшуємо лічильник залишених кольорів

    # Додаємо кількість кольорів в середині підвідрізку, якщо вона парна
    if remaining_colors % 2 == 0:
        remaining_colors += 1

    return total_colors - remaining_colors

# Зчитуємо вхідні дані
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Виводимо результат
result = find_max_subsegment_length(n, m, a)
print(result)
