#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll n, m;
    cin >> n >> m;
    vector<ll> v;
    map<ll, ll, greater<ll>> map_l;
    for (ll i = 0; i < n; i++)
    {
        ll inp; cin >> inp;
        map_l[inp]++;
    }
    auto begin_ptr = map_l.begin();
    while (m > begin_ptr->second)
    {
        if (begin_ptr->first % 2 == 1)
        {
            map_l[begin_ptr->first / 2] += begin_ptr->second * 2;
        }
        else
        {
            map_l[begin_ptr->first / 2] += begin_ptr->second;
            map_l[begin_ptr->first / 2 - 1] += begin_ptr->second;
        }
        m -= begin_ptr->second;
        map_l.erase(begin_ptr->first);
        begin_ptr = map_l.begin();
    }
    cout << begin_ptr->first;
}