#include <bits/stdc++.h>
using namespace std;
using ll = unsigned long long;
const int inf = 1e2 + 5;

map<ll, bool> vis[inf];

void dfs(ll v, int& i){
    vis[i][v] = true;
    if (v < 3) return;
    ll a = (v - 1) / 2, b = v / 2;
    if (!vis[i][a]) dfs(a, i);
    if (!vis[i][b]) dfs(b, i);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n; ll m; cin>>n>>m;
    vector<ll> u(n + 1);
    ll maxi = 0;
    for (int i = 1; i <= n; i++){
        cin>>u[i];
        maxi = max(maxi, u[i]);
        dfs(u[i], i);
    }
    map<ll, int> cnt[n + 1];
    for (int i = 1; i <= n; i++){
        cnt[i][u[i]] = 1;
        auto q = vis[i].end(); q--; 
        while (true){
            ll v = (*q).first;
            if (v != u[i]) cnt[i][v] = cnt[i][2 * v] + 2 * cnt[i][2 * v + 1] + cnt[i][2 * v + 2];
            if (q == vis[i].begin()) break;
            q--;
        }
    }
    ll l = 1, r = maxi;
    while (l + 1 < r){
        ll mid = (l + r) / 2, sum = 0;
        for (int i = 1; i <= n; i++){
            auto mp = cnt[i].lower_bound(mid);
            while (mp != cnt[i].end()){
                sum += (*mp++).second;
            }
        }
        if (sum >= m + n - 1){
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll s1 = 0;
    for (int i = 1; i <= n; i++){
        s1 += cnt[i][l];
    }
    ll s2 = 0;
    for (int i = 1; i <= n; i++){
        s2 += cnt[i][r];
    }
    if (s1) cout<<l;
    else cout<<r;
}
