def check(mid, a, m):
    n = len(a)
    count = 0
    prev_color = 0

    for color in a:
        count += (color - prev_color - 1) // mid
        prev_color = color

    count += (m - prev_color) // mid

    return count >= n


def find_max_length(n, m, a):
    left, right = 1, m + n  # визначаємо інтервал для бінарного пошуку

    while left < right:
        mid = (left + right + 1) // 2  # середина інтервалу
        if check(mid, a, m):
            left = mid
        else:
            right = mid - 1

    return left


# Зчитування вхідних даних
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Знаходження та виведення результату
result = find_max_length(n, m, a)
print(result)
