#include <iostream>
#include <vector>
#include <algorithm> // For max_element and sort
using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (n == 1) {
        // Your existing logic for a single wheel
        long long max_length = a[0] - 1; // First color is already marked
        long long power_of_two = 1;
        while (m > 0 && max_length > 0) {
            max_length--; // Decrement the sequence length
            max_length /= 2; // Halve the sequence length
            power_of_two *= 2; // Double the power of two
            m -= power_of_two; // Decrement m by the power of two
        }
        cout << max_length << endl;
    } else {
        // Placeholder for the logic for multiple color wheels
        // This would involve more complex logic
        cout << "Multiple color wheels logic not implemented." << endl;
    }

    return 0;
}
