def choose_colors(n, m, weights, boxes):
    left = 0
    right = n - 1
    total_weight = [0] * (n + 1)
    for i in range(1, n + 1):
        total_weight[i] = total_weight[i - 1] + weights[i - 1]

    while left < right:
        mid = (left + right) // 2
        if total_weight[mid + 1] <= total_weight[n] // 2:
            left = mid + 1
        else:
            right = mid

    if total_weight[n] - total_weight[left] <= total_weight[left]:
        return (boxes[:left], boxes[left:])
    else:
        return (boxes[:left + 1], boxes[left + 1:])

n = 4
m = 2
weights = [5, 3, 7, 2]
boxes = [1, 2, 1, 2]

result = choose_colors(n, m, weights, boxes)
print(result)