#include <iostream>
#include <vector>

using namespace std;

vector<vector<char>> generateOrnament(int n, int m) {
    vector<vector<char>> pattern(n, vector<char>(m, '.'));

    for (int i = 0; i < n; i += 2) {
        for (int j = 0; j < m; ++j) {
            pattern[i][j] = 'x';
        }
    }

    for (int i = 1; i < n; i += 4) {
        pattern[i][0] = 'x';
    }

    for (int i = 3; i < n; i += 4) {
        pattern[i][m - 1] = 'x';
    }

    return pattern;
}

void printOrnament(const vector<vector<char>>& pattern) {
    for (const auto& row : pattern) {
        for (char c : row) {
            cout << c;
        }
        cout << endl;
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<char>> ornament = generateOrnament(n, m);
    printOrnament(ornament);

    return 0;
}
