#include <iostream>
using namespace std;

void readArray(int boxes[]) {
    for (int i = 0; i < 4; i++) 
        cin >> boxes[i];
}

int switchBox(int box[], int index) {
    int result;
    if (box[index] == 1)
        result = 2;
    else
        result = 1;
    return result;
}

int TotalWeight(int weights[], int boxes[], const int length) {
    int weight1 = 0, weight2 = 0;
    for (int i = 0; i < length; i++) {
        if (boxes[i] == 1)
            weight1 += weights[i];
        else
            weight2 += weights[i];
    }
    return (weight1 > weight2) ? weight1 : weight2;
}

int main() {
    const int length = 4;
    int participantWeights[length];
    int participantBoxes[length];

    readArray(participantBoxes);

    int maxWeight, optimalBoxNumber, maxWeightOfTwoBoxes;
    bool isOptimalSet = false;

    maxWeightOfTwoBoxes = TotalWeight(participantWeights, participantBoxes, length);

    for (int i = 0, switchedBox = participantBoxes[i]; i < length; i++) {
        switchedBox = switchBox(participantBoxes, i);
        participantBoxes[i] = switchedBox;
        maxWeight = TotalWeight(participantWeights, participantBoxes, length);

        if (maxWeight < maxWeightOfTwoBoxes) {
            isOptimalSet = true;
            maxWeightOfTwoBoxes = maxWeight;
            optimalBoxNumber = i + 1;
        }
    }

    if (!isOptimalSet)
        cout << -1;
    else
        cout << optimalBoxNumber;

    return 0;
}
