#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    sort(colors.begin(), colors.end());

    vector<int> prefix_sum(n + 1);
    for (int i = 1; i <= n; ++i) {
        prefix_sum[i] = prefix_sum[i - 1] + colors[i - 1];
    }

    int answer = 0;
    for (int i = 0; i <= n; ++i) {
        int remaining_colors = m + i;
        int remaining_sum = prefix_sum[min(n, remaining_colors)] + (remaining_colors - min(n, remaining_colors)) * colors[i];
        answer = max(answer, remaining_sum);
    }

    cout << answer << endl;

    return 0;
}
