def find_max_unmarked_subarray_length(n, m, colors):
    total_colors = sum(colors)
    max_unmarked_length = min(total_colors, m)

    return max(0, total_colors - max_unmarked_length)

def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    result = find_max_unmarked_subarray_length(n, m, colors)
    print(result)

if __name__ == "__main__":
    main()
