def max_subarray_length(n, m, colors):
    total_colors = sum(colors)
    
    # Calculate the remaining colors that Miss M can choose
    remaining_colors = min(total_colors, m)
    
    # Calculate the maximum length of unmarked subarray
    max_length = total_colors - remaining_colors
    
    return max_length

# Read input values
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Calculate and print the result
result = max_subarray_length(n, m, colors)
print(result)
