def max_subsegment_length(n, m, colors):
    intervals = []
    for i in range(1, n):
        length = (colors[i] - colors[i-1] - 1)
        if length > 0:
            intervals.append(length)
    
    intervals.sort()
    total_length = n + sum(intervals[-m+1:])
    
    return total_length

n, m = map(int, input().split())
colors = list(map(int, input().split()))

print(max_subsegment_length(n, m, colors))