def max_unmarked_sequence(n, m, colors):
    max_sequence = 0

    colors.sort(reverse=True)

    for i in range(n):
        unmarked_sequence = colors[i] - 1

        max_sequence = max(max_sequence, unmarked_sequence)

    max_sequence += m

    return max_sequence

n, m = map(int, input().split())
colors = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, colors)
print(result)