def distribute_tshirts(n, m, sizes, tshirts, winners):
    remaining = [tshirts[i][:] for i in range(n)]
    order = [[0]*m for _ in range(n)]
    
    for color, size in winners:
        found = False
        for i in range(sizes.index(size), m):
            if remaining[color-1][i] > 0:
                remaining[color-1][i] -= 1
                found = True
                break
        if not found:
            order[color-1][sizes.index(size)] += 1
    
    for row in remaining:
        print(' '.join(map(str, row)))
    print()
    for row in order:
        print(' '.join(map(str, row)))

if __name__ == "__main__":
    n, m = map(int, input().split())
    sizes = input().split()
    tshirts = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    winners = [tuple(input().split()) for _ in range(k)]
    winners = [(int(color), size) for color, size in winners]
    distribute_tshirts(n, m, sizes, tshirts, winners)