process.stdin.on('data', function (data) {
    function count(n, m, a, ser) {
        let num = 0;
        for (let i = 0; i < n; i++) {
            num += Math.min(a[i], ser);
        }
        return num + Math.min(ser, m);
    }

    function maxLength(n, m, a) {
        let left = 1;
        let right = 10 ** 18 + 1;

        while (left < right) {
            let ser = Math.floor((left + right) / 2);
            if (count(n, m, a, ser) >= m + n) {
                right = ser;
            } else {
                left = ser + 1;
            }
        }

        return left - 1;
    }

    const input = readline().split(' ');
    const n = parseInt(input[0], 10);
    const m = parseInt(input[1], 10);
    const a = readline().split(' ').map(x => parseInt(x, 10));

    const res = maxLength(n, m, a);
    console.log(res);
});
