def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if i % 2 == 0 and (j == 0 or j == m - 1):
                ornament[i][j] = 'x'
            elif i % 2 == 1 and (j % 2 == 1):
                ornament[i][j] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print("".join(row))

if __name__ == "__main__":
    n, m = map(int, input().split())

    ornament = generate_ornament(n, m)
    print_ornament(ornament)
