def max_unmarked_length(n, m, a):
    total_colors = sum(a)
    if m >= total_colors:
        return n + m

    a.sort(reverse=True)  # Sort in descending order to consider longer sequences first

    low, high = 0, total_colors
    answer = 0

    while low <= high:
        mid = (low + high) // 2

        curr_m = 0
        for i in range(n):
            curr_m += max(0, a[i] - mid)

        if curr_m >= m:
            answer = mid
            low = mid + 1
        else:
            high = mid - 1

    return n + answer

# Example usage
n, m = map(int, input().split())
a = list(map(int, input().split()))
result = max_unmarked_length(n, m, a)
print(result)
