n, m = map(int, input().split())
sizes = input().split()
tshirts = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
requests = [input().split() for _ in range(k)]

# Initialize the remaining T-shirts
remaining_tshirts = [row.copy() for row in tshirts]

# Initialize the list to track the T-shirts that need to be ordered
needed_tshirts = [[0] * m for _ in range(n)]

for i in range(k):
    color, size = int(requests[i][0]) - 1, sizes.index(requests[i][1])
    
    if remaining_tshirts[color][size] > 0:
        remaining_tshirts[color][size] -= 1
    else:
        found = False

        for s in range(size + 1, m):
            if remaining_tshirts[color][s] > 0:
                remaining_tshirts[color][s] -= 1
                found = True
                break

        if not found:
            for s in range(size + 1, m):
                for c in range(n):
                    if remaining_tshirts[c][s] > 0:
                        remaining_tshirts[c][s] -= 1
                        needed_tshirts[c][s] += 1
                        found = True
                        break
                if found:
                    break

for row in remaining_tshirts:
    print(" ".join(map(str, row)))

for row in needed_tshirts:
    print(" ".join(map(str, row)))
