def max_unmarked_sequence(n, m, a):
    # Find the longest sequence among all color wheels
    longest_sequence = max(a)

    # Subtract the first marked colors on each wheel
    total_marked = sum(a) - n

    # Subtract the additional colors Miss M wants to take
    remaining_colors = m - (n - 1)

    # Calculate the maximum length of the sequence of unmarked colors
    max_length = longest_sequence - (total_marked // n)

    # If there are additional colors Miss M wants to take
    if remaining_colors > 0:
        # Add the remaining colors to the sequence
        max_length += remaining_colors

    return max_length


# Read input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the result
result = max_unmarked_sequence(n, m, a)
print(result)

