n = int(input())

participants = []

for i in range(n):
    id, gender, grade, age, score = input().split()
    id = int(id)
    grade = int(grade)
    age = int(age)
    score = int(score)
    participants.append((id, gender, grade, age, score))

m = int(input())

olympiads = []


for i in range(m):
    name = input()
    olympiads.append(name)


def sort_by_score(participant):
    return -participant[4]


def filter_by_gender(participant, gender):
    return participant[1] == gender


def filter_by_age(participant, max_age):
    return participant[3] <= max_age


def filter_by_grade(participant, excluded_grades):
    return participant[2] not in excluded_grades


criteria = {
    "IOI": (4, None, None, None),
    "CEOI": (4, None, None, None), 
    "EGOI": (4, "female", None, None), 
    "EJOI": (4, None, 15, None)
    "BaltOI": (6, None, None, None),
    "BalkOI": (4, None, None, [11]),
    "JBOI": (4, None, None, [10, 11])
}


for olympiad in olympiads:
    print(olympiad)
    limit, gender, age, grades = criteria[olympiad]
    filtered = participants
    if gender is not None:
        filtered = list(filter(lambda p: filter_by_gender(p, gender), filtered))
    if age is not None:
        filtered = list(filter(lambda p: filter_by_age(p, age), filtered))
    if grades is not None:
        filtered = list(filter(lambda p: filter_by_grade(p, grades), filtered))
    filtered.sort(key=sort_by_score)
    for i in range(min(limit, len(filtered))):
        print(filtered[i][0])
