def max_subarray_length(n, m, a):
    left, right = 0, n
    result = 0

    while left <= right:
        mid = (left + right) // 2
        cnt_odd = 0
        cnt_even = 0
        total = 0

        for length in a:
            total += length
            if length % 2 == 1:
                cnt_odd += length // 2
            else:
                cnt_even += length // 2

        if total >= mid:
            cnt_odd += total % 2

        if cnt_odd >= m + 1:
            result = max(result, mid)
            left = mid + 1
        else:
            right = mid - 1

    return result

# Зчитування вхідних даних
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Виведення відповіді
print(max_subarray_length(n, m, a))
