def move_items_to_minimize_weight(w, t):
    n = len(w)
    

    box_weights = [0, 0]
    for i in range(n):
        box_weights[t[i] - 1] += w[i]
    

    for i in range(n):
        current_box = t[i] - 1
        other_box = 1 - current_box

        new_max_weight = max(box_weights[current_box] - w[i], box_weights[other_box] + w[i])
        
      
        if new_max_weight < max(box_weights):
            return i + 1
    
    return -1 


weights = [3, 2, 5, 1]
boxes = [1, 2, 1, 2]

result = move_items_to_minimize_weight(weights, boxes)
print("Item to be moved:", result)

