#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    vector<int> w(4), t(4);
    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    int max_weight = max(w[0], w[1]) + max(w[2], w[3]);

    bool no_move_needed = true;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            if (t[i] != t[j]) {
                int diff = (t[i] == 1) ? w[i] : -w[i];
                diff += (t[j] == 1) ? w[j] : -w[j];
                if (diff < 0) {
                    no_move_needed = false;
                }
            }
        }
    }

    if (no_move_needed) {
        cout << "-1" << endl;
    } else {
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                if (t[i] != t[j]) {
                    int diff = (t[i] == 1) ? w[i] : -w[i];
                    diff += (t[j] == 1) ? w[j] : -w[j];
                    if (diff < 0 && max_weight - diff == max_weight) {
                        cout << i + 1 << endl;
                        return 0;
                    }
                }
            }
        }
    }

    return 0;
}
