#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

// Структура для зберігання даних про учасників
struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

// Функція для визначення складу команди для кожної олімпіади
vector<int> determineTeam(string olympiad, vector<Participant>& participants) {
    unordered_map<string, vector<int>> teams;

    // Логіка визначення команди для кожної олімпіади

    return teams[olympiad];
}

int main() {
    int n;
    cin >> n; // Зчитування кількості учасників
    vector<Participant> participants(n);

    // Зчитування даних про учасників
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    cin >> m; // Зчитування кількості олімпіад

    // Зчитування олімпіад та визначення складу команд для кожної олімпіади
    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;
        vector<int> team = determineTeam(olympiad, participants);
        
        cout << olympiad << endl;
        for (int participant : team) {
            cout << participant << endl;
        }
    }

    return 0;
}
