#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (n == 1) {
        cout << a[0] - 1 + m << endl;
        return 0;
    }

    sort(a.begin(), a.end());

    long long max_gap = a[0] - 1;
    for (int i = 1; i < n; ++i) {
        long long gap = a[i] - a[i - 1] - 1;
        max_gap = max(max_gap, gap);
    }

    long long result = max_gap;

    if (m != 0) {
        result = max(result, max(a[0] - 1, max_gap / 2 + (max_gap % 2)));
        result = max(result, max(a[n - 1] - a[n - 2], max_gap / 2 + (max_gap % 2)));
        result = max(result, max_gap / 2 + (max_gap % 2) + m);
    }

    cout << result << endl;

    return 0;
}
