def max_unmarked_subsegment_length(colors):
    max_length = 0
    current_length = 0

    for color in colors:
        if color == 0:
            current_length += 1
            max_length = max(max_length, current_length)
        else:
            current_length = 0

    return max_length

def main():
    n, m = map(int, input().split())
    color_counts = list(map(int, input().split()))

    max_unmarked = max_unmarked_subsegment_length(color_counts)

    remaining_colors = m
    while remaining_colors > 0:
        if max_unmarked % 2 == 0:
            max_unmarked //= 2
        else:
            max_unmarked //= 2
            max_unmarked += 1
        remaining_colors -= 1

    print(max_unmarked)

if __name__ == "__main__":
    main()