#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> w(4), t(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> w[i];
    }
    for (int i = 0; i < 4; ++i) {
        std::cin >> t[i];
    }

    int weight_box1 = 0, weight_box2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (t[i] == 1) {
            weight_box1 += w[i];
        } else {
            weight_box2 += w[i];
        }
    }
    
if (weight_box1 == weight_box2) {
        std::cout << "-1\n";
    } else {
        int item_to_move = -1;
        for (int i = 0; i < 4; ++i) {
            if (t[i] == 1 && weight_box1 - w[i] == weight_box2) {
                item_to_move = i + 1;
                break;
            } else if (t[i] == 2 && weight_box2 - w[i] == weight_box1) {
                item_to_move = i + 1;
                break;
            }
        }

        std::cout << item_to_move << "\n";
    }

    return 0;
}