def process_gifts(n, m, sizes, stocks, k, requests):
    stock_dict = {}
    present_dict = {}

    for i in range(n):
        stock_dict[i] = {}
        present_dict[i] = {}
        for j in range(m):
            stock_dict[i][sizes[j]] = stocks[i][j]
            present_dict[i][sizes[j]] = 0

    for i in range(k):
        color_idx, size = requests[i]
        size_idx = sizes.index(size)
        found = False

        if stock_dict[color_idx][size] > 0:
            stock_dict[color_idx][size] -= 1
            present_dict[color_idx][size] += 1
            found = True

        if not found:
            for j in range(n):
                if stock_dict[j][size] > 0:
                    stock_dict[j][size] -= 1
                    present_dict[j][size] += 1
                    found = True
                    break

        if not found:
            for j in range(size_idx + 1, m):
                for l in range(n):
                    if stock_dict[l][sizes[j]] > 0:
                        stock_dict[l][sizes[j]] -= 1
                        present_dict[l][sizes[j]] += 1
                        found = True
                        break
                if found:
                    break

        if not found:
            present_dict[color_idx][size] += 1

    for i in range(n):
        stock_left = [stock_dict[i][sizes[j]] for j in range(m)]
        present_needed = [0 if present_dict[i][sizes[j]] == 0 else present_dict[i][sizes[j]] for j in range(m)]
        print(*stock_left)
        print(*present_needed)

n, m = map(int, input().split())
sizes = input().split()
stocks = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [input().split() for _ in range(k)]

process_gifts(n, m, sizes, stocks, k, requests)
