def select_participants(olympiads, participants):
    for olympiad in olympiads:
        eligible_participants = []

        if olympiad == "IOI" or olympiad == "CEOI":
            eligible_participants = sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == "EGOI":
            eligible_participants = sorted([p for p in participants if p['gender'] == 'female'], key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == "EJOI":
            eligible_participants = sorted([p for p in participants if p['age'] <= 15], key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == "BaltOI":
            eligible_participants = sorted(participants, key=lambda x: x['score'], reverse=True)[:6]
        elif olympiad == "BalkOI":
            eligible_participants = sorted([p for p in participants if p['grade'] != 11], key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == "JBOI":
            eligible_participants = sorted([p for p in participants if p['grade'] != 11 and p['grade'] != 10], key=lambda x: x['score'], reverse=True)[:4]

        print(olympiad)
        for participant in sorted(eligible_participants, key=lambda x: x['id']):
            print(participant['id'])

# Приклад вхідних даних
n = 6
participants = [
    {'id': 1000000, 'gender': 'male', 'grade': 10, 'age': 16, 'score': 87},
    {'id': 1000001, 'gender': 'female', 'grade': 11, 'age': 18, 'score': 92},
    {'id': 1000002, 'gender': 'female', 'grade': 9, 'age': 15, 'score': 80},
    {'id': 1000003, 'gender': 'male', 'grade': 11, 'age': 17, 'score': 90},
    {'id': 1000004, 'gender': 'male', 'grade': 10, 'age': 16, 'score': 85},
    {'id': 1000005, 'gender': 'female', 'grade': 10, 'age': 15, 'score': 88}
]

m = 4
olympiads = ['EGOI', 'IOI', 'BalkOI', 'JBOI']

select_participants(olympiads, participants)
