#include <bits/stdc++.h>
#include <algorithm>
#include <array>

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    
    // Read input data
    std::array<int, 4> weights, indices;
    for (int& elem : weights) { std::cin >> elem; }
    for (int& elem : indices) { std::cin >> elem; }

    // Current maximum box weight
    int curMax = 0;
    {
        int w1 = 0, w2 = 0;
        for (int i = 0; i < indices.size(); ++i)
            indices[i] == 1 ? w1 += weights[i] : w2 += weights[i];
        curMax = std::max(w1, w2);
    }

    // Next maximum box weight, index of changed element
    int nextMax = 0, changedInd = 0;
    {
        int w1_ind = 0, w1_box = 0;
        for (int i = 1; i < indices.size(); ++i) {
            if (weights[w1_ind] < weights[i]) {
                w1_ind = i;
                w1_box = indices[i];
            }
        }
        for (int i = 0; i < indices.size(); ++i) {
            if (indices[i] == indices[w1_ind] && i != w1_ind) {
                changedInd = i;
            }
        }
        
        int w2 = 0;
        for (int i = 0; i < indices.size(); ++i) {
            if (i != w1_ind) { w2 += weights[i]; }
        }
        
        nextMax = std::max(weights[w1_ind], w2);
    }
    
    if (curMax <= nextMax) {
        std::cout << -1 << std::endl;
    } else {
        std::cout << changedInd + 1 << std::endl;
    }
}
