#include <bits/stdc++.h>
#include <algorithm>
#include <array>

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    
    // Read input data
    std::array<int, 4> w, t;
    for (int& elem : w) { std::cin >> elem; }
    for (int& elem : t) { std::cin >> elem; }

    std::array<int, 2> weights1 = {0, 0};
    for (int i = 0; i < 4; ++i) {
        weights1[t[i] - 1] += w[i];
    }

    std::array<int, 2> weights2;
    {
        int maxElem = *std::max_element(w.begin(), w.end());
        int maxInd = std::distance(w.begin(), std::find(w.begin(), w.end(), maxElem));
        std::array<int, 3> t;
        for (int i = 0; i < 3; ++i) { t[i] = w[i < maxInd ? i : i + 1]; }

        weights2[0] = w[maxInd];
        weights2[1] = t[0] + t[1] + t[2];

    }

    int max1 = *std::max_element(weights1.begin(), weights1.end());
    int max2 = *std::max_element(weights2.begin(), weights2.end());

    if (max1 < max2) {
        std::cout << -1;
    } else {
        std::cout << 1;
    }
}
