#include <bits/stdc++.h>
#include <algorithm>
#include <array>

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    
    // Read input data
    std::array<int, 4> w, t;
    for (int& elem : w) { std::cin >> elem; }
    for (int& elem : t) { std::cin >> elem; }

    std::array<int, 2> weights1 = {0, 0};
    for (int i = 0; i < 4; ++i) {
        weights1[t[i] - 1] += w[i];
    }

    std::array<int, 4> weights2 = {
        std::max(w[0], w[1] + w[2] + w[3]),
        std::max(w[1], w[0] + w[2] + w[3]),
        std::max(w[2], w[0] + w[1] + w[3]),
        std::max(w[3], w[0] + w[1] + w[2]),
    };
    
    int max1 = *std::max_element(weights1.begin(), weights1.end());
    int max2 = *std::min_element(weights2.begin(), weights2.end());

    if (max1 <= max2) {
        std::cout << -1;
    } else {
        int ind = std::distance(weights2.begin(), std::find(weights2.begin(), weights2.end(), max2));
        // std::cout << t << std::endl;
        for (int i = 0; i < 4; ++i) {
            if (t[i] == t[ind]) {
                if (i != ind) {
                    std::cout << i + 1;
                }
            }
        }
    }
}
