def create_ornament(n, m):
    # Initialize the ornament matrix with spaces
    ornament = [[' ' for _ in range(m)] for _ in range(n)]

    # Fill in the upper-left corner of the ornament
    ornament[0][1] = 'x'
    ornament[1][0] = 'x'
    ornament[1][1] = '.'

    # Fill in the upper-right corner of the ornament
    ornament[0][m - 2] = 'x'
    ornament[1][m - 1] = 'x'
    ornament[1][m - 2] = '.'

    # Fill in the lower part of the ornament
    for i in range(2, n):
        ornament[i][1] = 'x'
        ornament[i][m - 2] = 'x'

    # Print the ornament
    for row in ornament:
        print(''.join(row))

# Read input
n, m = map(int, input().split())

# Output the ornament
create_ornament(n, m)
