n, m = map(int, input().split())
wheels = list(map(int, input().split()))

def count_unmarked(lengths):
    lengths.sort(reverse=True)
    total = 0
    for length in lengths:
        if length % 2 == 1:
            total += length // 2 + 1
        else:
            total += length // 2
    return total

unmarked = count_unmarked(wheels)
remaining = m

while remaining > 0:
    lengths = [x for x in wheels if x > 1]
    if not lengths:
        break
    unmarked += count_unmarked(lengths)
    for i in range(len(wheels)):
        if wheels[i] > 1:
            if wheels[i] % 2 == 1:
                wheels[i] = wheels[i] // 2 + 1
            else:
                wheels[i] = wheels[i] // 2
            remaining -= 1
            if remaining == 0:
                break

result = unmarked + remaining * n
print(result)
