n, m = map(int, input().split())
wheels = list(map(int, input().split()))

max_length = max(wheels)
total_length = sum(wheels)

# Binary search to find the number of iterations needed
left, right = max_length, total_length + m
while left < right:
    mid = (left + right) // 2
    count = sum((wheel + 1) // 2 for wheel in wheels if wheel >= mid)
    if count >= m:
        right = mid
    else:
        left = mid + 1

print(left)
