def max_unmarked_sequence_length(n, m, color_wheels):
    max_sequence_length = 0
    unmarked_colors = sum(color_wheels) - n

    while m > 0:
        max_seq = max(color_wheels)
        max_index = color_wheels.index(max_seq)
        color_wheels[max_index] -= 1

        if max_seq % 2 == 0:
            m -= 1
            max_seq //= 2
            color_wheels.insert(max_index, max_seq)
            color_wheels.insert(max_index, max_seq)
        else:
            m -= 1
            color_wheels.insert(max_index, max_seq // 2)
            color_wheels.insert(max_index, max_seq // 2)
        
        if max_seq > max_sequence_length:
            max_sequence_length = max_seq
        
        unmarked_colors -= 1
    
    return max_sequence_length

# Reading input
n, m = map(int, input().split())
color_wheels = list(map(int, input().split()))

result = max_unmarked_sequence_length(n, m, color_wheels)
print(result)
