#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>

using namespace std;

int n, m, k, current_i, current_j;
int stock[101][7], need[101][7];
unordered_map<string, int> sizes;
vector<pair<int, string>> wish_list;

int c;
string s;

bool searching, completed;

int main() {
    cin >> n >> m;
    for (int i = 1; i <= m; i++) { cin >> s; sizes[s] = i; }
    for (int i = 1; i <= n; i++) for (int j = 1; j <= m; j++) cin >> stock[i][j];
    cin >> k;
    for (int i = 1; i <= k; i++) { cin >> c >> s; wish_list.push_back({ c, s }); }

    for (auto i : wish_list) {
        completed = false;
        searching = true;
        current_i = i.first;
        current_j = sizes[i.second];
        while (stock[current_i][current_j] == 0 && searching)
        {
            for (int j = 1; j <= n; j++) {
                if (stock[j][current_j] > 0) {
                    stock[j][current_j]--;
                    searching = false;
                    completed = true;
                    break;
                }
            }
            if (searching) {
                if (current_i != m) current_i++;
                else { need[i.first][sizes[i.second]+1]++; completed = true; searching = false; }
            }
        }

        if (!completed) stock[current_i][current_j]--;
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++)
            cout << stock[i][j] << ' ';
        cout << endl;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++)
            cout << need[i][j] << ' ';
        cout << endl;
    }

    return 0;
}