import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class OlympiadParticipants {

    public static void main(String[] args) {
        List<Integer> egoiParticipants = Arrays.asList(1000001, 1000005, 1000006);
        List<Integer> ioiParticipants = Arrays.asList(1000002, 1000003, 1000005, 1000006, 1000007, 1000010);

        System.out.println("EGOI Participants: " + egoiParticipants);
        System.out.println("IOI Participants: " + ioiParticipants);

        List<Integer> baltOiParticipants = egoiParticipants.stream()
                .filter(participant -> !ioiParticipants.contains(participant))
                .collect(Collectors.toList());

        System.out.println("BaltOI Participants: " + baltOiParticipants);
    }
}