def move_items(weights, boxes):
    total_weight_box1 = sum(weights[i] for i in range(4) if boxes[i] == 1)
    total_weight_box2 = sum(weights[i] for i in range(4) if boxes[i] == 2)

    for i in range(4):
        if boxes[i] == 1:
            new_weight_box1 = total_weight_box1 - weights[i]
            new_weight_box2 = total_weight_box2 + weights[i]
        else:
            new_weight_box1 = total_weight_box1 + weights[i]
            new_weight_box2 = total_weight_box2 - weights[i]

        if max(new_weight_box1, new_weight_box2) < max(total_weight_box1, total_weight_box2):
            return i + 1

    return -1


weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))


result = move_items(weights, boxes)
print(result)

