def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m) // 2):
        ornament[i][i] = ornament[i][m - 1 - i] = 'x'
        ornament[n - 1 - i][i] = ornament[n - 1 - i][m - 1 - i] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Input
n, m = map(int, input().split())

# Output
ornament = generate_ornament(n, m)
print_ornament(ornament)



