# Зчитуємо вхідні дані
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Ініціалізуємо максимальну вагу коробок
max_weights = [0, 0]

# Обчислюємо початкову максимальну вагу коробок
for i in range(4):
    max_weights[boxes[i] - 1] += weights[i]

# Ініціалізуємо змінні для збереження оптимального варіанту
best_i, best_j = -1, -1

# Перебираємо всі можливі переміщення
for i in range(4):
    for j in range(4):
        if i != j:
            # Обчислюємо нові ваги коробок після переміщення
            new_weights = max_weights.copy()
            new_weights[boxes[i] - 1] += weights[i]
            new_weights[boxes[j] - 1] -= weights[i]
            
            # Знаходимо максимальну вагу після переміщення
            max_weight = max(new_weights)
            
            # Перевіряємо, чи це оптимальне переміщення
            if max_weight < min(max_weights):
                best_i, best_j = i, j

# Виводимо результат
if best_i == -1:
    print(-1)
else:
    print(best_i + 1)

