def create_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        pattern[i][0] = '*'
        pattern[i][m - 1] = '*'
        pattern[0][i] = '*'
        pattern[n - 1][i] = '*'

    return pattern

def print_pattern(pattern):
    for row in pattern:
        print(''.join(row))

if __name__ == "__main__":
    n, m = map(int, input().split())
    
    if n < 3 or m < 3:
        print("Невірні розміри вишиванки.")
    else:
        ornament = create_pattern(n, m)
        print_pattern(ornament)
