const
  MAX_COLORS = 100;
  MAX_SIZES = 6;

var
  colors, sizes: array[1..MAX_COLORS, 1..MAX_SIZES] of integer;
  available, needed: array[1..MAX_COLORS, 1..MAX_SIZES] of integer;
  n, m, i, j, k, c, winners, currentColor, currentSize: integer;
  sizeIndex: array['XS'..'2XL'] of integer;
  color, size: string;

begin
  sizeIndex['XS'] := 1;
  sizeIndex['S'] := 2;
  sizeIndex['M'] := 3;
  sizeIndex['L'] := 4;
  sizeIndex['XL'] := 5;
  sizeIndex['2XL'] := 6;

  readln(n, m);
  
  for i := 1 to m do
    read(sizes[1, i]);
  
  for i := 1 to n do
    for j := 1 to m do
      read(colors[i, j]);
  
  readln(winners);
  
  for i := 1 to winners do
  begin
    readln(c, size);
    currentSize := sizeIndex[size];
    currentColor := colors[c, currentSize];
    
    if currentColor > 0 then
    begin
      available[c, currentSize] := available[c, currentSize] + 1;
      colors[c, currentSize] := colors[c, currentSize] - 1;
    end
    else
    begin
      for j := currentSize + 1 to m do
      begin
        if colors[c, j] > 0 then
        begin
          available[c, j] := available[c, j] + 1;
          colors[c, j] := colors[c, j] - 1;
          break;
        end;
      end;
      
      if available[c, currentSize] = 0 then
        needed[c, currentSize] := needed[c, currentSize] + 1;
    end;
  end;
  
  for i := 1 to n do
  begin
    for j := 1 to m do
      write(available[i, j], ' ');
    writeln;
  end;
  
  for i := 1 to n do
  begin
    for j := 1 to m do
      write(needed[i, j], ' ');
    writeln;
  end;
end.