def find_optimal_move(weights, boxes):
    box_weights = [0, 0]
    for i in range(4):
        box_weights[boxes[i] - 1] += weights[i]

    for i in range(4):
        other_box = 1 - (boxes[i] - 1)
        other_weight = box_weights[other_box] - weights[i]

        if other_weight <= max(box_weights) - weights[i]:
            return i + 1

    return -1

weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

result = find_optimal_move(weights, boxes)
print(result)
