def optimal_item_to_move(weights, boxes):
    total_weight = [0, 0]

    for i in range(4):
        total_weight[boxes[i] - 1] += weights[i]

    max_weight = max(total_weight)

    for i in range(4):
        if total_weight[boxes[i] - 1] == max_weight and weights[i] <= max_weight - weights[i]:
            return i + 1

    return -1

if __name__ == "__main__":
    weights = list(map(int, input().split()))
    boxes = list(map(int, input().split()))

    result = optimal_item_to_move(weights, boxes)
    print(result)
