def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][0] = ornament[0][i] = '*'

    for i in range(1, min(n, m)):
        ornament[i][i] = '*'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(' '.join(row))

n, m = map(int, input().split())
ornament = generate_ornament(n, m)
print_ornament(ornament)
