def max_unmarked_sequence_length(n, m, lengths):
    lengths.sort(reverse=True)
    unmarked_count = 0
    result = 0

    for length in lengths:
        if unmarked_count >= m:
            break

        if length % 2 == 1:
            result += length // 2 + 1
        else:
            result += length // 2

        unmarked_count += length - 1

    return result

n, m = map(int, input().split())
lengths = list(map(int, input().split()))
print(max_unmarked_sequence_length(n, m, lengths))
