def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    ornament[0][0] = 'x'
    ornament[0][-1] = 'x'
    ornament[-1][0] = 'x'
    ornament[-1][-1] = 'x'

    for i in range(1, min(n, m - 1)):
        ornament[i][i] = 'x'

    for i in range(1, min(n, m - 1)):
        ornament[i][-i - 1] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print("".join(row))

def main():
    n, m = map(int, input().split())

    ornament = generate_ornament(n, m)
    print_ornament(ornament)

if __name__ == "__main__":
    main()
