def check(mid, wheels):
    total = 0
    for wheel in wheels:
        total += min(wheel, mid) 
    return total

def main():
    n, m = map(int, input().split())
    wheels = list(map(int, input().split()))

    left, right = 1, 10**18 + 1

    while left < right:
        mid = (left + right) // 2
        if check(mid, wheels) >= m:
            right = mid
        else:
            left = mid + 1

    print(left - 1)

if __name__ == "__main__":
    main()
