def max_unmarked_sequence(n, m, a):
    total_colors = sum(a)
    max_sequence = max(a)

    if m >= total_colors:
        return total_colors

    left, right = 1, max_sequence

    while left < right:
        mid = (left + right) // 2

        required_colors = sum(min(mid, wheel) for wheel in a)

        if required_colors < m:
            left = mid + 1
        else:
            right = mid

    return left + total_colors - max_sequence


n, m = map(int, input().split())
a = list(map(int, input().split()))

print(max_unmarked_sequence(n, m, a))
