def main():
    # Введення кількості різних кольорів та розмірів футболок
    n, m = map(int, input().split())

    # Введення розмірів футболок
    sizes = input().split()

    # Введення кількості футболок кожного кольору та розміру
    available = [list(map(int, input().split())) for _ in range(n)]

    # Введення кількості переможців
    k = int(input())

    # Ініціалізація змінних для збереження кількості залишених та потрібних футболок
    left = [[0] * m for _ in range(n)]
    needed = [[0] * m for _ in range(n)]

    # Обробка запитів переможців
    for _ in range(k):
        # Введення номеру кольору та розміру потрібної футболки
        color, size = input().split()
        color = int(color)

        # Пошук футболки за алгоритмом Міс M
        found = False
        for j in range(m):
            if sizes[j][0] == size:
                if available[color - 1][j] > 0:
                    available[color - 1][j] -= 1
                    left[color - 1][j] += 1
                    found = True
                    break

        if not found:
            for j in range(m):
                if available[color - 1][j] > 0:
                    available[color - 1][j] -= 1
                    left[color - 1][j] += 1
                    break

    # Виведення кількості залишених футболок
    for i in range(n):
        print(" ".join(map(str, left[i])))

    # Виведення кількості потрібних докупити футболок
    for i in range(n):
        needed[i] = [max(0, needed[i][j] - left[i][j]) for j in range(m)]
        print(" ".join(map(str, needed[i])))


if __name__ == "__main__":
    main()