#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sort(a.begin(), a.end(), greater<long long>());

    long long max_length = 0;
    long long remaining_colors = m;

    for (int i = 0; i < n; ++i) {
        long long current_length = a[i] - 1;
        long long available_colors = min(remaining_colors, current_length);
        remaining_colors -= available_colors;
        current_length -= available_colors;

        if (current_length % 2 == 1) {
            max_length = max(max_length, current_length / 2 + 1);
        } else {
            max_length = max(max_length, current_length / 2);
        }

        if (remaining_colors == 0) {
            break;
        }
    }

    cout << max_length + m << endl;

    return 0;
}