def max_unmarked_subsegment_length(n, m, a):
    total_colors = sum(a)
    remaining_colors = total_colors - m

    if remaining_colors <= 0:
        return total_colors

    max_length = 0

    for i in range(n):
        length = 1
        for j in range(i + 1, n):
            length += a[j]
            if length % 2 == 0:
                max_length = max(max_length, length // 2)
            else:
                max_length = max(max_length, length // 2 + 1)

    return max_length

# Зчитування вхідних даних
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Виведення результату
result = max_unmarked_subsegment_length(n, m, a)
print(result)