def find_item_to_move(weights, boxes):
    total_weight = [0, 0]  # total_weight[0] represents the weight of items in box 1, and total_weight[1] represents the weight of items in box 2

    for i in range(4):
        total_weight[boxes[i] - 1] += weights[i]

    for i in range(4):
        candidate_weight = total_weight[1 - (boxes[i] - 1)] + weights[i]
        if candidate_weight <= max(total_weight[boxes[i] - 1], weights[i]):
            return i + 1

    return -1

# Read input
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Find and print the item to move
result = find_item_to_move(weights, boxes)
print(result)
