#include <iostream>
#include <vector>

int main() {
    // Input
    std::vector<int> w(4);
    std::vector<int> t(4);

    for (int i = 0; i < 4; ++i) {
        std::cin >> w[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> t[i];
    }

    // Calculate the sum of weights in each box
    int sum_box1 = 0, sum_box2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (t[i] == 1) {
            sum_box1 += w[i];
        } else {
            sum_box2 += w[i];
        }
    }

    // Find the item to be moved
    for (int i = 0; i < 4; ++i) {
        if (t[i] == 1 && (sum_box1 - w[i] + w[i]) != sum_box2) {
            std::cout << i + 1 << std::endl;
            return 0;
        } else if (t[i] == 2 && (sum_box2 - w[i] + w[i]) != sum_box1) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // If no change is needed
    std::cout << "-1" << std::endl;

    return 0;
}
