#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    pair<int, pair<int, int>> participants[n];  // Інформація про учасників: <id, <score, index>>

    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        string gender;
        cin >> id >> gender >> grade >> age >> score;
        participants[i] = {id, {score, i}};
    }

    sort(participants, participants + n, greater<pair<int, pair<int, int>>>());  // Сортування за спаданням балів

    int m;
    cin >> m;

    while (m--) {
        string olympiad;
        cin >> olympiad;

        int teamSize;
        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            teamSize = min(6, n);
        } else if (olympiad == "EGOI") {
            teamSize = min(4, n);
        } else if (olympiad == "EJOI") {
            teamSize = min(4, n);
        } else if (olympiad == "BalkOI" || olympiad == "JBOI") {
            teamSize = min(4, n);
        }

        cout << olympiad << "\n";

        for (int i = 0; i < teamSize; ++i) {
            cout << participants[i].first << "\n";
        }
    }

    return 0;
}
