#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>  // Додавання цього включення

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    if (m >= n) {
        // Якщо m більше або рівне n, то ми можемо вибрати всі кольори,
        // тому максимальна довжина підвідрізку - це сума всіх кольорів.
        cout << accumulate(colors.begin(), colors.end(), 0) << endl;
    } else {
        // Сортуємо кольори, щоб вибрати найбільші.
        sort(colors.begin(), colors.end(), greater<int>());

        // Обчислюємо максимальну довжину підвідрізку.
        int maxSegmentLength = colors[0] - 1;
        for (int i = 1; i < m; ++i) {
            maxSegmentLength += colors[i];
        }

        cout << maxSegmentLength << endl;
    }

    return 0;
}
