#include <iostream>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    int* colors = new int[n];
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    if (m >= n) {
        // Якщо m більше або рівне n, то ми можемо вибрати всі кольори,
        // тому максимальна довжина підвідрізку - це сума всіх кольорів.
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            sum += colors[i];
        }
        cout << sum << endl;
    } else {
        // Сортуємо кольори, щоб вибрати найбільші.
        for (int i = 0; i < n - 1; ++i) {
            for (int j = 0; j < n - i - 1; ++j) {
                if (colors[j] < colors[j + 1]) {
                    swap(colors[j], colors[j + 1]);
                }
            }
        }

        // Обчислюємо максимальну довжину підвідрізку.
        int maxSegmentLength = colors[0] - 1;
        for (int i = 1; i < m; ++i) {
            maxSegmentLength += colors[i];
        }

        cout << maxSegmentLength << endl;
    }

    delete[] colors;
    return 0;
}
