#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <vector>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using namespace std;
#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl '\n'
#define eps 1e-4

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("peacefulsets.in", "r", stdin);
  // freopen("peacefulsets.out", "w", stdout);
  ll n, m, x;
  ll t, a, b, c, d, e, f, o, k, mn, mx, l, r, mid;
  bool bl, bl2;
  char ch, ch2;
  string str, str2, str3;
  cin >> n >> m;
  vector<ll> arr[n];
  for (ll i = 0; i < n; i++) {
    cin >> a;
    arr[i].push_back(a);
  }
  ll max_segment_start, max_segment_end, max_segment_circle, max_segment_len,
      current_segment_len;
  while (m--) {
    max_segment_circle = 0;
    max_segment_len = 0;
    for (ll i = 0; i < n; i++) {
      current_segment_len = arr[i][arr[i].size() - 1];
      if (current_segment_len > max_segment_len) {
        max_segment_len = current_segment_len;
        max_segment_circle = i;
      }
    }
    ll first_segment = (max_segment_len - 1) / 2;
    ll second_segment = ceil((max_segment_len - 1) / 2.0);
    arr[max_segment_circle].erase(arr[max_segment_circle].end() - 1);
    ll position_to_insert =
        lower_bound(all(arr[max_segment_circle]), second_segment) -
        arr[max_segment_circle].begin();
    arr[max_segment_circle].insert(
        arr[max_segment_circle].begin() + position_to_insert, second_segment);
    arr[max_segment_circle].insert(
        arr[max_segment_circle].begin() + position_to_insert, first_segment);
  }
  cout << max_segment_len;
}
