#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <vector>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using namespace std;
#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl '\n'
#define eps 1e-4

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("peacefulsets.in", "r", stdin);
  // freopen("peacefulsets.out", "w", stdout);
  ll n, m, x;
  ll t, a, b, c, d, e, f, o, k, mn, mx, l, r, mid;
  lf division_result;
  bool bl, bl2;
  char ch, ch2;
  string str, str2, str3;
  cin >> n >> m;
  vector<pair<ll, ll>> arr[n];
  for (ll i = 0; i < n; i++) {
    cin >> a;
    arr[i].push_back({a, 1});
  }
  ll max_segment_start, max_segment_end, max_segment_circle, max_segment_len,
      current_segment_len;
  while (m--) {
    max_segment_circle = 0;
    max_segment_len = 0;
    for (ll i = 0; i < n; i++) {
      current_segment_len = arr[i][arr[i].size() - 1].first;
      if (current_segment_len > max_segment_len) {
        max_segment_len = current_segment_len;
        max_segment_circle = i;
      }
    }
    division_result = (max_segment_len - 1) / 2.0;
    ll first_segment = division_result;
    ll second_segment = ceil(division_result);
    ll vec_size = arr[max_segment_circle].size();
    if (arr[max_segment_circle][vec_size - 1].second == 1)
      arr[max_segment_circle].erase(arr[max_segment_circle].end() - 1);
    else
      arr[max_segment_circle][vec_size - 1].second--;
    ll position_to_insert = lower_bound(all(arr[max_segment_circle]),
                                        pair<ll, ll>{second_segment, 1}) -
                            arr[max_segment_circle].begin();
    if (arr[max_segment_circle][position_to_insert].first == second_segment) {
      arr[max_segment_circle][position_to_insert].second++;
    } else {
      arr[max_segment_circle].insert(arr[max_segment_circle].begin() +
                                         position_to_insert,
                                     {second_segment, 1});
    }
    if (position_to_insert > 0 &&
        arr[max_segment_circle][position_to_insert - 1].first ==
            first_segment) {
      arr[max_segment_circle][position_to_insert - 1].second++;
    } else {
      arr[max_segment_circle].insert(arr[max_segment_circle].begin() +
                                         position_to_insert,
                                     {first_segment, 1});
    }
  }
  cout << max_segment_len;
}
