weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

box_weights = [0, 0]
for weight, box in zip(weights, boxes):
    box_weights[box - 1] += weight

max_box_weight = max(box_weights)

item_to_move = -1
for i, (weight, box) in enumerate(zip(weights, boxes), start=1):
    new_weight = box_weights[box - 1] - weight
    if new_weight < max_box_weight:
        item_to_move = i
        break

print(item_to_move)
