def max_weight_after_move(weights, box_numbers, item_index, target_box):
    box1_weight = sum(w for w, t in zip(weights, box_numbers) if t == target_box)
    box2_weight = sum(w for w, t in zip(weights, box_numbers) if t != target_box)

    # Move the item to the target box
    box1_weight += weights[item_index]
    box2_weight -= weights[item_index]

    return max(box1_weight, box2_weight)



weights = list(map(int, input().split()))
box_numbers = list(map(int, input().split()))

min_max_weight = float('inf')
move_item_index = -1


for i in range(4):
    for target_box in range(1, 3):
        new_max_weight = max_weight_after_move(weights, box_numbers, i, target_box)

       
        if new_max_weight < min_max_weight:
            min_max_weight = new_max_weight
            move_item_index = i + 1  


if min_max_weight < max(sum(weights) // 2, max(weights)):
    print(move_item_index)
else:
    print(-1)