n, m = map(int, input().split())
a = list(map(int, input().split()))

if m == 0:
    print(0)
    exit()

prefix_sum = [0] * (n + 1)
for i in range(n):
    prefix_sum[i + 1] = prefix_sum[i] + a[i]

answer = 0

for i in range(1, n + 1):
    for j in range(i, n + 1):
        left = prefix_sum[i - 1]
        right = prefix_sum[n] - prefix_sum[j]
        length = j - i + 1

        if left + right < m:
            continue

        if (left + right - m) % 2 == 1:
            length -= 1

        answer = max(answer, length)

print(answer)
