def find_max_unmarked_subarray(colors):
    n = len(colors)
    max_length = 0
    current_length = 0

    for color in colors:
        if color == 0:
            current_length += 1
        else:
            max_length = max(max_length, current_length)
            current_length = 0

    # Check the length of the last unmarked subarray
    max_length = max(max_length, current_length)
    return max_length

def choose_colors(n, m, initial_colors):
    remaining_colors = n - m  # Number of unmarked colors to choose (m+1)-th color
    max_unmarked_subarray = find_max_unmarked_subarray(initial_colors)

    print("Max length of unmarked subarray:", max_unmarked_subarray)

    print("Colors to choose:")
    
    for _ in range(m):
        selected_color_index = initial_colors.index(0)
        print("Selected color:", selected_color_index + 1)
        
        initial_colors[selected_color_index] = 1  # Mark the selected color
        remaining_colors -= 1

        if remaining_colors > 0:
            max_unmarked_subarray = find_max_unmarked_subarray(initial_colors)
            print("Max length of unmarked subarray:", max_unmarked_subarray)
            print("Colors to choose:")