def count_possible_colors(colors, gap):
    count = 0
    for i in range(1, len(colors)):
        count += max(0, (colors[i] - colors[i - 1] - 1 - gap + 1) // 2)
    return count

n, m = map(int, input().split())
colors = list(map(int, input().split()))

left = 0
right = 10**18
result = 0

while left <= right:
    mid = (left + right) // 2
    if count_possible_colors(colors, mid) <= m:
        result = mid
        right = mid - 1
    else:
        left = mid + 1

print(result)
