def create_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    if m % 2 == 0:
        for i in range(n):
            row = ['x'] * 2 + ['.' if j % 2 == 0 else 'x' for j in range(2, m)]
            pattern[i] = row
    else:
        for i in range(n):
            row = ['x'] * 2 + ['.' if j % 2 != 0 else 'x' for j in range(2, m)]
            pattern[i] = row if i % 2 == 0 else row[::-1]

    for row in pattern:
        print(''.join(row))

n, m = map(int, input().split())
create_pattern(n, m)