n, m = map(int, input().split())
sizes = input().split()

initial_counts = []
for _ in range(n):
    counts = list(map(int, input().split()))
    initial_counts.append(counts)

num_winners = int(input())

leftover_counts = [[0 for _ in range(m)] for _ in range(n)]
needed_counts = [[0 for _ in range(m)] for _ in range(n)]

for _ in range(num_winners):
    color, size = input().split()
    size_index = sizes.index(size)

    found = False
    for i in range(n):
        if initial_counts[i][size_index] > 0:
            initial_counts[i][size_index] -= 1
            leftover_counts[i][size_index] += 1
            found = True
            break

    if not found:
        for i in range(n):
            if initial_counts[i][(size_index + 1) % m] > 0:
                initial_counts[i][(size_index + 1) % m] -= 1
                leftover_counts[i][(size_index + 1) % m] += 1
                break

for i in range(n):
    for j in range(m):
        while initial_counts[i][j] > 0:
            needed_counts[i][j] += 1
            initial_counts[i][j] -= 1

for row in leftover_counts:
    print(' '.join(map(str, row)))

for row in needed_counts:
    print(' '.join(map(str, row)))